/* MainView.c generated by valac 0.56.2, the Vala compiler
 * generated from MainView.vala, do not modify */

/*
 * Copyright (c) 2015-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include "networking.h"
#include <NetworkManager.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <glib/gi18n-lib.h>

enum  {
	NETWORK_MAIN_VIEW_0_PROPERTY,
	NETWORK_MAIN_VIEW_STATE_PROPERTY,
	NETWORK_MAIN_VIEW_NUM_PROPERTIES
};
static GParamSpec* network_main_view_properties[NETWORK_MAIN_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
typedef struct _Block2Data Block2Data;

struct _NetworkMainViewPrivate {
	NMDeviceState _state;
	NMDevice* current_device;
	GtkStack* content;
	NetworkWidgetsPage* page;
	NetworkWidgetsDeviceList* device_list;
};

struct _Block2Data {
	int _ref_count_;
	NetworkMainView* self;
	GraniteWidgetsAlertView* no_devices;
	GtkScrolledWindow* scrolled_window;
};

static gint NetworkMainView_private_offset;
static gpointer network_main_view_parent_class = NULL;

static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void network_main_view_device_removed_cb (NetworkMainView* self,
                                          NMDevice* device);
static void network_main_view_remove_interface (NetworkMainView* self,
                                         NetworkWidgetsPage* widget_interface);
static void network_main_view_update_interfaces_names (NetworkMainView* self);
static gint* _int_dup (gint* self);
static void network_main_view_connection_added_cb (NetworkMainView* self,
                                            GObject* obj);
static void network_main_view_add_connection (NetworkMainView* self,
                                       NMRemoteConnection* connection);
static void network_main_view_connection_removed_cb (NetworkMainView* self,
                                              GObject* obj);
static void network_main_view_remove_connection (NetworkMainView* self,
                                          NMRemoteConnection* connection);
static void network_main_view_device_added_cb (NetworkMainView* self,
                                        NMDevice* device);
static void network_main_view_add_interface (NetworkMainView* self,
                                      NetworkWidgetsPage* widget_interface);
static void network_main_view_update_state (NetworkMainView* self);
static void _network_main_view_update_state_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self);
static void network_main_view_update_all (NetworkMainView* self);
static void network_main_view_set_state (NetworkMainView* self,
                                  NMDeviceState value);
static void network_main_view_update_networking_state (NetworkMainView* self);
static void network_main_view_select_first (NetworkMainView* self);
static GObject * network_main_view_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void _network_main_view___lambda48_ (NetworkMainView* self,
                                     GtkListBoxRow* row);
static void __network_main_view___lambda48__gtk_list_box_row_activated (GtkListBox* _sender,
                                                                 GtkListBoxRow* row,
                                                                 gpointer self);
static void _network_main_view___lambda49_ (Block2Data* _data2_,
                                     gboolean show);
static void __network_main_view___lambda49__network_widgets_device_list_show_no_devices (NetworkWidgetsDeviceList* _sender,
                                                                                  gboolean show,
                                                                                  gpointer self);
static void _network_main_view_update_networking_state_g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self);
static void _network_main_view_connection_added_cb_nm_client_connection_added (NMClient* _sender,
                                                                        NMRemoteConnection* connection,
                                                                        gpointer self);
static void _network_main_view_connection_removed_cb_nm_client_connection_removed (NMClient* _sender,
                                                                            NMRemoteConnection* connection,
                                                                            gpointer self);
static void _network_main_view_device_added_cb_nm_client_device_added (NMClient* _sender,
                                                                NMDevice* device,
                                                                gpointer self);
static void _network_main_view_device_removed_cb_nm_client_device_removed (NMClient* _sender,
                                                                    NMDevice* device,
                                                                    gpointer self);
static void _network_main_view___lambda50_ (NetworkMainView* self,
                                     NMDevice* device);
static void __network_main_view___lambda50__gfunc (gconstpointer data,
                                            gpointer self);
static void _network_main_view___lambda51_ (NetworkMainView* self,
                                     NMRemoteConnection* connection);
static void __network_main_view___lambda51__gfunc (gconstpointer data,
                                            gpointer self);
static void network_main_view_finalize (GObject * obj);
static GType network_main_view_get_type_once (void);
static void _vala_network_main_view_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_network_main_view_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
network_main_view_get_instance_private (NetworkMainView* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkMainView_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static GList*
vala_g_list_remove_full (GList* self,
                         gconstpointer data,
                         GFreeFunc func)
{
	GList* l = NULL;
	GList* result;
	l = self;
	while (TRUE) {
		GList* _tmp0_;
		GList* _tmp1_;
		gconstpointer _tmp2_;
		_tmp0_ = l;
		if (!(_tmp0_ != NULL)) {
			break;
		}
		_tmp1_ = l;
		_tmp2_ = ((GList*) _tmp1_)->data;
		if (_tmp2_ != data) {
			GList* _tmp3_;
			GList* _tmp4_;
			_tmp3_ = l;
			_tmp4_ = ((GList*) _tmp3_)->next;
			l = _tmp4_;
		} else {
			GList* _tmp5_;
			gconstpointer _tmp6_;
			GList* _tmp7_;
			_tmp5_ = l;
			_tmp6_ = ((GList*) _tmp5_)->data;
			func (_tmp6_);
			_tmp7_ = l;
			self = g_list_delete_link (self, (GList*) _tmp7_);
			break;
		}
	}
	result = self;
	return result;
}

static void
network_main_view_device_removed_cb (NetworkMainView* self,
                                     NMDevice* device)
{
	GList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	_tmp0_ = self->network_interface;
	{
		GList* widget_interface_collection = NULL;
		GList* widget_interface_it = NULL;
		widget_interface_collection = _tmp0_;
		for (widget_interface_it = widget_interface_collection; widget_interface_it != NULL; widget_interface_it = widget_interface_it->next) {
			NetworkWidgetsPage* _tmp1_;
			NetworkWidgetsPage* widget_interface = NULL;
			_tmp1_ = _g_object_ref0 ((NetworkWidgetsPage*) widget_interface_it->data);
			widget_interface = _tmp1_;
			{
				NetworkWidgetsPage* _tmp2_;
				NMDevice* _tmp3_;
				NMDevice* _tmp4_;
				_tmp2_ = widget_interface;
				_tmp3_ = network_widgets_page_get_device (_tmp2_);
				_tmp4_ = _tmp3_;
				if (_tmp4_ == device) {
					NetworkWidgetsPage* _tmp5_;
					NetworkWidgetsPage* _tmp6_;
					_tmp5_ = widget_interface;
					self->network_interface = vala_g_list_remove_full (self->network_interface, _tmp5_, _g_object_unref0_);
					_tmp6_ = widget_interface;
					network_main_view_remove_interface (self, _tmp6_);
					_g_object_unref0 (widget_interface);
					break;
				}
				_g_object_unref0 (widget_interface);
			}
		}
	}
	network_main_view_update_interfaces_names (self);
}

static gint*
_int_dup (gint* self)
{
	gint* dup;
	dup = g_new0 (gint, 1);
	memcpy (dup, self, sizeof (gint));
	return dup;
}

static void
network_main_view_update_interfaces_names (NetworkMainView* self)
{
	GeeHashMap* count_type = NULL;
	GeeHashMap* _tmp0_;
	GList* _tmp1_;
	GList* _tmp18_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_INT, (GBoxedCopyFunc) _int_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	count_type = _tmp0_;
	_tmp1_ = self->network_interface;
	{
		GList* iface_collection = NULL;
		GList* iface_it = NULL;
		iface_collection = _tmp1_;
		for (iface_it = iface_collection; iface_it != NULL; iface_it = iface_it->next) {
			NetworkWidgetsPage* _tmp2_;
			NetworkWidgetsPage* iface = NULL;
			_tmp2_ = _g_object_ref0 ((NetworkWidgetsPage*) iface_it->data);
			iface = _tmp2_;
			{
				gchar* type = NULL;
				NetworkWidgetsPage* _tmp3_;
				const gchar* _tmp4_;
				gchar* _tmp5_;
				GeeHashMap* _tmp6_;
				const gchar* _tmp7_;
				_tmp3_ = iface;
				_tmp4_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) _tmp3_));
				_tmp5_ = g_strdup (_tmp4_);
				type = _tmp5_;
				_tmp6_ = count_type;
				_tmp7_ = type;
				if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp6_, _tmp7_)) {
					GeeHashMap* _tmp8_;
					const gchar* _tmp9_;
					GeeHashMap* _tmp10_;
					const gchar* _tmp11_;
					gpointer _tmp12_;
					gint* _tmp13_;
					gint _tmp14_;
					_tmp8_ = count_type;
					_tmp9_ = type;
					_tmp10_ = count_type;
					_tmp11_ = type;
					_tmp12_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp10_, _tmp11_);
					_tmp13_ = (gint*) _tmp12_;
					_tmp14_ = (*_tmp13_) + 1;
					gee_abstract_map_set ((GeeAbstractMap*) _tmp8_, _tmp9_, &_tmp14_);
					_g_free0 (_tmp13_);
				} else {
					GeeHashMap* _tmp15_;
					const gchar* _tmp16_;
					gint _tmp17_;
					_tmp15_ = count_type;
					_tmp16_ = type;
					_tmp17_ = 1;
					gee_abstract_map_set ((GeeAbstractMap*) _tmp15_, _tmp16_, &_tmp17_);
				}
				_g_free0 (type);
				_g_object_unref0 (iface);
			}
		}
	}
	_tmp18_ = self->network_interface;
	{
		GList* iface_collection = NULL;
		GList* iface_it = NULL;
		iface_collection = _tmp18_;
		for (iface_it = iface_collection; iface_it != NULL; iface_it = iface_it->next) {
			NetworkWidgetsPage* _tmp19_;
			NetworkWidgetsPage* iface = NULL;
			_tmp19_ = _g_object_ref0 ((NetworkWidgetsPage*) iface_it->data);
			iface = _tmp19_;
			{
				gchar* type = NULL;
				NetworkWidgetsPage* _tmp20_;
				const gchar* _tmp21_;
				gchar* _tmp22_;
				NetworkWidgetsPage* _tmp23_;
				GeeHashMap* _tmp24_;
				const gchar* _tmp25_;
				gpointer _tmp26_;
				gint* _tmp27_;
				_tmp20_ = iface;
				_tmp21_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) _tmp20_));
				_tmp22_ = g_strdup (_tmp21_);
				type = _tmp22_;
				_tmp23_ = iface;
				_tmp24_ = count_type;
				_tmp25_ = type;
				_tmp26_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp24_, _tmp25_);
				_tmp27_ = (gint*) _tmp26_;
				network_widgets_page_update_name (_tmp23_, *_tmp27_);
				_g_free0 (_tmp27_);
				_g_free0 (type);
				_g_object_unref0 (iface);
			}
		}
	}
	_g_object_unref0 (count_type);
}

static void
network_main_view_connection_added_cb (NetworkMainView* self,
                                       GObject* obj)
{
	NMRemoteConnection* connection = NULL;
	NMRemoteConnection* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (obj != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (obj, nm_remote_connection_get_type (), NMRemoteConnection));
	connection = _tmp0_;
	network_main_view_add_connection (self, connection);
	_g_object_unref0 (connection);
}

static void
network_main_view_connection_removed_cb (NetworkMainView* self,
                                         GObject* obj)
{
	NMRemoteConnection* connection = NULL;
	NMRemoteConnection* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (obj != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (obj, nm_remote_connection_get_type (), NMRemoteConnection));
	connection = _tmp0_;
	network_main_view_remove_connection (self, connection);
	_g_object_unref0 (connection);
}

static void
_network_main_view_update_state_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self)
{
	network_main_view_update_state ((NetworkMainView*) self);
}

static void
network_main_view_device_added_cb (NetworkMainView* self,
                                   NMDevice* device)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	NetworkWidgetsPage* widget_interface = NULL;
	NetworkWidgetsPage* hotspot_interface = NULL;
	NetworkWidgetsPage* _tmp11_;
	NetworkWidgetsPage* _tmp16_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	_tmp2_ = nm_device_get_iface (device);
	if (g_str_has_prefix (_tmp2_, "vmnet")) {
		_tmp1_ = TRUE;
	} else {
		const gchar* _tmp3_;
		_tmp3_ = nm_device_get_iface (device);
		_tmp1_ = g_str_has_prefix (_tmp3_, "lo");
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp4_;
		_tmp4_ = nm_device_get_iface (device);
		_tmp0_ = g_str_has_prefix (_tmp4_, "veth");
	}
	if (_tmp0_) {
		return;
	}
	widget_interface = NULL;
	hotspot_interface = NULL;
	if (G_TYPE_CHECK_INSTANCE_TYPE (device, nm_device_wifi_get_type ())) {
		NetworkWifiInterface* _tmp5_;
		NetworkWidgetsPage* _tmp6_;
		NetworkWidgetsHotspotInterface* _tmp7_;
		_tmp5_ = network_wifi_interface_new (device);
		g_object_ref_sink (_tmp5_);
		_g_object_unref0 (widget_interface);
		widget_interface = (NetworkWidgetsPage*) _tmp5_;
		_tmp6_ = widget_interface;
		_tmp7_ = network_widgets_hotspot_interface_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, NETWORK_TYPE_WIFI_INTERFACE, NetworkWifiInterface));
		g_object_ref_sink (_tmp7_);
		_g_object_unref0 (hotspot_interface);
		hotspot_interface = (NetworkWidgetsPage*) _tmp7_;
		g_debug ("MainView.vala:172: Wifi interface added");
	} else {
		if (G_TYPE_CHECK_INSTANCE_TYPE (device, nm_device_ethernet_get_type ())) {
			NetworkWidgetsEtherInterface* _tmp8_;
			_tmp8_ = network_widgets_ether_interface_new (device);
			g_object_ref_sink (_tmp8_);
			_g_object_unref0 (widget_interface);
			widget_interface = (NetworkWidgetsPage*) _tmp8_;
			g_debug ("MainView.vala:175: Ethernet interface added");
		} else {
			if (G_TYPE_CHECK_INSTANCE_TYPE (device, nm_device_modem_get_type ())) {
				NetworkWidgetsModemInterface* _tmp9_;
				_tmp9_ = network_widgets_modem_interface_new (device);
				g_object_ref_sink (_tmp9_);
				_g_object_unref0 (widget_interface);
				widget_interface = (NetworkWidgetsPage*) _tmp9_;
				g_debug ("MainView.vala:178: Modem interface added");
			} else {
				GEnumValue* _tmp10_;
				_tmp10_ = g_enum_get_value (g_type_class_ref (nm_device_type_get_type ()), nm_device_get_device_type (device));
				g_debug ("MainView.vala:180: Unknown device: %s\n", (_tmp10_ != NULL) ? _tmp10_->value_name : NULL);
			}
		}
	}
	_tmp11_ = widget_interface;
	if (_tmp11_ != NULL) {
		NetworkWidgetsPage* _tmp12_;
		NetworkWidgetsPage* _tmp13_;
		NetworkWidgetsPage* _tmp14_;
		NetworkWidgetsPage* _tmp15_;
		_tmp12_ = widget_interface;
		_tmp13_ = _g_object_ref0 (_tmp12_);
		self->network_interface = g_list_append (self->network_interface, _tmp13_);
		_tmp14_ = widget_interface;
		network_main_view_add_interface (self, _tmp14_);
		_tmp15_ = widget_interface;
		g_signal_connect_object ((GObject*) _tmp15_, "notify::state", (GCallback) _network_main_view_update_state_g_object_notify, self, 0);
	}
	_tmp16_ = hotspot_interface;
	if (_tmp16_ != NULL) {
		NetworkWidgetsPage* _tmp17_;
		NetworkWidgetsPage* _tmp18_;
		NetworkWidgetsPage* _tmp19_;
		NetworkWidgetsPage* _tmp20_;
		_tmp17_ = hotspot_interface;
		_tmp18_ = _g_object_ref0 (_tmp17_);
		self->network_interface = g_list_append (self->network_interface, _tmp18_);
		_tmp19_ = hotspot_interface;
		network_main_view_add_interface (self, _tmp19_);
		_tmp20_ = hotspot_interface;
		g_signal_connect_object ((GObject*) _tmp20_, "notify::state", (GCallback) _network_main_view_update_state_g_object_notify, self, 0);
	}
	network_main_view_update_interfaces_names (self);
	network_main_view_update_all (self);
	_g_object_unref0 (hotspot_interface);
	_g_object_unref0 (widget_interface);
}

static void
network_main_view_update_all (NetworkMainView* self)
{
	GList* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->network_interface;
	{
		GList* inter_collection = NULL;
		GList* inter_it = NULL;
		inter_collection = _tmp0_;
		for (inter_it = inter_collection; inter_it != NULL; inter_it = inter_it->next) {
			NetworkWidgetsPage* _tmp1_;
			NetworkWidgetsPage* inter = NULL;
			_tmp1_ = _g_object_ref0 ((NetworkWidgetsPage*) inter_it->data);
			inter = _tmp1_;
			{
				NetworkWidgetsPage* _tmp2_;
				_tmp2_ = inter;
				network_widgets_page_update (_tmp2_);
				_g_object_unref0 (inter);
			}
		}
	}
}

static void
network_main_view_update_state (NetworkMainView* self)
{
	NMDeviceState next_state = 0;
	GList* _tmp0_;
	g_return_if_fail (self != NULL);
	next_state = NM_DEVICE_STATE_DISCONNECTED;
	_tmp0_ = self->network_interface;
	{
		GList* inter_collection = NULL;
		GList* inter_it = NULL;
		inter_collection = _tmp0_;
		for (inter_it = inter_collection; inter_it != NULL; inter_it = inter_it->next) {
			NetworkWidgetsPage* _tmp1_;
			NetworkWidgetsPage* inter = NULL;
			_tmp1_ = _g_object_ref0 ((NetworkWidgetsPage*) inter_it->data);
			inter = _tmp1_;
			{
				NetworkWidgetsPage* _tmp2_;
				NMDeviceState _tmp3_;
				NMDeviceState _tmp4_;
				_tmp2_ = inter;
				_tmp3_ = network_widgets_page_get_state (_tmp2_);
				_tmp4_ = _tmp3_;
				if (_tmp4_ != NM_DEVICE_STATE_DISCONNECTED) {
					NetworkWidgetsPage* _tmp5_;
					NMDeviceState _tmp6_;
					NMDeviceState _tmp7_;
					_tmp5_ = inter;
					_tmp6_ = network_widgets_page_get_state (_tmp5_);
					_tmp7_ = _tmp6_;
					next_state = _tmp7_;
				}
				_g_object_unref0 (inter);
			}
		}
	}
	network_main_view_set_state (self, next_state);
}

static void
network_main_view_add_interface (NetworkMainView* self,
                                 NetworkWidgetsPage* widget_interface)
{
	NetworkWidgetsDeviceList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget_interface != NULL);
	_tmp0_ = self->priv->device_list;
	network_widgets_device_list_add_iface_to_list (_tmp0_, widget_interface);
	network_main_view_update_networking_state (self);
}

static void
network_main_view_remove_interface (NetworkMainView* self,
                                    NetworkWidgetsPage* widget_interface)
{
	GtkStack* _tmp0_;
	GtkWidget* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget_interface != NULL);
	_tmp0_ = self->priv->content;
	_tmp1_ = gtk_stack_get_visible_child (_tmp0_);
	if (_tmp1_ == G_TYPE_CHECK_INSTANCE_CAST (widget_interface, gtk_widget_get_type (), GtkWidget)) {
		GtkListBoxRow* row = NULL;
		NetworkWidgetsDeviceList* _tmp2_;
		GtkListBoxRow* _tmp3_;
		GtkListBoxRow* _tmp4_;
		gint index = 0;
		NetworkWidgetsDeviceList* _tmp5_;
		GtkListBoxRow* _tmp6_;
		NetworkWidgetsDeviceList* _tmp7_;
		gboolean _tmp8_ = FALSE;
		GtkListBoxRow* _tmp9_;
		_tmp2_ = self->priv->device_list;
		_tmp3_ = gtk_list_box_get_selected_row ((GtkListBox*) _tmp2_);
		_tmp4_ = _g_object_ref0 (_tmp3_);
		row = _tmp4_;
		_tmp5_ = self->priv->device_list;
		_tmp6_ = gtk_list_box_get_selected_row ((GtkListBox*) _tmp5_);
		index = gtk_list_box_row_get_index (_tmp6_);
		_tmp7_ = self->priv->device_list;
		network_widgets_device_list_remove_iface_from_list (_tmp7_, widget_interface);
		_tmp9_ = row;
		if (_tmp9_ != NULL) {
			GtkListBoxRow* _tmp10_;
			_tmp10_ = row;
			_tmp8_ = gtk_list_box_row_get_index (_tmp10_) >= 0;
		} else {
			_tmp8_ = FALSE;
		}
		if (_tmp8_) {
			NetworkWidgetsDeviceList* _tmp11_;
			GtkListBoxRow* _tmp12_;
			_tmp11_ = self->priv->device_list;
			_tmp12_ = gtk_list_box_get_row_at_index ((GtkListBox*) _tmp11_, index);
			g_signal_emit_by_name (_tmp12_, "activate");
		} else {
			network_main_view_select_first (self);
		}
		_g_object_unref0 (row);
	} else {
		NetworkWidgetsDeviceList* _tmp13_;
		_tmp13_ = self->priv->device_list;
		network_widgets_device_list_remove_iface_from_list (_tmp13_, widget_interface);
	}
	gtk_widget_destroy ((GtkWidget*) widget_interface);
}

static void
network_main_view_add_connection (NetworkMainView* self,
                                  NMRemoteConnection* connection)
{
	NetworkWidgetsDeviceList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	_tmp0_ = self->priv->device_list;
	network_widgets_device_list_add_connection (_tmp0_, connection);
}

static void
network_main_view_remove_connection (NetworkMainView* self,
                                     NMRemoteConnection* connection)
{
	NetworkWidgetsDeviceList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	_tmp0_ = self->priv->device_list;
	network_widgets_device_list_remove_connection (_tmp0_, connection);
}

static void
network_main_view_select_first (NetworkMainView* self)
{
	NetworkWidgetsDeviceList* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->device_list;
	network_widgets_device_list_select_first_item (_tmp0_);
}

static void
network_main_view_update_networking_state (NetworkMainView* self)
{
	NetworkNetworkManager* network_manager = NULL;
	NetworkNetworkManager* _tmp0_;
	NetworkNetworkManager* _tmp1_;
	NMClient* _tmp2_;
	NMClient* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = network_network_manager_get_default ();
	network_manager = _tmp0_;
	_tmp1_ = network_manager;
	_tmp2_ = network_network_manager_get_client (_tmp1_);
	_tmp3_ = _tmp2_;
	if (nm_client_networking_get_enabled (_tmp3_)) {
		NetworkWidgetsDeviceList* _tmp4_;
		NetworkWidgetsDeviceList* _tmp5_;
		_tmp4_ = self->priv->device_list;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, TRUE);
		_tmp5_ = self->priv->device_list;
		network_widgets_device_list_select_first_item (_tmp5_);
	} else {
		NetworkWidgetsDeviceList* _tmp6_;
		NetworkWidgetsDeviceList* _tmp7_;
		GtkStack* _tmp8_;
		_tmp6_ = self->priv->device_list;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, FALSE);
		_g_object_unref0 (self->priv->current_device);
		self->priv->current_device = NULL;
		_tmp7_ = self->priv->device_list;
		gtk_list_box_select_row ((GtkListBox*) _tmp7_, NULL);
		_tmp8_ = self->priv->content;
		gtk_stack_set_visible_child_name (_tmp8_, "airplane-mode-info");
	}
}

NetworkMainView*
network_main_view_construct (GType object_type)
{
	NetworkMainView * self = NULL;
	self = (NetworkMainView*) g_object_new (object_type, NULL);
	return self;
}

NetworkMainView*
network_main_view_new (void)
{
	return network_main_view_construct (NETWORK_TYPE_MAIN_VIEW);
}

NMDeviceState
network_main_view_get_state (NetworkMainView* self)
{
	NMDeviceState result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_state;
	return result;
}

static void
network_main_view_set_state (NetworkMainView* self,
                             NMDeviceState value)
{
	NMDeviceState old_value;
	g_return_if_fail (self != NULL);
	old_value = network_main_view_get_state (self);
	if (old_value != value) {
		self->priv->_state = value;
		g_object_notify_by_pspec ((GObject *) self, network_main_view_properties[NETWORK_MAIN_VIEW_STATE_PROPERTY]);
	}
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		NetworkMainView* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->scrolled_window);
		_g_object_unref0 (_data2_->no_devices);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static void
_network_main_view___lambda48_ (NetworkMainView* self,
                                GtkListBoxRow* row)
{
	NetworkWidgetsPage* page = NULL;
	NetworkWidgetsPage* _tmp0_;
	NetworkWidgetsPage* _tmp1_;
	NetworkWidgetsPage* _tmp2_;
	GtkStack* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
	NetworkWidgetsPage* _tmp6_;
	GList* _tmp7_;
	gboolean _tmp8_;
	GtkStack* _tmp11_;
	NetworkWidgetsPage* _tmp12_;
	g_return_if_fail (row != NULL);
	_tmp0_ = network_widgets_device_item_get_page (G_TYPE_CHECK_INSTANCE_CAST (row, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem));
	_tmp1_ = _tmp0_;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	page = _tmp2_;
	_tmp3_ = self->priv->content;
	_tmp4_ = gtk_container_get_children ((GtkContainer*) _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = page;
	_tmp7_ = g_list_find (_tmp5_, (GtkWidget*) _tmp6_);
	_tmp8_ = _tmp7_ == NULL;
	(_tmp5_ == NULL) ? NULL : (_tmp5_ = (g_list_free (_tmp5_), NULL));
	if (_tmp8_) {
		GtkStack* _tmp9_;
		NetworkWidgetsPage* _tmp10_;
		_tmp9_ = self->priv->content;
		_tmp10_ = page;
		gtk_container_add ((GtkContainer*) _tmp9_, (GtkWidget*) _tmp10_);
	}
	_tmp11_ = self->priv->content;
	_tmp12_ = page;
	gtk_stack_set_visible_child (_tmp11_, (GtkWidget*) _tmp12_);
	_g_object_unref0 (page);
}

static void
__network_main_view___lambda48__gtk_list_box_row_activated (GtkListBox* _sender,
                                                            GtkListBoxRow* row,
                                                            gpointer self)
{
	_network_main_view___lambda48_ ((NetworkMainView*) self, row);
}

static void
_network_main_view___lambda49_ (Block2Data* _data2_,
                                gboolean show)
{
	NetworkMainView* self;
	GtkScrolledWindow* _tmp0_;
	self = _data2_->self;
	_tmp0_ = _data2_->scrolled_window;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, !show);
	if (show) {
		GtkStack* _tmp1_;
		GraniteWidgetsAlertView* _tmp2_;
		_tmp1_ = self->priv->content;
		_tmp2_ = _data2_->no_devices;
		gtk_stack_set_visible_child (_tmp1_, (GtkWidget*) _tmp2_);
	} else {
		GtkStack* _tmp3_;
		NetworkWidgetsPage* _tmp4_;
		_tmp3_ = self->priv->content;
		_tmp4_ = self->priv->page;
		gtk_stack_set_visible_child (_tmp3_, (GtkWidget*) _tmp4_);
	}
}

static void
__network_main_view___lambda49__network_widgets_device_list_show_no_devices (NetworkWidgetsDeviceList* _sender,
                                                                             gboolean show,
                                                                             gpointer self)
{
	_network_main_view___lambda49_ (self, show);
}

static void
_network_main_view_update_networking_state_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self)
{
	network_main_view_update_networking_state ((NetworkMainView*) self);
}

static void
_network_main_view_connection_added_cb_nm_client_connection_added (NMClient* _sender,
                                                                   NMRemoteConnection* connection,
                                                                   gpointer self)
{
	network_main_view_connection_added_cb ((NetworkMainView*) self, connection);
}

static void
_network_main_view_connection_removed_cb_nm_client_connection_removed (NMClient* _sender,
                                                                       NMRemoteConnection* connection,
                                                                       gpointer self)
{
	network_main_view_connection_removed_cb ((NetworkMainView*) self, connection);
}

static void
_network_main_view_device_added_cb_nm_client_device_added (NMClient* _sender,
                                                           NMDevice* device,
                                                           gpointer self)
{
	network_main_view_device_added_cb ((NetworkMainView*) self, device);
}

static void
_network_main_view_device_removed_cb_nm_client_device_removed (NMClient* _sender,
                                                               NMDevice* device,
                                                               gpointer self)
{
	network_main_view_device_removed_cb ((NetworkMainView*) self, device);
}

static void
_network_main_view___lambda50_ (NetworkMainView* self,
                                NMDevice* device)
{
	g_return_if_fail (device != NULL);
	network_main_view_device_added_cb (self, device);
}

static void
__network_main_view___lambda50__gfunc (gconstpointer data,
                                       gpointer self)
{
	_network_main_view___lambda50_ ((NetworkMainView*) self, (NMDevice*) data);
}

static void
_network_main_view___lambda51_ (NetworkMainView* self,
                                NMRemoteConnection* connection)
{
	g_return_if_fail (connection != NULL);
	network_main_view_add_connection (self, connection);
}

static void
__network_main_view___lambda51__gfunc (gconstpointer data,
                                       gpointer self)
{
	_network_main_view___lambda51_ ((NetworkMainView*) self, (NMRemoteConnection*) data);
}

static GObject *
network_main_view_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkMainView * self;
	Block2Data* _data2_;
	NetworkWidgetsDeviceList* _tmp0_;
	NetworkWidgetsFooter* footer = NULL;
	NetworkWidgetsFooter* _tmp1_;
	GraniteWidgetsAlertView* airplane_mode = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GraniteWidgetsAlertView* _tmp6_;
	GraniteWidgetsAlertView* _tmp7_;
	GraniteWidgetsAlertView* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GraniteWidgetsAlertView* _tmp11_;
	GraniteWidgetsAlertView* _tmp12_;
	GraniteWidgetsAlertView* _tmp13_;
	GtkStack* _tmp14_ = NULL;
	GtkStack* _tmp15_;
	GraniteWidgetsAlertView* _tmp16_;
	GtkStack* _tmp17_;
	GraniteWidgetsAlertView* _tmp18_;
	GtkScrolledWindow* _tmp19_ = NULL;
	GtkScrolledWindow* _tmp20_;
	NetworkWidgetsDeviceList* _tmp21_;
	GtkGrid* sidebar = NULL;
	GtkGrid* _tmp22_ = NULL;
	GtkGrid* _tmp23_;
	GtkScrolledWindow* _tmp24_;
	GtkGrid* _tmp25_;
	NetworkWidgetsFooter* _tmp26_;
	GtkGrid* _tmp27_;
	GtkStack* _tmp28_;
	NetworkWidgetsDeviceList* _tmp29_;
	NetworkWidgetsDeviceList* _tmp30_;
	NetworkNetworkManager* network_manager = NULL;
	NetworkNetworkManager* _tmp31_;
	NetworkNetworkManager* _tmp32_;
	NMClient* _tmp33_;
	NMClient* _tmp34_;
	NetworkNetworkManager* nm_manager = NULL;
	NetworkNetworkManager* _tmp35_;
	NMClient* nm_client = NULL;
	NetworkNetworkManager* _tmp36_;
	NMClient* _tmp37_;
	NMClient* _tmp38_;
	NMClient* _tmp39_;
	NMClient* _tmp40_;
	NMClient* _tmp41_;
	NMClient* _tmp42_;
	NMClient* _tmp43_;
	GPtrArray* _tmp44_;
	NMClient* _tmp45_;
	GPtrArray* _tmp46_;
	parent_class = G_OBJECT_CLASS (network_main_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_MAIN_VIEW, NetworkMainView);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	(self->network_interface == NULL) ? NULL : (self->network_interface = (_g_list_free__g_object_unref0_ (self->network_interface), NULL));
	self->network_interface = NULL;
	_tmp0_ = network_widgets_device_list_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->device_list);
	self->priv->device_list = _tmp0_;
	_tmp1_ = network_widgets_footer_new ();
	g_object_ref_sink (_tmp1_);
	footer = _tmp1_;
	_tmp2_ = g_strconcat (_ ("While in Airplane Mode your device's Internet access and any wireless " \
"and ethernet connections, will be suspended.\n" \
"\n"), _ ("You will be unable to browse the web or use applications that require " \
"a network connection or Internet access.\n"), NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strconcat (_tmp3_, _ ("Applications and other functions that do not require the Internet will" \
" be unaffected."), NULL);
	_tmp5_ = _tmp4_;
	_tmp6_ = granite_widgets_alert_view_new (_ ("Airplane Mode Is Enabled"), _tmp5_, "airplane-mode");
	g_object_ref_sink (_tmp6_);
	_tmp7_ = _tmp6_;
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	airplane_mode = _tmp7_;
	_tmp8_ = airplane_mode;
	gtk_widget_show_all ((GtkWidget*) _tmp8_);
	_tmp9_ = g_strconcat (_ ("There are no available Wi-Fi connections or Wi-Fi devices connected to" \
" this computer.\n"), _ ("Please connect at least one device to begin configuring the network."), NULL);
	_tmp10_ = _tmp9_;
	_tmp11_ = granite_widgets_alert_view_new (_ ("There is nothing to do"), _tmp10_, "dialog-cancel");
	g_object_ref_sink (_tmp11_);
	_tmp12_ = _tmp11_;
	_g_free0 (_tmp10_);
	_data2_->no_devices = _tmp12_;
	_tmp13_ = _data2_->no_devices;
	gtk_widget_show_all ((GtkWidget*) _tmp13_);
	_tmp14_ = (GtkStack*) gtk_stack_new ();
	gtk_widget_set_hexpand ((GtkWidget*) _tmp14_, TRUE);
	g_object_ref_sink (_tmp14_);
	_g_object_unref0 (self->priv->content);
	self->priv->content = _tmp14_;
	_tmp15_ = self->priv->content;
	_tmp16_ = airplane_mode;
	gtk_stack_add_named (_tmp15_, (GtkWidget*) _tmp16_, "airplane-mode-info");
	_tmp17_ = self->priv->content;
	_tmp18_ = _data2_->no_devices;
	gtk_stack_add_named (_tmp17_, (GtkWidget*) _tmp18_, "no-devices-info");
	_tmp19_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_set ((GtkWidget*) _tmp19_, "expand", TRUE, NULL);
	g_object_ref_sink (_tmp19_);
	_data2_->scrolled_window = _tmp19_;
	_tmp20_ = _data2_->scrolled_window;
	_tmp21_ = self->priv->device_list;
	gtk_container_add ((GtkContainer*) _tmp20_, (GtkWidget*) _tmp21_);
	_tmp22_ = (GtkGrid*) gtk_grid_new ();
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp22_, GTK_ORIENTATION_VERTICAL);
	g_object_ref_sink (_tmp22_);
	sidebar = _tmp22_;
	_tmp23_ = sidebar;
	_tmp24_ = _data2_->scrolled_window;
	gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
	_tmp25_ = sidebar;
	_tmp26_ = footer;
	gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) _tmp26_);
	gtk_paned_set_position ((GtkPaned*) self, 240);
	_tmp27_ = sidebar;
	gtk_paned_pack1 ((GtkPaned*) self, (GtkWidget*) _tmp27_, FALSE, FALSE);
	_tmp28_ = self->priv->content;
	gtk_paned_pack2 ((GtkPaned*) self, (GtkWidget*) _tmp28_, TRUE, FALSE);
	_tmp29_ = self->priv->device_list;
	g_signal_connect_object ((GtkListBox*) _tmp29_, "row-activated", (GCallback) __network_main_view___lambda48__gtk_list_box_row_activated, self, 0);
	_tmp30_ = self->priv->device_list;
	g_signal_connect_data (_tmp30_, "show-no-devices", (GCallback) __network_main_view___lambda49__network_widgets_device_list_show_no_devices, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp31_ = network_network_manager_get_default ();
	network_manager = _tmp31_;
	_tmp32_ = network_manager;
	_tmp33_ = network_network_manager_get_client (_tmp32_);
	_tmp34_ = _tmp33_;
	g_signal_connect_object ((GObject*) _tmp34_, "notify::networking-enabled", (GCallback) _network_main_view_update_networking_state_g_object_notify, self, 0);
	network_main_view_update_networking_state (self);
	_tmp35_ = network_network_manager_get_default ();
	nm_manager = _tmp35_;
	_tmp36_ = nm_manager;
	_tmp37_ = network_network_manager_get_client (_tmp36_);
	_tmp38_ = _tmp37_;
	nm_client = _tmp38_;
	_tmp39_ = nm_client;
	g_signal_connect_object (_tmp39_, "connection-added", (GCallback) _network_main_view_connection_added_cb_nm_client_connection_added, self, 0);
	_tmp40_ = nm_client;
	g_signal_connect_object (_tmp40_, "connection-removed", (GCallback) _network_main_view_connection_removed_cb_nm_client_connection_removed, self, 0);
	_tmp41_ = nm_client;
	g_signal_connect_object (_tmp41_, "device-added", (GCallback) _network_main_view_device_added_cb_nm_client_device_added, self, 0);
	_tmp42_ = nm_client;
	g_signal_connect_object (_tmp42_, "device-removed", (GCallback) _network_main_view_device_removed_cb_nm_client_device_removed, self, 0);
	_tmp43_ = nm_client;
	_tmp44_ = nm_client_get_devices (_tmp43_);
	g_ptr_array_foreach (_tmp44_, __network_main_view___lambda50__gfunc, self);
	_tmp45_ = nm_client;
	_tmp46_ = nm_client_get_connections (_tmp45_);
	g_ptr_array_foreach (_tmp46_, __network_main_view___lambda51__gfunc, self);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (sidebar);
	_g_object_unref0 (airplane_mode);
	_g_object_unref0 (footer);
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return obj;
}

static void
network_main_view_class_init (NetworkMainViewClass * klass,
                              gpointer klass_data)
{
	network_main_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NetworkMainView_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_network_main_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_network_main_view_set_property;
	G_OBJECT_CLASS (klass)->constructor = network_main_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = network_main_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_MAIN_VIEW_STATE_PROPERTY, network_main_view_properties[NETWORK_MAIN_VIEW_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", nm_device_state_get_type (), NM_DEVICE_STATE_PREPARE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
network_main_view_instance_init (NetworkMainView * self,
                                 gpointer klass)
{
	self->priv = network_main_view_get_instance_private (self);
	self->priv->_state = NM_DEVICE_STATE_PREPARE;
	self->priv->current_device = NULL;
}

static void
network_main_view_finalize (GObject * obj)
{
	NetworkMainView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_MAIN_VIEW, NetworkMainView);
	(self->network_interface == NULL) ? NULL : (self->network_interface = (_g_list_free__g_object_unref0_ (self->network_interface), NULL));
	_g_object_unref0 (self->priv->current_device);
	_g_object_unref0 (self->priv->content);
	_g_object_unref0 (self->priv->page);
	_g_object_unref0 (self->priv->device_list);
	G_OBJECT_CLASS (network_main_view_parent_class)->finalize (obj);
}

static GType
network_main_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkMainViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_main_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkMainView), 0, (GInstanceInitFunc) network_main_view_instance_init, NULL };
	GType network_main_view_type_id;
	network_main_view_type_id = g_type_register_static (gtk_paned_get_type (), "NetworkMainView", &g_define_type_info, 0);
	NetworkMainView_private_offset = g_type_add_instance_private (network_main_view_type_id, sizeof (NetworkMainViewPrivate));
	return network_main_view_type_id;
}

GType
network_main_view_get_type (void)
{
	static volatile gsize network_main_view_type_id__once = 0;
	if (g_once_init_enter (&network_main_view_type_id__once)) {
		GType network_main_view_type_id;
		network_main_view_type_id = network_main_view_get_type_once ();
		g_once_init_leave (&network_main_view_type_id__once, network_main_view_type_id);
	}
	return network_main_view_type_id__once;
}

static void
_vala_network_main_view_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	NetworkMainView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_MAIN_VIEW, NetworkMainView);
	switch (property_id) {
		case NETWORK_MAIN_VIEW_STATE_PROPERTY:
		g_value_set_enum (value, network_main_view_get_state (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_network_main_view_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	NetworkMainView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_MAIN_VIEW, NetworkMainView);
	switch (property_id) {
		case NETWORK_MAIN_VIEW_STATE_PROPERTY:
		network_main_view_set_state (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

