/* VPNPage.c generated by valac 0.56.2, the Vala compiler
 * generated from VPNPage.vala, do not modify */

/*-
 * Copyright (c) 2015-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include "networking.h"
#include <gee.h>
#include <glib-object.h>
#include <NetworkManager.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

enum  {
	NETWORK_VPN_PAGE_0_PROPERTY,
	NETWORK_VPN_PAGE_OWNER_PROPERTY,
	NETWORK_VPN_PAGE_NUM_PROPERTIES
};
static GParamSpec* network_vpn_page_properties[NETWORK_VPN_PAGE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block4Data Block4Data;

struct _NetworkVPNPagePrivate {
	NetworkWidgetsDeviceItem* _owner;
	GeeList* active_connections;
	GtkListBox* vpn_list;
	guint timeout_id;
	NetworkVPNMenuItem* sel_row;
	GraniteWidgetsToast* remove_vpn_toast;
};

struct _Block4Data {
	int _ref_count_;
	NetworkVPNPage* self;
	GtkButton* remove_button;
	GtkButton* edit_connection_button;
};

static gint NetworkVPNPage_private_offset;
static gpointer network_vpn_page_parent_class = NULL;

static void network_vpn_page_real_update (NetworkWidgetsPage* base);
static void network_vpn_page_update_active_connections (NetworkVPNPage* self);
static NetworkVPNMenuItem* network_vpn_page_get_item_by_uuid (NetworkVPNPage* self,
                                                       const gchar* uuid);
static void network_vpn_page_real_update_switch (NetworkWidgetsPage* base);
static void network_vpn_page_real_control_switch_activated (NetworkWidgetsPage* base);
static void __lambda25_ (NetworkVPNPage* self,
                  NMActiveConnection* ac);
static void _network_widgets_page_update_nm_vpn_connection_vpn_state_changed (NMVpnConnection* _sender,
                                                                       guint object,
                                                                       guint p0,
                                                                       gpointer self);
static void ___lambda25__gfunc (gconstpointer data,
                         gpointer self);
static void network_vpn_page_connect_vpn_cb (NetworkVPNPage* self,
                                      NetworkVPNMenuItem* item);
static void network_vpn_page_disconnect_vpn_cb (NetworkVPNPage* self,
                                         NetworkVPNMenuItem* item);
static void network_vpn_page_remove_button_cb (NetworkVPNPage* self);
static gboolean ____lambda26_ (NetworkVPNPage* self);
static void network_vpn_page_delete_connection (NetworkVPNPage* self);
static gboolean _____lambda26__gsource_func (gpointer self);
static void network_vpn_page_try_connection_editor (NetworkVPNPage* self,
                                             const gchar* args);
static gint network_vpn_page_compare_rows (NetworkVPNMenuItem* row1,
                                    NetworkVPNMenuItem* row2,
                                    NetworkVPNPage* self);
static GObject * network_vpn_page_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void _network_vpn_page___lambda27_ (NetworkVPNPage* self);
static void __network_vpn_page___lambda27__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _network_vpn_page_remove_button_cb_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static void _network_vpn_page___lambda28_ (NetworkVPNPage* self);
static void __network_vpn_page___lambda28__granite_widgets_toast_default_action (GraniteWidgetsToast* _sender,
                                                                          gpointer self);
static void _network_vpn_page___lambda29_ (NetworkVPNPage* self);
static void __network_vpn_page___lambda29__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _network_vpn_page___lambda30_ (NetworkVPNPage* self,
                                    GtkListBoxRow* row);
static void __network_vpn_page___lambda30__gtk_list_box_row_activated (GtkListBox* _sender,
                                                                GtkListBoxRow* row,
                                                                gpointer self);
static void _network_vpn_page___lambda31_ (Block4Data* _data4_,
                                    GtkListBoxRow* row);
static void __network_vpn_page___lambda31__gtk_list_box_row_selected (GtkListBox* _sender,
                                                               GtkListBoxRow* row,
                                                               gpointer self);
static void _network_vpn_page_update_active_connections_g_object_notify (GObject* _sender,
                                                                  GParamSpec* pspec,
                                                                  gpointer self);
static void network_vpn_page_finalize (GObject * obj);
static GType network_vpn_page_get_type_once (void);
static void _vala_network_vpn_page_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_network_vpn_page_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
network_vpn_page_get_instance_private (NetworkVPNPage* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkVPNPage_private_offset);
}

NetworkVPNPage*
network_vpn_page_construct (GType object_type,
                            NetworkWidgetsDeviceItem* owner)
{
	NetworkVPNPage * self = NULL;
	g_return_val_if_fail (owner != NULL, NULL);
	self = (NetworkVPNPage*) g_object_new (object_type, "owner", owner, "title", _ ("Virtual Private Network"), "icon-name", "network-vpn", NULL);
	return self;
}

NetworkVPNPage*
network_vpn_page_new (NetworkWidgetsDeviceItem* owner)
{
	return network_vpn_page_construct (NETWORK_TYPE_VPN_PAGE, owner);
}

static void
network_vpn_page_real_update (NetworkWidgetsPage* base)
{
	NetworkVPNPage * self;
	NetworkVPNMenuItem* item = NULL;
	NetworkWidgetsDeviceItem* _tmp17_;
	NMDeviceState _tmp18_;
	NMDeviceState _tmp19_;
	self = (NetworkVPNPage*) base;
	network_vpn_page_update_active_connections (self);
	item = NULL;
	{
		GeeList* _ac_list = NULL;
		GeeList* _tmp0_;
		gint _ac_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _ac_index = 0;
		_tmp0_ = self->priv->active_connections;
		_ac_list = _tmp0_;
		_tmp1_ = _ac_list;
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_ac_size = _tmp3_;
		_ac_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			NMVpnConnection* ac = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			NMVpnConnection* _tmp8_;
			NetworkVPNMenuItem* _tmp13_;
			_ac_index = _ac_index + 1;
			_tmp4_ = _ac_index;
			_tmp5_ = _ac_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _ac_list;
			_tmp7_ = gee_list_get (_tmp6_, _ac_index);
			ac = (NMVpnConnection*) _tmp7_;
			_tmp8_ = ac;
			if (_tmp8_ != NULL) {
				NMVpnConnection* _tmp9_;
				NMVpnConnection* _tmp10_;
				const gchar* _tmp11_;
				NetworkVPNMenuItem* _tmp12_;
				_tmp9_ = ac;
				switch (nm_vpn_connection_get_vpn_state (_tmp9_)) {
					case NM_VPN_CONNECTION_STATE_UNKNOWN:
					case NM_VPN_CONNECTION_STATE_DISCONNECTED:
					{
						network_widgets_page_set_state ((NetworkWidgetsPage*) self, NM_DEVICE_STATE_DISCONNECTED);
						break;
					}
					case NM_VPN_CONNECTION_STATE_PREPARE:
					case NM_VPN_CONNECTION_STATE_NEED_AUTH:
					case NM_VPN_CONNECTION_STATE_IP_CONFIG_GET:
					case NM_VPN_CONNECTION_STATE_CONNECT:
					{
						network_widgets_page_set_state ((NetworkWidgetsPage*) self, NM_DEVICE_STATE_PREPARE);
						break;
					}
					case NM_VPN_CONNECTION_STATE_FAILED:
					{
						network_widgets_page_set_state ((NetworkWidgetsPage*) self, NM_DEVICE_STATE_FAILED);
						break;
					}
					case NM_VPN_CONNECTION_STATE_ACTIVATED:
					{
						network_widgets_page_set_state ((NetworkWidgetsPage*) self, NM_DEVICE_STATE_ACTIVATED);
						break;
					}
					default:
					break;
				}
				_tmp10_ = ac;
				_tmp11_ = nm_active_connection_get_uuid ((NMActiveConnection*) _tmp10_);
				_tmp12_ = network_vpn_page_get_item_by_uuid (self, _tmp11_);
				_g_object_unref0 (item);
				item = _tmp12_;
			} else {
				network_widgets_page_set_state ((NetworkWidgetsPage*) self, NM_DEVICE_STATE_DISCONNECTED);
			}
			_tmp13_ = item;
			if (_tmp13_ != NULL) {
				NetworkVPNMenuItem* _tmp14_;
				NMDeviceState _tmp15_;
				NMDeviceState _tmp16_;
				_tmp14_ = item;
				_tmp15_ = network_widgets_page_get_state ((NetworkWidgetsPage*) self);
				_tmp16_ = _tmp15_;
				network_vpn_menu_item_set_state (_tmp14_, _tmp16_);
			}
			_g_object_unref0 (ac);
		}
	}
	_tmp17_ = self->priv->_owner;
	_tmp18_ = network_widgets_page_get_state ((NetworkWidgetsPage*) self);
	_tmp19_ = _tmp18_;
	network_widgets_device_item_switch_status (_tmp17_, NETWORK_UTILS_CUSTOM_MODE_INVALID, &_tmp19_);
	network_widgets_page_update_switch ((NetworkWidgetsPage*) self);
	_g_object_unref0 (item);
}

static void
network_vpn_page_real_update_switch (NetworkWidgetsPage* base)
{
	NetworkVPNPage * self;
	self = (NetworkVPNPage*) base;
}

static void
network_vpn_page_real_control_switch_activated (NetworkWidgetsPage* base)
{
	NetworkVPNPage * self;
	self = (NetworkVPNPage*) base;
}

void
network_vpn_page_add_connection (NetworkVPNPage* self,
                                 NMRemoteConnection* connection)
{
	NetworkVPNMenuItem* item = NULL;
	NetworkVPNMenuItem* _tmp0_;
	GtkListBox* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	_tmp0_ = network_vpn_menu_item_new (connection);
	g_object_ref_sink (_tmp0_);
	item = _tmp0_;
	_tmp1_ = self->priv->vpn_list;
	gtk_container_add ((GtkContainer*) _tmp1_, (GtkWidget*) item);
	network_widgets_page_update ((NetworkWidgetsPage*) self);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (item);
}

void
network_vpn_page_remove_connection (NetworkVPNPage* self,
                                    NMRemoteConnection* connection)
{
	NetworkVPNMenuItem* item = NULL;
	const gchar* _tmp0_;
	NetworkVPNMenuItem* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	_tmp0_ = nm_connection_get_uuid ((NMConnection*) connection);
	_tmp1_ = network_vpn_page_get_item_by_uuid (self, _tmp0_);
	item = _tmp1_;
	gtk_widget_destroy ((GtkWidget*) item);
	_g_object_unref0 (item);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static NetworkVPNMenuItem*
network_vpn_page_get_item_by_uuid (NetworkVPNPage* self,
                                   const gchar* uuid)
{
	NetworkVPNMenuItem* item = NULL;
	GtkListBox* _tmp0_;
	GList* _tmp1_;
	NetworkVPNMenuItem* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (uuid != NULL, NULL);
	item = NULL;
	_tmp0_ = self->priv->vpn_list;
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
		child_collection = _tmp1_;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* child = NULL;
			child = (GtkWidget*) child_it->data;
			{
				NetworkVPNMenuItem* _item = NULL;
				GtkWidget* _tmp2_;
				NetworkVPNMenuItem* _tmp3_;
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
				NetworkVPNMenuItem* _tmp6_;
				NMRemoteConnection* _tmp7_;
				NMRemoteConnection* _tmp8_;
				_tmp2_ = child;
				_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem));
				_item = _tmp3_;
				_tmp6_ = _item;
				_tmp7_ = network_vpn_menu_item_get_connection (_tmp6_);
				_tmp8_ = _tmp7_;
				if (_tmp8_ != NULL) {
					NetworkVPNMenuItem* _tmp9_;
					NMRemoteConnection* _tmp10_;
					NMRemoteConnection* _tmp11_;
					const gchar* _tmp12_;
					_tmp9_ = _item;
					_tmp10_ = network_vpn_menu_item_get_connection (_tmp9_);
					_tmp11_ = _tmp10_;
					_tmp12_ = nm_connection_get_uuid ((NMConnection*) _tmp11_);
					_tmp5_ = g_strcmp0 (_tmp12_, uuid) == 0;
				} else {
					_tmp5_ = FALSE;
				}
				if (_tmp5_) {
					NetworkVPNMenuItem* _tmp13_;
					_tmp13_ = item;
					_tmp4_ = _tmp13_ == NULL;
				} else {
					_tmp4_ = FALSE;
				}
				if (_tmp4_) {
					GtkWidget* _tmp14_;
					NetworkVPNMenuItem* _tmp15_;
					_tmp14_ = child;
					_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem));
					_g_object_unref0 (item);
					item = _tmp15_;
				}
				_g_object_unref0 (_item);
			}
		}
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
	}
	result = item;
	return result;
}

static void
_network_widgets_page_update_nm_vpn_connection_vpn_state_changed (NMVpnConnection* _sender,
                                                                  guint object,
                                                                  guint p0,
                                                                  gpointer self)
{
	network_widgets_page_update ((NetworkWidgetsPage*) self);
}

static void
__lambda25_ (NetworkVPNPage* self,
             NMActiveConnection* ac)
{
	g_return_if_fail (ac != NULL);
	if (nm_active_connection_get_vpn (ac)) {
		GeeList* _tmp0_;
		_tmp0_ = self->priv->active_connections;
		gee_collection_add ((GeeCollection*) _tmp0_, G_TYPE_CHECK_INSTANCE_CAST (ac, nm_vpn_connection_get_type (), NMVpnConnection));
		g_signal_connect_object (G_TYPE_CHECK_INSTANCE_TYPE (ac, nm_vpn_connection_get_type ()) ? ((NMVpnConnection*) ac) : NULL, "vpn-state-changed", (GCallback) _network_widgets_page_update_nm_vpn_connection_vpn_state_changed, (NetworkWidgetsPage*) self, 0);
	}
}

static void
___lambda25__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda25_ ((NetworkVPNPage*) self, (NMActiveConnection*) data);
}

static void
network_vpn_page_update_active_connections (NetworkVPNPage* self)
{
	GeeList* _tmp0_;
	NetworkNetworkManager* network_manager = NULL;
	NetworkNetworkManager* _tmp1_;
	NMClient* _tmp2_;
	NMClient* _tmp3_;
	GPtrArray* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->active_connections;
	gee_collection_clear ((GeeCollection*) _tmp0_);
	_tmp1_ = network_network_manager_get_default ();
	network_manager = _tmp1_;
	_tmp2_ = network_network_manager_get_client (network_manager);
	_tmp3_ = _tmp2_;
	_tmp4_ = nm_client_get_active_connections (_tmp3_);
	g_ptr_array_foreach (_tmp4_, ___lambda25__gfunc, self);
}

static void
network_vpn_page_connect_vpn_cb (NetworkVPNPage* self,
                                 NetworkVPNMenuItem* item)
{
	NetworkNetworkManager* network_manager = NULL;
	NetworkNetworkManager* _tmp0_;
	NMClient* _tmp1_;
	NMClient* _tmp2_;
	NMRemoteConnection* _tmp3_;
	NMRemoteConnection* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	network_vpn_page_update_active_connections (self);
	_tmp0_ = network_network_manager_get_default ();
	network_manager = _tmp0_;
	_tmp1_ = network_network_manager_get_client (network_manager);
	_tmp2_ = _tmp1_;
	_tmp3_ = network_vpn_menu_item_get_connection (item);
	_tmp4_ = _tmp3_;
	nm_client_activate_connection_async (_tmp2_, (NMConnection*) _tmp4_, NULL, NULL, NULL, NULL, NULL);
	network_widgets_page_update ((NetworkWidgetsPage*) self);
}

static void
network_vpn_page_disconnect_vpn_cb (NetworkVPNPage* self,
                                    NetworkVPNMenuItem* item)
{
	NetworkNetworkManager* network_manager = NULL;
	NetworkNetworkManager* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	network_vpn_page_update_active_connections (self);
	_tmp0_ = network_network_manager_get_default ();
	network_manager = _tmp0_;
	{
		GeeList* _ac_list = NULL;
		GeeList* _tmp1_;
		gint _ac_size = 0;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _ac_index = 0;
		_tmp1_ = self->priv->active_connections;
		_ac_list = _tmp1_;
		_tmp2_ = _ac_list;
		_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_ac_size = _tmp4_;
		_ac_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			NMVpnConnection* ac = NULL;
			GeeList* _tmp7_;
			gpointer _tmp8_;
			NMVpnConnection* _tmp9_;
			NMRemoteConnection* _tmp10_;
			NMRemoteConnection* _tmp11_;
			NMRemoteConnection* _tmp12_;
			_ac_index = _ac_index + 1;
			_tmp5_ = _ac_index;
			_tmp6_ = _ac_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _ac_list;
			_tmp8_ = gee_list_get (_tmp7_, _ac_index);
			ac = (NMVpnConnection*) _tmp8_;
			_tmp9_ = ac;
			_tmp10_ = nm_active_connection_get_connection ((NMActiveConnection*) _tmp9_);
			_tmp11_ = network_vpn_menu_item_get_connection (item);
			_tmp12_ = _tmp11_;
			if (_tmp10_ == _tmp12_) {
				{
					NetworkNetworkManager* _tmp13_;
					NMClient* _tmp14_;
					NMClient* _tmp15_;
					NMVpnConnection* _tmp16_;
					_tmp13_ = network_manager;
					_tmp14_ = network_network_manager_get_client (_tmp13_);
					_tmp15_ = _tmp14_;
					_tmp16_ = ac;
					nm_client_deactivate_connection (_tmp15_, (NMActiveConnection*) _tmp16_, NULL, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch0_g_error;
					}
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp17_;
					const gchar* _tmp18_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp17_ = e;
					_tmp18_ = _tmp17_->message;
					g_warning ("VPNPage.vala:234: %s", _tmp18_);
					_g_error_free0 (e);
				}
				__finally0:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (ac);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
				_g_object_unref0 (ac);
				break;
			}
			_g_object_unref0 (ac);
		}
	}
	network_widgets_page_update ((NetworkWidgetsPage*) self);
}

static gboolean
____lambda26_ (NetworkVPNPage* self)
{
	gboolean result;
	self->priv->timeout_id = (guint) 0;
	network_vpn_page_delete_connection (self);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
_____lambda26__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda26_ ((NetworkVPNPage*) self);
	return result;
}

static void
network_vpn_page_remove_button_cb (NetworkVPNPage* self)
{
	GtkListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	NetworkVPNMenuItem* _tmp2_;
	NetworkVPNMenuItem* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->vpn_list;
	_tmp1_ = gtk_list_box_get_selected_row (_tmp0_);
	_tmp2_ = _g_object_ref0 (NETWORK_IS_VPN_MENU_ITEM (_tmp1_) ? ((NetworkVPNMenuItem*) _tmp1_) : NULL);
	_g_object_unref0 (self->priv->sel_row);
	self->priv->sel_row = _tmp2_;
	_tmp3_ = self->priv->sel_row;
	if (_tmp3_ != NULL) {
		gboolean _tmp4_ = FALSE;
		NetworkVPNMenuItem* _tmp5_;
		NMDeviceState _tmp6_;
		NMDeviceState _tmp7_;
		_tmp5_ = self->priv->sel_row;
		_tmp6_ = network_vpn_menu_item_get_state (_tmp5_);
		_tmp7_ = _tmp6_;
		if (_tmp7_ == NM_DEVICE_STATE_ACTIVATED) {
			_tmp4_ = TRUE;
		} else {
			NetworkVPNMenuItem* _tmp8_;
			NMDeviceState _tmp9_;
			NMDeviceState _tmp10_;
			_tmp8_ = self->priv->sel_row;
			_tmp9_ = network_vpn_menu_item_get_state (_tmp8_);
			_tmp10_ = _tmp9_;
			_tmp4_ = _tmp10_ == NM_DEVICE_STATE_PREPARE;
		}
		if (_tmp4_) {
			GraniteMessageDialog* dialog = NULL;
			GThemedIcon* _tmp11_;
			GThemedIcon* _tmp12_;
			GThemedIcon* _tmp13_;
			GtkWidget* _tmp14_;
			GtkWindow* _tmp15_;
			GraniteMessageDialog* _tmp16_ = NULL;
			GraniteMessageDialog* _tmp17_;
			GraniteMessageDialog* _tmp18_;
			GraniteMessageDialog* _tmp19_;
			_tmp11_ = (GThemedIcon*) g_themed_icon_new ("network-vpn");
			_tmp12_ = _tmp11_;
			_tmp13_ = (GThemedIcon*) g_themed_icon_new ("dialog-error");
			_tmp14_ = gtk_widget_get_toplevel ((GtkWidget*) self);
			_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_window_get_type (), GtkWindow));
			_tmp16_ = granite_message_dialog_new (_ ("Failed to remove VPN connection"), _ ("Cannot remove an active VPN connection."), (GIcon*) _tmp12_, GTK_BUTTONS_CLOSE);
			granite_message_dialog_set_badge_icon (_tmp16_, (GIcon*) _tmp13_);
			_g_object_unref0 (_tmp13_);
			gtk_window_set_transient_for ((GtkWindow*) _tmp16_, _tmp15_);
			_g_object_unref0 (_tmp15_);
			g_object_ref_sink (_tmp16_);
			_tmp17_ = _tmp16_;
			_g_object_unref0 (_tmp12_);
			dialog = _tmp17_;
			_tmp18_ = dialog;
			gtk_dialog_run ((GtkDialog*) _tmp18_);
			_tmp19_ = dialog;
			gtk_widget_destroy ((GtkWidget*) _tmp19_);
			_g_object_unref0 (dialog);
			return;
		} else {
			GraniteWidgetsToast* _tmp20_;
			NetworkVPNMenuItem* _tmp21_;
			_tmp20_ = self->priv->remove_vpn_toast;
			granite_widgets_toast_send_notification (_tmp20_);
			_tmp21_ = self->priv->sel_row;
			gtk_widget_hide ((GtkWidget*) _tmp21_);
			self->priv->timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 3600, _____lambda26__gsource_func, g_object_ref (self), g_object_unref);
		}
	}
}

static void
network_vpn_page_try_connection_editor (NetworkVPNPage* self,
                                        const gchar* args)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (args != NULL);
	{
		GAppInfo* appinfo = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GAppInfo* _tmp2_;
		GAppInfo* _tmp3_;
		GAppInfo* _tmp4_;
		_tmp0_ = g_strdup_printf ("nm-connection-editor %s", args);
		_tmp1_ = _tmp0_;
		_tmp2_ = g_app_info_create_from_commandline (_tmp1_, NULL, G_APP_INFO_CREATE_NONE, &_inner_error0_);
		_tmp3_ = _tmp2_;
		_g_free0 (_tmp1_);
		appinfo = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp4_ = appinfo;
		g_app_info_launch (_tmp4_, NULL, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (appinfo);
			goto __catch0_g_error;
		}
		_g_object_unref0 (appinfo);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GraniteMessageDialog* dialog = NULL;
		GThemedIcon* _tmp5_;
		GThemedIcon* _tmp6_;
		GThemedIcon* _tmp7_;
		GtkWidget* _tmp8_;
		GtkWindow* _tmp9_;
		GraniteMessageDialog* _tmp10_ = NULL;
		GraniteMessageDialog* _tmp11_;
		GraniteMessageDialog* _tmp12_;
		GError* _tmp13_;
		const gchar* _tmp14_;
		GraniteMessageDialog* _tmp15_;
		GraniteMessageDialog* _tmp16_;
		_error_ = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp5_ = (GThemedIcon*) g_themed_icon_new ("network-vpn");
		_tmp6_ = _tmp5_;
		_tmp7_ = (GThemedIcon*) g_themed_icon_new ("dialog-error");
		_tmp8_ = gtk_widget_get_toplevel ((GtkWidget*) self);
		_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_window_get_type (), GtkWindow));
		_tmp10_ = granite_message_dialog_new (_ ("Failed to run Connection Editor"), _ ("The program \"nm-connection-editor\" may not be installed."), (GIcon*) _tmp6_, GTK_BUTTONS_CLOSE);
		granite_message_dialog_set_badge_icon (_tmp10_, (GIcon*) _tmp7_);
		_g_object_unref0 (_tmp7_);
		gtk_window_set_transient_for ((GtkWindow*) _tmp10_, _tmp9_);
		_g_object_unref0 (_tmp9_);
		g_object_ref_sink (_tmp10_);
		_tmp11_ = _tmp10_;
		_g_object_unref0 (_tmp6_);
		dialog = _tmp11_;
		_tmp12_ = dialog;
		_tmp13_ = _error_;
		_tmp14_ = _tmp13_->message;
		granite_message_dialog_show_error_details (_tmp12_, _tmp14_);
		_tmp15_ = dialog;
		gtk_dialog_run ((GtkDialog*) _tmp15_);
		_tmp16_ = dialog;
		gtk_widget_destroy ((GtkWidget*) _tmp16_);
		_g_object_unref0 (dialog);
		_g_error_free0 (_error_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
network_vpn_page_delete_connection (NetworkVPNPage* self)
{
	NetworkVPNMenuItem* selected_row = NULL;
	GtkListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	NetworkVPNMenuItem* _tmp2_;
	gboolean _tmp3_ = FALSE;
	NetworkVPNMenuItem* _tmp4_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->vpn_list;
	_tmp1_ = gtk_list_box_get_selected_row (_tmp0_);
	_tmp2_ = _g_object_ref0 (NETWORK_IS_VPN_MENU_ITEM (_tmp1_) ? ((NetworkVPNMenuItem*) _tmp1_) : NULL);
	selected_row = _tmp2_;
	_tmp4_ = selected_row;
	if (_tmp4_ != NULL) {
		NetworkVPNMenuItem* _tmp5_;
		_tmp5_ = self->priv->sel_row;
		_tmp3_ = _tmp5_ != NULL;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		NetworkVPNMenuItem* _tmp6_;
		NetworkVPNMenuItem* _tmp7_;
		_tmp6_ = self->priv->sel_row;
		_tmp7_ = selected_row;
		if (_tmp6_ == _tmp7_) {
			{
				NetworkVPNMenuItem* _tmp8_;
				NMRemoteConnection* _tmp9_;
				NMRemoteConnection* _tmp10_;
				_tmp8_ = selected_row;
				_tmp9_ = network_vpn_menu_item_get_connection (_tmp8_);
				_tmp10_ = _tmp9_;
				nm_remote_connection_delete (_tmp10_, NULL, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch0_g_error;
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				GError* _tmp11_;
				const gchar* _tmp12_;
				GraniteMessageDialog* dialog = NULL;
				GThemedIcon* _tmp13_;
				GThemedIcon* _tmp14_;
				GThemedIcon* _tmp15_;
				GtkWidget* _tmp16_;
				GtkWindow* _tmp17_;
				GraniteMessageDialog* _tmp18_ = NULL;
				GraniteMessageDialog* _tmp19_;
				GraniteMessageDialog* _tmp20_;
				GError* _tmp21_;
				const gchar* _tmp22_;
				GraniteMessageDialog* _tmp23_;
				GraniteMessageDialog* _tmp24_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp11_ = e;
				_tmp12_ = _tmp11_->message;
				g_warning ("VPNPage.vala:302: %s", _tmp12_);
				_tmp13_ = (GThemedIcon*) g_themed_icon_new ("network-vpn");
				_tmp14_ = _tmp13_;
				_tmp15_ = (GThemedIcon*) g_themed_icon_new ("dialog-error");
				_tmp16_ = gtk_widget_get_toplevel ((GtkWidget*) self);
				_tmp17_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_window_get_type (), GtkWindow));
				_tmp18_ = granite_message_dialog_new (_ ("Failed to remove VPN connection"), "", (GIcon*) _tmp14_, GTK_BUTTONS_CLOSE);
				granite_message_dialog_set_badge_icon (_tmp18_, (GIcon*) _tmp15_);
				_g_object_unref0 (_tmp15_);
				gtk_window_set_transient_for ((GtkWindow*) _tmp18_, _tmp17_);
				_g_object_unref0 (_tmp17_);
				g_object_ref_sink (_tmp18_);
				_tmp19_ = _tmp18_;
				_g_object_unref0 (_tmp14_);
				dialog = _tmp19_;
				_tmp20_ = dialog;
				_tmp21_ = e;
				_tmp22_ = _tmp21_->message;
				granite_message_dialog_show_error_details (_tmp20_, _tmp22_);
				_tmp23_ = dialog;
				gtk_dialog_run ((GtkDialog*) _tmp23_);
				_tmp24_ = dialog;
				gtk_widget_destroy ((GtkWidget*) _tmp24_);
				_g_object_unref0 (dialog);
				_g_error_free0 (e);
			}
			__finally0:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (selected_row);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		} else {
			NetworkVPNMenuItem* _tmp25_;
			g_warning ("VPNPage.vala:317: Row selection changed between operations. Cancelling" \
" removal of VPN.");
			g_source_remove (self->priv->timeout_id);
			self->priv->timeout_id = (guint) 0;
			_tmp25_ = self->priv->sel_row;
			gtk_widget_show ((GtkWidget*) _tmp25_);
		}
	}
	_g_object_unref0 (selected_row);
}

static gint
network_vpn_page_compare_rows (NetworkVPNMenuItem* row1,
                               NetworkVPNMenuItem* row2,
                               NetworkVPNPage* self)
{
	NMSettingConnection* vpn_menu_item1 = NULL;
	NMRemoteConnection* _tmp0_;
	NMRemoteConnection* _tmp1_;
	NMSettingConnection* _tmp2_;
	NMSettingConnection* vpn_menu_item2 = NULL;
	NMRemoteConnection* _tmp3_;
	NMRemoteConnection* _tmp4_;
	NMSettingConnection* _tmp5_;
	gboolean _tmp6_ = FALSE;
	NMSettingConnection* _tmp7_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (row1 != NULL, 0);
	g_return_val_if_fail (row2 != NULL, 0);
	_tmp0_ = network_vpn_menu_item_get_connection (row1);
	_tmp1_ = _tmp0_;
	_tmp2_ = nm_connection_get_setting_connection ((NMConnection*) _tmp1_);
	vpn_menu_item1 = _tmp2_;
	_tmp3_ = network_vpn_menu_item_get_connection (row2);
	_tmp4_ = _tmp3_;
	_tmp5_ = nm_connection_get_setting_connection ((NMConnection*) _tmp4_);
	vpn_menu_item2 = _tmp5_;
	_tmp7_ = vpn_menu_item1;
	if (_tmp7_ != NULL) {
		NMSettingConnection* _tmp8_;
		_tmp8_ = vpn_menu_item2;
		_tmp6_ = _tmp8_ != NULL;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		NMSettingConnection* _tmp9_;
		NMSettingConnection* _tmp10_;
		_tmp9_ = vpn_menu_item1;
		_tmp10_ = vpn_menu_item2;
		if (nm_setting_connection_get_timestamp (_tmp9_) > nm_setting_connection_get_timestamp (_tmp10_)) {
			result = -1;
			return result;
		}
	}
	result = 1;
	return result;
}

NetworkWidgetsDeviceItem*
network_vpn_page_get_owner (NetworkVPNPage* self)
{
	NetworkWidgetsDeviceItem* result;
	NetworkWidgetsDeviceItem* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_owner;
	result = _tmp0_;
	return result;
}

static void
network_vpn_page_set_owner (NetworkVPNPage* self,
                            NetworkWidgetsDeviceItem* value)
{
	NetworkWidgetsDeviceItem* old_value;
	g_return_if_fail (self != NULL);
	old_value = network_vpn_page_get_owner (self);
	if (old_value != value) {
		NetworkWidgetsDeviceItem* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_owner);
		self->priv->_owner = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, network_vpn_page_properties[NETWORK_VPN_PAGE_OWNER_PROPERTY]);
	}
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		NetworkVPNPage* self;
		self = _data4_->self;
		_g_object_unref0 (_data4_->edit_connection_button);
		_g_object_unref0 (_data4_->remove_button);
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}

static void
_network_vpn_page___lambda27_ (NetworkVPNPage* self)
{
	network_vpn_page_try_connection_editor (self, "--create --type=vpn");
}

static void
__network_vpn_page___lambda27__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
	_network_vpn_page___lambda27_ ((NetworkVPNPage*) self);
}

static void
_network_vpn_page_remove_button_cb_gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
	network_vpn_page_remove_button_cb ((NetworkVPNPage*) self);
}

static void
_network_vpn_page___lambda28_ (NetworkVPNPage* self)
{
	NetworkVPNMenuItem* _tmp0_;
	g_source_remove (self->priv->timeout_id);
	self->priv->timeout_id = (guint) 0;
	_tmp0_ = self->priv->sel_row;
	gtk_widget_show ((GtkWidget*) _tmp0_);
}

static void
__network_vpn_page___lambda28__granite_widgets_toast_default_action (GraniteWidgetsToast* _sender,
                                                                     gpointer self)
{
	_network_vpn_page___lambda28_ ((NetworkVPNPage*) self);
}

static void
_network_vpn_page___lambda29_ (NetworkVPNPage* self)
{
	NetworkVPNMenuItem* selected_row = NULL;
	GtkListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	NetworkVPNMenuItem* _tmp2_;
	NetworkVPNMenuItem* _tmp3_;
	NMRemoteConnection* _tmp4_;
	NMRemoteConnection* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	_tmp0_ = self->priv->vpn_list;
	_tmp1_ = gtk_list_box_get_selected_row (_tmp0_);
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem));
	selected_row = _tmp2_;
	_tmp3_ = selected_row;
	_tmp4_ = network_vpn_menu_item_get_connection (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = nm_connection_get_uuid ((NMConnection*) _tmp5_);
	_tmp7_ = g_strconcat ("--edit=", _tmp6_, NULL);
	_tmp8_ = _tmp7_;
	network_vpn_page_try_connection_editor (self, _tmp8_);
	_g_free0 (_tmp8_);
	_g_object_unref0 (selected_row);
}

static void
__network_vpn_page___lambda29__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
	_network_vpn_page___lambda29_ ((NetworkVPNPage*) self);
}

static void
_network_vpn_page___lambda30_ (NetworkVPNPage* self,
                               GtkListBoxRow* row)
{
	NMDeviceState _tmp0_;
	NMDeviceState _tmp1_;
	g_return_if_fail (row != NULL);
	_tmp0_ = network_vpn_menu_item_get_state (G_TYPE_CHECK_INSTANCE_CAST (row, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem));
	_tmp1_ = _tmp0_;
	if (_tmp1_ == NM_DEVICE_STATE_ACTIVATED) {
		network_vpn_page_disconnect_vpn_cb (self, G_TYPE_CHECK_INSTANCE_CAST (row, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem));
	} else {
		network_vpn_page_connect_vpn_cb (self, G_TYPE_CHECK_INSTANCE_CAST (row, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVPNMenuItem));
	}
}

static void
__network_vpn_page___lambda30__gtk_list_box_row_activated (GtkListBox* _sender,
                                                           GtkListBoxRow* row,
                                                           gpointer self)
{
	_network_vpn_page___lambda30_ ((NetworkVPNPage*) self, row);
}

static void
_network_vpn_page___lambda31_ (Block4Data* _data4_,
                               GtkListBoxRow* row)
{
	NetworkVPNPage* self;
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	self = _data4_->self;
	_tmp0_ = _data4_->remove_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, row != NULL);
	_tmp1_ = _data4_->edit_connection_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, row != NULL);
}

static void
__network_vpn_page___lambda31__gtk_list_box_row_selected (GtkListBox* _sender,
                                                          GtkListBoxRow* row,
                                                          gpointer self)
{
	_network_vpn_page___lambda31_ (self, row);
}

static void
_network_vpn_page_update_active_connections_g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self)
{
	network_vpn_page_update_active_connections ((NetworkVPNPage*) self);
}

static GObject *
network_vpn_page_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkVPNPage * self;
	Block4Data* _data4_;
	GraniteWidgetsToast* _tmp0_;
	GraniteWidgetsToast* _tmp1_;
	GraniteWidgetsAlertView* placeholder = NULL;
	GraniteWidgetsAlertView* _tmp2_;
	GraniteWidgetsAlertView* _tmp3_;
	GtkListBox* _tmp4_ = NULL;
	GtkListBox* _tmp5_;
	GraniteWidgetsAlertView* _tmp6_;
	GtkListBox* _tmp7_;
	GtkActionBar* actionbar = NULL;
	GtkActionBar* _tmp8_;
	GtkActionBar* _tmp9_;
	GtkStyleContext* _tmp10_;
	GtkButton* add_button = NULL;
	gchar* _tmp11_;
	GtkButton* _tmp12_ = NULL;
	GtkButton* _tmp13_;
	gchar* _tmp14_;
	GtkButton* _tmp15_ = NULL;
	GtkButton* _tmp16_;
	GraniteWidgetsToast* _tmp17_;
	gchar* _tmp18_;
	GtkButton* _tmp19_ = NULL;
	GtkButton* _tmp20_;
	GtkActionBar* _tmp21_;
	GtkButton* _tmp22_;
	GtkActionBar* _tmp23_;
	GtkButton* _tmp24_;
	GtkActionBar* _tmp25_;
	GtkButton* _tmp26_;
	GtkScrolledWindow* scrolled = NULL;
	GtkScrolledWindow* _tmp27_ = NULL;
	GtkScrolledWindow* _tmp28_;
	GtkListBox* _tmp29_;
	GtkGrid* list_root = NULL;
	GtkGrid* _tmp30_;
	GtkGrid* _tmp31_;
	GtkScrolledWindow* _tmp32_;
	GtkGrid* _tmp33_;
	GtkActionBar* _tmp34_;
	GtkFrame* frame = NULL;
	GtkFrame* _tmp35_ = NULL;
	GtkFrame* _tmp36_;
	GtkStyleContext* _tmp37_;
	GtkFrame* _tmp38_;
	GtkGrid* _tmp39_;
	GtkOverlay* main_overlay = NULL;
	GtkOverlay* _tmp40_;
	GtkOverlay* _tmp41_;
	GtkFrame* _tmp42_;
	GtkOverlay* _tmp43_;
	GraniteWidgetsToast* _tmp44_;
	GtkGrid* _tmp45_;
	GtkGrid* _tmp46_;
	GtkOverlay* _tmp47_;
	GtkListBox* _tmp48_;
	GtkListBox* _tmp49_;
	GeeArrayList* _tmp50_;
	NetworkNetworkManager* network_manager = NULL;
	NetworkNetworkManager* _tmp51_;
	NetworkNetworkManager* _tmp52_;
	NMClient* _tmp53_;
	NMClient* _tmp54_;
	parent_class = G_OBJECT_CLASS (network_vpn_page_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_VPN_PAGE, NetworkVPNPage);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = g_object_ref (self);
	_tmp0_ = granite_widgets_toast_new (_ ("VPN removed"));
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->remove_vpn_toast);
	self->priv->remove_vpn_toast = _tmp0_;
	_tmp1_ = self->priv->remove_vpn_toast;
	granite_widgets_toast_set_default_action (_tmp1_, _ ("Undo"));
	_tmp2_ = granite_widgets_alert_view_new (_ ("No VPN Connections"), _ ("Add a new VPN connection to begin."), "");
	g_object_ref_sink (_tmp2_);
	placeholder = _tmp2_;
	_tmp3_ = placeholder;
	gtk_widget_show_all ((GtkWidget*) _tmp3_);
	_tmp4_ = (GtkListBox*) gtk_list_box_new ();
	gtk_list_box_set_activate_on_single_click (_tmp4_, FALSE);
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, TRUE);
	gtk_list_box_set_selection_mode (_tmp4_, GTK_SELECTION_BROWSE);
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->vpn_list);
	self->priv->vpn_list = _tmp4_;
	_tmp5_ = self->priv->vpn_list;
	_tmp6_ = placeholder;
	gtk_list_box_set_placeholder (_tmp5_, (GtkWidget*) _tmp6_);
	_tmp7_ = self->priv->vpn_list;
	gtk_list_box_set_sort_func (_tmp7_, (GtkListBoxSortFunc) network_vpn_page_compare_rows, g_object_ref (self), g_object_unref);
	_tmp8_ = (GtkActionBar*) gtk_action_bar_new ();
	g_object_ref_sink (_tmp8_);
	actionbar = _tmp8_;
	_tmp9_ = actionbar;
	_tmp10_ = gtk_widget_get_style_context ((GtkWidget*) _tmp9_);
	gtk_style_context_add_class (_tmp10_, GTK_STYLE_CLASS_INLINE_TOOLBAR);
	_tmp11_ = g_strdup (_ ("Add VPN Connection…"));
	_tmp12_ = (GtkButton*) gtk_button_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp12_, _tmp11_);
	_g_free0 (_tmp11_);
	g_object_ref_sink (_tmp12_);
	add_button = _tmp12_;
	_tmp13_ = add_button;
	g_signal_connect_object (_tmp13_, "clicked", (GCallback) __network_vpn_page___lambda27__gtk_button_clicked, self, 0);
	_tmp14_ = g_strdup (_ ("Forget selected VPN…"));
	_tmp15_ = (GtkButton*) gtk_button_new_from_icon_name ("list-remove-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp15_, _tmp14_);
	_g_free0 (_tmp14_);
	gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, FALSE);
	g_object_ref_sink (_tmp15_);
	_data4_->remove_button = _tmp15_;
	_tmp16_ = _data4_->remove_button;
	g_signal_connect_object (_tmp16_, "clicked", (GCallback) _network_vpn_page_remove_button_cb_gtk_button_clicked, self, 0);
	_tmp17_ = self->priv->remove_vpn_toast;
	g_signal_connect_object (_tmp17_, "default-action", (GCallback) __network_vpn_page___lambda28__granite_widgets_toast_default_action, self, 0);
	_tmp18_ = g_strdup (_ ("Edit VPN connection…"));
	_tmp19_ = (GtkButton*) gtk_button_new_from_icon_name ("preferences-system-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp19_, _tmp18_);
	_g_free0 (_tmp18_);
	gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, FALSE);
	g_object_ref_sink (_tmp19_);
	_data4_->edit_connection_button = _tmp19_;
	_tmp20_ = _data4_->edit_connection_button;
	g_signal_connect_object (_tmp20_, "clicked", (GCallback) __network_vpn_page___lambda29__gtk_button_clicked, self, 0);
	_tmp21_ = actionbar;
	_tmp22_ = add_button;
	gtk_container_add ((GtkContainer*) _tmp21_, (GtkWidget*) _tmp22_);
	_tmp23_ = actionbar;
	_tmp24_ = _data4_->remove_button;
	gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
	_tmp25_ = actionbar;
	_tmp26_ = _data4_->edit_connection_button;
	gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) _tmp26_);
	_tmp27_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_set ((GtkWidget*) _tmp27_, "expand", TRUE, NULL);
	g_object_ref_sink (_tmp27_);
	scrolled = _tmp27_;
	_tmp28_ = scrolled;
	_tmp29_ = self->priv->vpn_list;
	gtk_container_add ((GtkContainer*) _tmp28_, (GtkWidget*) _tmp29_);
	_tmp30_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp30_);
	list_root = _tmp30_;
	_tmp31_ = list_root;
	_tmp32_ = scrolled;
	gtk_grid_attach (_tmp31_, (GtkWidget*) _tmp32_, 0, 0, 1, 1);
	_tmp33_ = list_root;
	_tmp34_ = actionbar;
	gtk_grid_attach (_tmp33_, (GtkWidget*) _tmp34_, 0, 1, 1, 1);
	_tmp35_ = (GtkFrame*) gtk_frame_new (NULL);
	gtk_widget_set_vexpand ((GtkWidget*) _tmp35_, TRUE);
	g_object_ref_sink (_tmp35_);
	frame = _tmp35_;
	_tmp36_ = frame;
	_tmp37_ = gtk_widget_get_style_context ((GtkWidget*) _tmp36_);
	gtk_style_context_add_class (_tmp37_, GTK_STYLE_CLASS_VIEW);
	_tmp38_ = frame;
	_tmp39_ = list_root;
	gtk_container_add ((GtkContainer*) _tmp38_, (GtkWidget*) _tmp39_);
	_tmp40_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp40_);
	main_overlay = _tmp40_;
	_tmp41_ = main_overlay;
	_tmp42_ = frame;
	gtk_container_add ((GtkContainer*) _tmp41_, (GtkWidget*) _tmp42_);
	_tmp43_ = main_overlay;
	_tmp44_ = self->priv->remove_vpn_toast;
	gtk_overlay_add_overlay (_tmp43_, (GtkWidget*) _tmp44_);
	_tmp45_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp46_ = _tmp45_;
	_tmp47_ = main_overlay;
	gtk_container_add ((GtkContainer*) _tmp46_, (GtkWidget*) _tmp47_);
	gtk_widget_show_all ((GtkWidget*) self);
	_tmp48_ = self->priv->vpn_list;
	g_signal_connect_object (_tmp48_, "row-activated", (GCallback) __network_vpn_page___lambda30__gtk_list_box_row_activated, self, 0);
	_tmp49_ = self->priv->vpn_list;
	g_signal_connect_data (_tmp49_, "row-selected", (GCallback) __network_vpn_page___lambda31__gtk_list_box_row_selected, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
	_tmp50_ = gee_array_list_new (nm_vpn_connection_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->active_connections);
	self->priv->active_connections = (GeeList*) _tmp50_;
	network_widgets_page_update ((NetworkWidgetsPage*) self);
	_tmp51_ = network_network_manager_get_default ();
	network_manager = _tmp51_;
	_tmp52_ = network_manager;
	_tmp53_ = network_network_manager_get_client (_tmp52_);
	_tmp54_ = _tmp53_;
	g_signal_connect_object ((GObject*) _tmp54_, "notify::active-connections", (GCallback) _network_vpn_page_update_active_connections_g_object_notify, self, 0);
	_g_object_unref0 (main_overlay);
	_g_object_unref0 (frame);
	_g_object_unref0 (list_root);
	_g_object_unref0 (scrolled);
	_g_object_unref0 (add_button);
	_g_object_unref0 (actionbar);
	_g_object_unref0 (placeholder);
	block4_data_unref (_data4_);
	_data4_ = NULL;
	return obj;
}

static void
network_vpn_page_class_init (NetworkVPNPageClass * klass,
                             gpointer klass_data)
{
	network_vpn_page_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NetworkVPNPage_private_offset);
	((NetworkWidgetsPageClass *) klass)->update = (void (*) (NetworkWidgetsPage*)) network_vpn_page_real_update;
	((NetworkWidgetsPageClass *) klass)->update_switch = (void (*) (NetworkWidgetsPage*)) network_vpn_page_real_update_switch;
	((NetworkWidgetsPageClass *) klass)->control_switch_activated = (void (*) (NetworkWidgetsPage*)) network_vpn_page_real_control_switch_activated;
	G_OBJECT_CLASS (klass)->get_property = _vala_network_vpn_page_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_network_vpn_page_set_property;
	G_OBJECT_CLASS (klass)->constructor = network_vpn_page_constructor;
	G_OBJECT_CLASS (klass)->finalize = network_vpn_page_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_PAGE_OWNER_PROPERTY, network_vpn_page_properties[NETWORK_VPN_PAGE_OWNER_PROPERTY] = g_param_spec_object ("owner", "owner", "owner", NETWORK_WIDGETS_TYPE_DEVICE_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
network_vpn_page_instance_init (NetworkVPNPage * self,
                                gpointer klass)
{
	self->priv = network_vpn_page_get_instance_private (self);
	self->priv->timeout_id = (guint) 0;
}

static void
network_vpn_page_finalize (GObject * obj)
{
	NetworkVPNPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_VPN_PAGE, NetworkVPNPage);
	_g_object_unref0 (self->priv->_owner);
	_g_object_unref0 (self->priv->active_connections);
	_g_object_unref0 (self->priv->vpn_list);
	_g_object_unref0 (self->priv->sel_row);
	_g_object_unref0 (self->priv->remove_vpn_toast);
	G_OBJECT_CLASS (network_vpn_page_parent_class)->finalize (obj);
}

static GType
network_vpn_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkVPNPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_vpn_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkVPNPage), 0, (GInstanceInitFunc) network_vpn_page_instance_init, NULL };
	GType network_vpn_page_type_id;
	network_vpn_page_type_id = g_type_register_static (NETWORK_WIDGETS_TYPE_PAGE, "NetworkVPNPage", &g_define_type_info, 0);
	NetworkVPNPage_private_offset = g_type_add_instance_private (network_vpn_page_type_id, sizeof (NetworkVPNPagePrivate));
	return network_vpn_page_type_id;
}

GType
network_vpn_page_get_type (void)
{
	static volatile gsize network_vpn_page_type_id__once = 0;
	if (g_once_init_enter (&network_vpn_page_type_id__once)) {
		GType network_vpn_page_type_id;
		network_vpn_page_type_id = network_vpn_page_get_type_once ();
		g_once_init_leave (&network_vpn_page_type_id__once, network_vpn_page_type_id);
	}
	return network_vpn_page_type_id__once;
}

static void
_vala_network_vpn_page_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	NetworkVPNPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_PAGE, NetworkVPNPage);
	switch (property_id) {
		case NETWORK_VPN_PAGE_OWNER_PROPERTY:
		g_value_set_object (value, network_vpn_page_get_owner (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_network_vpn_page_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	NetworkVPNPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_PAGE, NetworkVPNPage);
	switch (property_id) {
		case NETWORK_VPN_PAGE_OWNER_PROPERTY:
		network_vpn_page_set_owner (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

