/* WifiPage.c generated by valac 0.56.2, the Vala compiler
 * generated from WifiPage.vala, do not modify */

/*-
 * Copyright (c) 2015-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include "networking.h"
#include <NetworkManager.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <nma-wifi-dialog.h>
#include <gio/gio.h>
#include <pango/pango.h>

enum  {
	NETWORK_WIFI_INTERFACE_0_PROPERTY,
	NETWORK_WIFI_INTERFACE_NUM_PROPERTIES
};
static GParamSpec* network_wifi_interface_properties[NETWORK_WIFI_INTERFACE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _rf_kill_device_unref0(var) ((var == NULL) ? NULL : (var = (rf_kill_device_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block5Data Block5Data;
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
typedef struct _Block6Data Block6Data;
typedef struct _Block7Data Block7Data;
typedef struct _Block8Data Block8Data;
typedef struct _NetworkWifiInterfaceConnectToNetworkData NetworkWifiInterfaceConnectToNetworkData;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _NetworkWifiInterfacePrivate {
	RFKillManager* rfkill;
	NMAccessPoint* active_ap;
	GtkListBox* wifi_list;
	NetworkWifiMenuItem* _active_wifi_item;
	GtkStack* placeholder;
	gboolean locked;
	gboolean software_locked;
	gboolean hardware_locked;
	guint timeout_scan;
};

struct _Block5Data {
	int _ref_count_;
	NetworkWifiInterface* self;
	NMClient* client;
};

struct _Block6Data {
	int _ref_count_;
	Block5Data * _data5_;
	NMAWifiDialog* wifi_dialog;
};

struct _Block7Data {
	int _ref_count_;
	NetworkWifiInterface* self;
	NMAWifiDialog* hidden_dialog;
};

struct _Block8Data {
	int _ref_count_;
	NetworkWifiInterface* self;
	NMConnection* fuzzy;
	NMConnection* dialog_connection;
	gpointer _async_data_;
};

struct _NetworkWifiInterfaceConnectToNetworkData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	NetworkWifiInterface* self;
	NMAWifiDialog* wifi_dialog;
	Block8Data* _data8_;
	NMDevice* dialog_device;
	NMAccessPoint* dialog_ap;
	NMDevice* _tmp0_;
	NMAccessPoint* _tmp1_;
	NMConnection* _tmp2_;
	NetworkNetworkManager* network_manager;
	NetworkNetworkManager* _tmp3_;
	NMClient* client;
	NetworkNetworkManager* _tmp4_;
	NMClient* _tmp5_;
	NMClient* _tmp6_;
	NMClient* _tmp7_;
	GPtrArray* _tmp8_;
	gchar* path;
	NMAccessPoint* _tmp9_;
	NMAccessPoint* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	NMConnection* _tmp13_;
	NMClient* _tmp14_;
	NMConnection* _tmp15_;
	NMDeviceWifi* _tmp16_;
	const gchar* _tmp17_;
	NMActiveConnection* _tmp18_;
	NMActiveConnection* _tmp19_;
	GError* _error_;
	GError* _tmp20_;
	const gchar* _tmp21_;
	gchar* mode;
	NMSettingWireless* setting_wireless;
	NMConnection* _tmp22_;
	NMSettingWireless* _tmp23_;
	NMSettingWireless* _tmp24_;
	NMSettingWireless* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	const gchar* _tmp28_;
	NMSettingConnection* connection_setting;
	NMConnection* _tmp29_;
	NMSettingConnection* _tmp30_;
	NMSettingConnection* _tmp31_;
	NMSettingConnection* _tmp32_;
	NMSettingConnection* _tmp33_;
	NMConnection* _tmp34_;
	NMSettingConnection* _tmp35_;
	NMSetting* _tmp36_;
	NMClient* _tmp37_;
	NMConnection* _tmp38_;
	NMDevice* _tmp39_;
	const gchar* _tmp40_;
	NMActiveConnection* _tmp41_;
	NMActiveConnection* _tmp42_;
	GError* _vala1__error_;
	GError* _tmp43_;
	const gchar* _tmp44_;
	GError* _inner_error0_;
};

static gint NetworkWifiInterface_private_offset;
static gpointer network_wifi_interface_parent_class = NULL;

static void network_wifi_interface_real_update_name (NetworkWidgetsPage* base,
                                              gint count);
static void network_wifi_interface_access_point_added_cb (NetworkWifiInterface* self,
                                                   GObject* ap_);
static void network_wifi_interface_wifi_activate_cb (NetworkWifiInterface* self,
                                              NetworkWifiMenuItem* row);
static void _network_wifi_interface_wifi_activate_cb_network_wifi_menu_item_user_action (NetworkWifiMenuItem* _sender,
                                                                                  gpointer self);
static void network_wifi_interface_update_active_ap (NetworkWifiInterface* self);
static NetworkWifiMenuItem* network_wifi_interface_get_active_wifi_item (NetworkWifiInterface* self);
static void network_wifi_interface_set_active_wifi_item (NetworkWifiInterface* self,
                                                  NetworkWifiMenuItem* value);
static void network_wifi_interface_access_point_removed_cb (NetworkWifiInterface* self,
                                                     GObject* ap_);
static void network_wifi_interface_real_update (NetworkWidgetsPage* base);
static void network_wifi_interface_cancel_scan (NetworkWifiInterface* self);
static void network_wifi_interface_set_scan_placeholder (NetworkWifiInterface* self);
static void _rf_kill_device_unref0_ (gpointer var);
static inline void _g_list_free__rf_kill_device_unref0_ (GList* self);
static void ____lambda15_ (NetworkWifiInterface* self);
static void _____lambda15__gtk_button_clicked (GtkButton* _sender,
                                        gpointer self);
static void ____lambda18_ (NetworkWifiInterface* self);
static void _____lambda18__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                               gpointer self);
static void network_wifi_interface_real_update_switch (NetworkWidgetsPage* base);
static void network_wifi_interface_real_control_switch_activated (NetworkWidgetsPage* base);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static NMConnection* network_wifi_interface_get_valid_connection (NetworkWifiInterface* self,
                                                           NMAccessPoint* ap,
                                                           GPtrArray* ap_connections);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void ___lambda10_ (Block6Data* _data6_,
                   gint response);
static void network_wifi_interface_connect_to_network (NetworkWifiInterface* self,
                                                NMAWifiDialog* wifi_dialog,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void network_wifi_interface_connect_to_network_finish (NetworkWifiInterface* self,
                                                       GAsyncResult* _res_);
static void ____lambda10__gtk_dialog_response (GtkDialog* _sender,
                                        gint response_id,
                                        gpointer self);
static void ___lambda12_ (Block5Data* _data5_,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda12__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static gboolean __lambda13_ (NetworkWifiInterface* self);
static gboolean ___lambda13__gsource_func (gpointer self);
static void network_wifi_interface_connect_to_hidden (NetworkWifiInterface* self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void __lambda19_ (Block7Data* _data7_,
                  gint response);
static void ___lambda19__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void network_wifi_interface_connect_to_network_data_free (gpointer _data);
static gboolean network_wifi_interface_connect_to_network_co (NetworkWifiInterfaceConnectToNetworkData* _data_);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda11_ (Block8Data* _data8_,
                  NMRemoteConnection* possible);
static void ___lambda11__gfunc (gconstpointer data,
                         gpointer self);
static void network_wifi_interface_connect_to_network_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static gboolean ___lambda14_ (NetworkWifiInterface* self);
static gboolean ____lambda14__gsource_func (gpointer self);
static gint network_wifi_interface_sort_func (NetworkWifiInterface* self,
                                       GtkListBoxRow* r1,
                                       GtkListBoxRow* r2);
static GObject * network_wifi_interface_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static gint _network_wifi_interface_sort_func_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                               GtkListBoxRow* row2,
                                                               gpointer self);
static void _network_wifi_interface___lambda20_ (NetworkWifiInterface* self);
static void __network_wifi_interface___lambda20__gtk_widget_hide (GtkWidget* _sender,
                                                           gpointer self);
static void _network_wifi_interface_connect_to_hidden_gtk_button_clicked (GtkButton* _sender,
                                                                   gpointer self);
static void _network_widgets_page_update_rf_kill_manager_device_added (RFKillManager* _sender,
                                                                RFKillDevice* device,
                                                                gpointer self);
static void _network_widgets_page_update_rf_kill_manager_device_changed (RFKillManager* _sender,
                                                                  RFKillDevice* device,
                                                                  gpointer self);
static void _network_widgets_page_update_rf_kill_manager_device_deleted (RFKillManager* _sender,
                                                                  RFKillDevice* device,
                                                                  gpointer self);
static void _network_widgets_page_update_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self);
static void _network_wifi_interface_access_point_added_cb_nm_device_wifi_access_point_added (NMDeviceWifi* _sender,
                                                                                      GObject* ap,
                                                                                      gpointer self);
static void _network_wifi_interface_access_point_removed_cb_nm_device_wifi_access_point_removed (NMDeviceWifi* _sender,
                                                                                          GObject* ap,
                                                                                          gpointer self);
static void _network_widgets_page_update_nm_device_state_changed (NMDevice* _sender,
                                                           guint new_state,
                                                           guint old_state,
                                                           guint reason,
                                                           gpointer self);
static void _network_wifi_interface_access_point_added_cb_gfunc (gconstpointer data,
                                                          gpointer self);
static void network_wifi_interface_finalize (GObject * obj);
static GType network_wifi_interface_get_type_once (void);
static void _vala_network_wifi_interface_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_network_wifi_interface_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
network_wifi_interface_get_instance_private (NetworkWifiInterface* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkWifiInterface_private_offset);
}

NetworkWifiInterface*
network_wifi_interface_construct (GType object_type,
                                  NMDevice* device)
{
	NetworkWifiInterface * self = NULL;
	g_return_val_if_fail (device != NULL, NULL);
	self = (NetworkWifiInterface*) g_object_new (object_type, "activatable", TRUE, "device", device, NULL);
	return self;
}

NetworkWifiInterface*
network_wifi_interface_new (NMDevice* device)
{
	return network_wifi_interface_construct (NETWORK_TYPE_WIFI_INTERFACE, device);
}

static void
network_wifi_interface_real_update_name (NetworkWidgetsPage* base,
                                         gint count)
{
	NetworkWifiInterface * self;
	self = (NetworkWifiInterface*) base;
	if (count <= 1) {
		granite_simple_settings_page_set_title ((GraniteSimpleSettingsPage*) self, _ ("Wireless"));
	} else {
		NMDevice* _tmp0_;
		NMDevice* _tmp1_;
		const gchar* _tmp2_;
		_tmp0_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
		_tmp1_ = _tmp0_;
		_tmp2_ = nm_device_get_description (_tmp1_);
		granite_simple_settings_page_set_title ((GraniteSimpleSettingsPage*) self, _tmp2_);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_network_wifi_interface_wifi_activate_cb_network_wifi_menu_item_user_action (NetworkWifiMenuItem* _sender,
                                                                             gpointer self)
{
	network_wifi_interface_wifi_activate_cb ((NetworkWifiInterface*) self, _sender);
}

static void
network_wifi_interface_access_point_added_cb (NetworkWifiInterface* self,
                                              GObject* ap_)
{
	NMAccessPoint* ap = NULL;
	NMAccessPoint* _tmp0_;
	gboolean found = FALSE;
	NMAccessPoint* _tmp1_;
	GBytes* _tmp2_;
	GBytes* _tmp3_;
	gboolean _tmp16_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ap_ != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (ap_, nm_access_point_get_type (), NMAccessPoint));
	ap = _tmp0_;
	found = FALSE;
	_tmp1_ = ap;
	_tmp2_ = nm_access_point_get_ssid (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != NULL) {
		GtkListBox* _tmp4_;
		GList* _tmp5_;
		_tmp4_ = self->priv->wifi_list;
		_tmp5_ = gtk_container_get_children ((GtkContainer*) _tmp4_);
		{
			GList* w_collection = NULL;
			GList* w_it = NULL;
			w_collection = _tmp5_;
			for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
				GtkWidget* w = NULL;
				w = (GtkWidget*) w_it->data;
				{
					NetworkWifiMenuItem* menu_item = NULL;
					GtkWidget* _tmp6_;
					NetworkWifiMenuItem* _tmp7_;
					NMAccessPoint* _tmp8_;
					GBytes* _tmp9_;
					GBytes* _tmp10_;
					NetworkWifiMenuItem* _tmp11_;
					GBytes* _tmp12_;
					GBytes* _tmp13_;
					_tmp6_ = w;
					_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem));
					menu_item = _tmp7_;
					_tmp8_ = ap;
					_tmp9_ = nm_access_point_get_ssid (_tmp8_);
					_tmp10_ = _tmp9_;
					_tmp11_ = menu_item;
					_tmp12_ = network_wifi_menu_item_get_ssid (_tmp11_);
					_tmp13_ = _tmp12_;
					if (g_bytes_compare (_tmp10_, _tmp13_) == 0) {
						NetworkWifiMenuItem* _tmp14_;
						NMAccessPoint* _tmp15_;
						found = TRUE;
						_tmp14_ = menu_item;
						_tmp15_ = ap;
						network_wifi_menu_item_add_ap (_tmp14_, _tmp15_);
						_g_object_unref0 (menu_item);
						break;
					}
					_g_object_unref0 (menu_item);
				}
			}
			(w_collection == NULL) ? NULL : (w_collection = (g_list_free (w_collection), NULL));
		}
	}
	if (!found) {
		NMAccessPoint* _tmp17_;
		GBytes* _tmp18_;
		GBytes* _tmp19_;
		_tmp17_ = ap;
		_tmp18_ = nm_access_point_get_ssid (_tmp17_);
		_tmp19_ = _tmp18_;
		_tmp16_ = _tmp19_ != NULL;
	} else {
		_tmp16_ = FALSE;
	}
	if (_tmp16_) {
		NetworkWifiMenuItem* item = NULL;
		NMAccessPoint* _tmp20_;
		NetworkWifiMenuItem* _tmp21_ = NULL;
		NetworkWifiMenuItem* _tmp22_;
		GtkListBox* _tmp23_;
		NetworkWifiMenuItem* _tmp24_;
		GtkListBox* _tmp25_;
		_tmp20_ = ap;
		_tmp21_ = network_wifi_menu_item_new (_tmp20_);
		gtk_widget_set_visible ((GtkWidget*) _tmp21_, TRUE);
		g_object_ref_sink (_tmp21_);
		item = _tmp21_;
		_tmp22_ = item;
		g_signal_connect_object (_tmp22_, "user-action", (GCallback) _network_wifi_interface_wifi_activate_cb_network_wifi_menu_item_user_action, self, 0);
		_tmp23_ = self->priv->wifi_list;
		_tmp24_ = item;
		gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
		_tmp25_ = self->priv->wifi_list;
		gtk_widget_show_all ((GtkWidget*) _tmp25_);
		network_widgets_page_update ((NetworkWidgetsPage*) self);
		_g_object_unref0 (item);
	}
	_g_object_unref0 (ap);
}

static void
network_wifi_interface_update_active_ap (NetworkWifiInterface* self)
{
	NMDeviceWifi* _tmp0_;
	NMAccessPoint* _tmp1_;
	NMAccessPoint* _tmp2_;
	NetworkWifiMenuItem* _tmp3_;
	NMAccessPoint* _tmp8_;
	g_return_if_fail (self != NULL);
	g_debug ("WifiPage.vala:227: Update active AP");
	_tmp0_ = self->wifi_device;
	_tmp1_ = nm_device_wifi_get_active_access_point (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	_g_object_unref0 (self->priv->active_ap);
	self->priv->active_ap = _tmp2_;
	_tmp3_ = self->priv->_active_wifi_item;
	if (_tmp3_ != NULL) {
		NetworkWifiMenuItem* _tmp4_;
		NMDeviceState _tmp5_;
		NMDeviceState _tmp6_;
		_tmp4_ = self->priv->_active_wifi_item;
		_tmp5_ = network_wifi_menu_item_get_state (_tmp4_);
		_tmp6_ = _tmp5_;
		if (_tmp6_ == NM_DEVICE_STATE_PREPARE) {
			NetworkWifiMenuItem* _tmp7_;
			_tmp7_ = self->priv->_active_wifi_item;
			network_wifi_menu_item_set_state (_tmp7_, NM_DEVICE_STATE_DISCONNECTED);
		}
		network_wifi_interface_set_active_wifi_item (self, NULL);
	}
	_tmp8_ = self->priv->active_ap;
	if (_tmp8_ == NULL) {
		g_debug ("WifiPage.vala:239: No active AP");
	} else {
		NMAccessPoint* _tmp9_;
		GBytes* _tmp10_;
		gsize _tmp11_ = 0;
		guint8* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gboolean found = FALSE;
		GtkListBox* _tmp15_;
		GList* _tmp16_;
		_tmp9_ = self->priv->active_ap;
		_tmp10_ = nm_access_point_get_ssid (_tmp9_);
		_tmp12_ = g_bytes_get_data (_tmp10_, &_tmp11_);
		_tmp13_ = nm_utils_ssid_to_utf8 (_tmp12_, (gsize) _tmp11_);
		_tmp14_ = _tmp13_;
		g_debug ("WifiPage.vala:241: Active ap: %s", _tmp14_);
		_g_free0 (_tmp14_);
		found = FALSE;
		_tmp15_ = self->priv->wifi_list;
		_tmp16_ = gtk_container_get_children ((GtkContainer*) _tmp15_);
		{
			GList* w_collection = NULL;
			GList* w_it = NULL;
			w_collection = _tmp16_;
			for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
				GtkWidget* w = NULL;
				w = (GtkWidget*) w_it->data;
				{
					NetworkWifiMenuItem* menu_item = NULL;
					GtkWidget* _tmp17_;
					NetworkWifiMenuItem* _tmp18_;
					NMAccessPoint* _tmp19_;
					GBytes* _tmp20_;
					GBytes* _tmp21_;
					NetworkWifiMenuItem* _tmp22_;
					GBytes* _tmp23_;
					GBytes* _tmp24_;
					_tmp17_ = w;
					_tmp18_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem));
					menu_item = _tmp18_;
					_tmp19_ = self->priv->active_ap;
					_tmp20_ = nm_access_point_get_ssid (_tmp19_);
					_tmp21_ = _tmp20_;
					_tmp22_ = menu_item;
					_tmp23_ = network_wifi_menu_item_get_ssid (_tmp22_);
					_tmp24_ = _tmp23_;
					if (g_bytes_compare (_tmp21_, _tmp24_) == 0) {
						NetworkWifiMenuItem* _tmp25_;
						NetworkWifiMenuItem* _tmp26_;
						NetworkWifiMenuItem* _tmp27_;
						NMDeviceState _tmp28_;
						NMDeviceState _tmp29_;
						found = TRUE;
						_tmp25_ = menu_item;
						network_wifi_menu_item_set_active (_tmp25_, TRUE);
						_tmp26_ = menu_item;
						network_wifi_interface_set_active_wifi_item (self, _tmp26_);
						_tmp27_ = self->priv->_active_wifi_item;
						_tmp28_ = network_widgets_page_get_state ((NetworkWidgetsPage*) self);
						_tmp29_ = _tmp28_;
						network_wifi_menu_item_set_state (_tmp27_, _tmp29_);
					}
					_g_object_unref0 (menu_item);
				}
			}
			(w_collection == NULL) ? NULL : (w_collection = (g_list_free (w_collection), NULL));
		}
		if (!found) {
			g_debug ("WifiPage.vala:257: Active AP not added");
		}
	}
}

static void
network_wifi_interface_access_point_removed_cb (NetworkWifiInterface* self,
                                                GObject* ap_)
{
	NMAccessPoint* ap = NULL;
	NMAccessPoint* _tmp0_;
	NetworkWifiMenuItem* found_item = NULL;
	GtkListBox* _tmp1_;
	GList* _tmp2_;
	NetworkWifiMenuItem* _tmp14_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ap_ != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (ap_, nm_access_point_get_type (), NMAccessPoint));
	ap = _tmp0_;
	found_item = NULL;
	_tmp1_ = self->priv->wifi_list;
	_tmp2_ = gtk_container_get_children ((GtkContainer*) _tmp1_);
	{
		GList* w_collection = NULL;
		GList* w_it = NULL;
		w_collection = _tmp2_;
		for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
			GtkWidget* w = NULL;
			w = (GtkWidget*) w_it->data;
			{
				NetworkWifiMenuItem* menu_item = NULL;
				GtkWidget* _tmp3_;
				NetworkWifiMenuItem* _tmp4_;
				NetworkWifiMenuItem* _tmp5_;
				NMAccessPoint* _tmp6_;
				GBytes* _tmp7_;
				GBytes* _tmp8_;
				NetworkWifiMenuItem* _tmp9_;
				GBytes* _tmp10_;
				GBytes* _tmp11_;
				_tmp3_ = w;
				_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem));
				menu_item = _tmp4_;
				_tmp5_ = menu_item;
				_vala_assert (_tmp5_ != NULL, "menu_item != null");
				_tmp6_ = ap;
				_tmp7_ = nm_access_point_get_ssid (_tmp6_);
				_tmp8_ = _tmp7_;
				_tmp9_ = menu_item;
				_tmp10_ = network_wifi_menu_item_get_ssid (_tmp9_);
				_tmp11_ = _tmp10_;
				if (g_bytes_compare (_tmp8_, _tmp11_) == 0) {
					NetworkWifiMenuItem* _tmp12_;
					NetworkWifiMenuItem* _tmp13_;
					_tmp12_ = menu_item;
					_tmp13_ = _g_object_ref0 (_tmp12_);
					_g_object_unref0 (found_item);
					found_item = _tmp13_;
					_g_object_unref0 (menu_item);
					break;
				}
				_g_object_unref0 (menu_item);
			}
		}
		(w_collection == NULL) ? NULL : (w_collection = (g_list_free (w_collection), NULL));
	}
	_tmp14_ = found_item;
	if (_tmp14_ == NULL) {
		g_critical ("WifiPage.vala:279: Couldn't remove an access point which has not been " \
"added.");
	} else {
		NetworkWifiMenuItem* _tmp15_;
		NMAccessPoint* _tmp16_;
		_tmp15_ = found_item;
		_tmp16_ = ap;
		if (!network_wifi_menu_item_remove_ap (_tmp15_, _tmp16_)) {
			NetworkWifiMenuItem* _tmp17_;
			_tmp17_ = found_item;
			gtk_widget_destroy ((GtkWidget*) _tmp17_);
		}
	}
	network_widgets_page_update ((NetworkWidgetsPage*) self);
	_g_object_unref0 (found_item);
	_g_object_unref0 (ap);
}

static gpointer
_rf_kill_device_ref0 (gpointer self)
{
	return self ? rf_kill_device_ref (self) : NULL;
}

static void
_rf_kill_device_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (rf_kill_device_unref (var), NULL));
}

static inline void
_g_list_free__rf_kill_device_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _rf_kill_device_unref0_);
}

static void
____lambda15_ (NetworkWifiInterface* self)
{
	GError* _inner_error0_ = NULL;
	{
		NMDevice* _tmp0_;
		NMDevice* _tmp1_;
		_tmp0_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
		_tmp1_ = _tmp0_;
		nm_device_disconnect (_tmp1_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp2_ = e;
		_tmp3_ = _tmp2_->message;
		g_warning ("WifiPage.vala:406: %s", _tmp3_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
_____lambda15__gtk_button_clicked (GtkButton* _sender,
                                   gpointer self)
{
	____lambda15_ ((NetworkWifiInterface*) self);
}

static void
____lambda18_ (NetworkWifiInterface* self)
{
	GtkPopover* _tmp0_;
	GtkToggleButton* _tmp1_;
	_tmp0_ = self->popover;
	_tmp1_ = self->info_btn;
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, gtk_toggle_button_get_active (_tmp1_));
}

static void
_____lambda18__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                          gpointer self)
{
	____lambda18_ ((NetworkWifiInterface*) self);
}

static void
network_wifi_interface_real_update (NetworkWidgetsPage* base)
{
	NetworkWifiInterface * self;
	gboolean sensitive = FALSE;
	NMDevice* _tmp0_;
	NMDevice* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp4_;
	GtkToggleButton* _tmp6_;
	GtkButton* _tmp8_;
	NetworkWifiMenuItem* old_active = NULL;
	NetworkWifiMenuItem* _tmp12_;
	NetworkWifiMenuItem* _tmp13_;
	NMDeviceWifi* _tmp14_;
	NMDeviceWifi* _tmp15_;
	NMDeviceState _tmp16_;
	NMDeviceState _tmp17_;
	NMDeviceWifi* _tmp23_;
	NMDeviceState _tmp24_;
	NMDeviceState _tmp25_;
	NMDeviceState _tmp26_;
	NMDeviceState _tmp27_;
	GEnumValue* _tmp28_;
	RFKillManager* _tmp29_;
	GList* _tmp30_;
	gboolean _tmp41_ = FALSE;
	gboolean is_hotspot = FALSE;
	NMDeviceWifi* _tmp42_;
	NMAccessPoint* active_access_point = NULL;
	NMDeviceWifi* _tmp43_;
	NMAccessPoint* _tmp44_;
	NMAccessPoint* _tmp45_;
	gboolean _tmp46_ = FALSE;
	NMAccessPoint* _tmp47_;
	GtkRevealer* _tmp48_;
	gboolean _tmp53_ = FALSE;
	NMAccessPoint* _tmp54_;
	self = (NetworkWifiInterface*) base;
	_tmp0_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
	_tmp1_ = _tmp0_;
	sensitive = nm_device_get_state (_tmp1_) == NM_DEVICE_STATE_ACTIVATED;
	_tmp2_ = self->disconnect_btn;
	if (_tmp2_ != NULL) {
		GtkButton* _tmp3_;
		_tmp3_ = self->disconnect_btn;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, sensitive);
	}
	_tmp4_ = self->settings_btn;
	if (_tmp4_ != NULL) {
		GtkButton* _tmp5_;
		_tmp5_ = self->settings_btn;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, sensitive);
	}
	_tmp6_ = self->info_btn;
	if (_tmp6_ != NULL) {
		GtkToggleButton* _tmp7_;
		_tmp7_ = self->info_btn;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, sensitive);
	}
	_tmp8_ = self->hidden_btn;
	if (_tmp8_ != NULL) {
		GtkButton* _tmp9_;
		NMDeviceState _tmp10_;
		NMDeviceState _tmp11_;
		_tmp9_ = self->hidden_btn;
		_tmp10_ = network_widgets_page_get_state ((NetworkWidgetsPage*) self);
		_tmp11_ = _tmp10_;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, _tmp11_ != NM_DEVICE_STATE_UNAVAILABLE);
	}
	_tmp12_ = self->priv->_active_wifi_item;
	_tmp13_ = _g_object_ref0 (_tmp12_);
	old_active = _tmp13_;
	_tmp14_ = self->wifi_device;
	if (network_utils_get_device_is_hotspot (_tmp14_)) {
		network_widgets_page_set_state ((NetworkWidgetsPage*) self, NM_DEVICE_STATE_DISCONNECTED);
		_g_object_unref0 (old_active);
		return;
	}
	_tmp15_ = self->wifi_device;
	_tmp16_ = nm_device_get_state ((NMDevice*) _tmp15_);
	_tmp17_ = _tmp16_;
	switch (_tmp17_) {
		case NM_DEVICE_STATE_UNKNOWN:
		case NM_DEVICE_STATE_UNMANAGED:
		case NM_DEVICE_STATE_FAILED:
		{
			NetworkWifiMenuItem* _tmp18_;
			_tmp18_ = self->priv->_active_wifi_item;
			if (_tmp18_ != NULL) {
				NetworkWifiMenuItem* _tmp19_;
				NMDeviceState _tmp20_;
				NMDeviceState _tmp21_;
				_tmp19_ = self->priv->_active_wifi_item;
				_tmp20_ = network_widgets_page_get_state ((NetworkWidgetsPage*) self);
				_tmp21_ = _tmp20_;
				network_wifi_menu_item_set_state (_tmp19_, _tmp21_);
			}
			network_wifi_interface_cancel_scan (self);
			break;
		}
		case NM_DEVICE_STATE_DEACTIVATING:
		case NM_DEVICE_STATE_UNAVAILABLE:
		{
			GtkStack* _tmp22_;
			network_wifi_interface_cancel_scan (self);
			_tmp22_ = self->priv->placeholder;
			gtk_stack_set_visible_child_name (_tmp22_, "wireless-off");
			break;
		}
		default:
		{
			network_wifi_interface_set_scan_placeholder (self);
			break;
		}
	}
	_tmp23_ = self->wifi_device;
	_tmp24_ = nm_device_get_state ((NMDevice*) _tmp23_);
	_tmp25_ = _tmp24_;
	network_widgets_page_set_state ((NetworkWidgetsPage*) self, _tmp25_);
	_tmp26_ = network_widgets_page_get_state ((NetworkWidgetsPage*) self);
	_tmp27_ = _tmp26_;
	_tmp28_ = g_enum_get_value (g_type_class_ref (nm_device_state_get_type ()), _tmp27_);
	g_debug ("WifiPage.vala:336: New network state: %s", (_tmp28_ != NULL) ? _tmp28_->value_name : NULL);
	self->priv->software_locked = FALSE;
	self->priv->hardware_locked = FALSE;
	_tmp29_ = self->priv->rfkill;
	_tmp30_ = rf_kill_manager_get_devices (_tmp29_);
	{
		GList* device_collection = NULL;
		GList* device_it = NULL;
		device_collection = _tmp30_;
		for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
			RFKillDevice* _tmp31_;
			RFKillDevice* device = NULL;
			_tmp31_ = _rf_kill_device_ref0 ((RFKillDevice*) device_it->data);
			device = _tmp31_;
			{
				RFKillDevice* _tmp32_;
				RFKillDeviceType _tmp33_;
				RFKillDeviceType _tmp34_;
				RFKillDevice* _tmp35_;
				gboolean _tmp36_;
				gboolean _tmp37_;
				RFKillDevice* _tmp38_;
				gboolean _tmp39_;
				gboolean _tmp40_;
				_tmp32_ = device;
				_tmp33_ = rf_kill_device_get_device_type (_tmp32_);
				_tmp34_ = _tmp33_;
				if (_tmp34_ != RF_KILL_DEVICE_TYPE_WLAN) {
					_rf_kill_device_unref0 (device);
					continue;
				}
				_tmp35_ = device;
				_tmp36_ = rf_kill_device_get_software_lock (_tmp35_);
				_tmp37_ = _tmp36_;
				if (_tmp37_) {
					self->priv->software_locked = TRUE;
				}
				_tmp38_ = device;
				_tmp39_ = rf_kill_device_get_hardware_lock (_tmp38_);
				_tmp40_ = _tmp39_;
				if (_tmp40_) {
					self->priv->hardware_locked = TRUE;
				}
				_rf_kill_device_unref0 (device);
			}
		}
		(device_collection == NULL) ? NULL : (device_collection = (_g_list_free__rf_kill_device_unref0_ (device_collection), NULL));
	}
	if (self->priv->hardware_locked) {
		_tmp41_ = TRUE;
	} else {
		_tmp41_ = self->priv->software_locked;
	}
	self->priv->locked = _tmp41_;
	network_wifi_interface_update_active_ap (self);
	NETWORK_WIDGETS_PAGE_CLASS (network_wifi_interface_parent_class)->update (G_TYPE_CHECK_INSTANCE_CAST (self, NETWORK_WIDGETS_TYPE_PAGE, NetworkWidgetsPage));
	_tmp42_ = self->wifi_device;
	is_hotspot = network_utils_get_device_is_hotspot (_tmp42_);
	_tmp43_ = self->wifi_device;
	_tmp44_ = nm_device_wifi_get_active_access_point (_tmp43_);
	_tmp45_ = _tmp44_;
	active_access_point = _tmp45_;
	_tmp47_ = active_access_point;
	if (_tmp47_ != NULL) {
		_tmp46_ = !is_hotspot;
	} else {
		_tmp46_ = FALSE;
	}
	_tmp48_ = self->top_revealer;
	gtk_revealer_set_reveal_child (_tmp48_, _tmp46_);
	if (is_hotspot) {
		GtkStack* _tmp49_;
		GtkBox* _tmp50_;
		_tmp49_ = self->list_stack;
		_tmp50_ = self->hotspot_mode_alert;
		gtk_stack_set_visible_child (_tmp49_, (GtkWidget*) _tmp50_);
	} else {
		GtkStack* _tmp51_;
		GtkScrolledWindow* _tmp52_;
		_tmp51_ = self->list_stack;
		_tmp52_ = self->scrolled;
		gtk_stack_set_visible_child (_tmp51_, (GtkWidget*) _tmp52_);
	}
	_tmp54_ = active_access_point;
	if (_tmp54_ == NULL) {
		NetworkWifiMenuItem* _tmp55_;
		_tmp55_ = old_active;
		_tmp53_ = _tmp55_ != NULL;
	} else {
		_tmp53_ = FALSE;
	}
	if (_tmp53_) {
		NetworkWifiMenuItem* _tmp56_;
		NetworkWifiMenuItem* _tmp57_;
		gboolean _tmp58_ = FALSE;
		GtkFrame* _tmp59_;
		GtkButton* _tmp64_;
		GtkButton* _tmp65_;
		_tmp56_ = old_active;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp56_, FALSE);
		_tmp57_ = old_active;
		gtk_widget_set_visible ((GtkWidget*) _tmp57_, TRUE);
		_tmp59_ = self->connected_frame;
		if (_tmp59_ != NULL) {
			GtkFrame* _tmp60_;
			GtkWidget* _tmp61_;
			_tmp60_ = self->connected_frame;
			_tmp61_ = gtk_bin_get_child ((GtkBin*) _tmp60_);
			_tmp58_ = _tmp61_ != NULL;
		} else {
			_tmp58_ = FALSE;
		}
		if (_tmp58_) {
			GtkFrame* _tmp62_;
			GtkWidget* _tmp63_;
			_tmp62_ = self->connected_frame;
			_tmp63_ = gtk_bin_get_child ((GtkBin*) _tmp62_);
			gtk_widget_destroy (_tmp63_);
		}
		_g_object_unref0 (self->settings_btn);
		self->settings_btn = NULL;
		_tmp64_ = self->settings_btn;
		_tmp65_ = _g_object_ref0 (_tmp64_);
		_g_object_unref0 (self->disconnect_btn);
		self->disconnect_btn = _tmp65_;
	} else {
		gboolean _tmp66_ = FALSE;
		NMAccessPoint* _tmp67_;
		_tmp67_ = active_access_point;
		if (_tmp67_ != NULL) {
			NetworkWifiMenuItem* _tmp68_;
			NetworkWifiMenuItem* _tmp69_;
			_tmp68_ = self->priv->_active_wifi_item;
			_tmp69_ = old_active;
			_tmp66_ = _tmp68_ != _tmp69_;
		} else {
			_tmp66_ = FALSE;
		}
		if (_tmp66_) {
			NetworkWifiMenuItem* _tmp70_;
			NetworkWifiMenuItem* _tmp79_;
			NetworkWifiMenuItem* _tmp80_;
			NetworkWifiMenuItem* top_item = NULL;
			NMAccessPoint* _tmp81_;
			NetworkWifiMenuItem* _tmp82_ = NULL;
			GtkBox* _tmp83_;
			GtkBox* _tmp84_;
			NetworkWifiMenuItem* _tmp85_;
			NMDevice* _tmp86_;
			NMDevice* _tmp87_;
			GtkButton* _tmp88_ = NULL;
			GtkButton* _tmp89_;
			GtkStyleContext* _tmp90_;
			GtkButton* _tmp91_;
			NMDeviceWifi* _tmp92_;
			NMDevice* _tmp93_;
			NMDevice* _tmp94_;
			NetworkWidgetsSettingsButton* _tmp95_ = NULL;
			GtkImage* _tmp96_;
			GtkToggleButton* _tmp97_ = NULL;
			GtkToggleButton* _tmp98_;
			GtkStyleContext* _tmp99_;
			GtkPopover* _tmp100_;
			GtkToggleButton* _tmp101_;
			GtkToggleButton* _tmp102_;
			GtkBox* button_box = NULL;
			GtkBox* _tmp103_ = NULL;
			GtkBox* _tmp104_;
			GtkButton* _tmp105_;
			GtkBox* _tmp106_;
			GtkButton* _tmp107_;
			GtkBox* _tmp108_;
			GtkBox* _tmp109_;
			GtkBox* _tmp110_;
			GtkBox* _tmp111_;
			GtkToggleButton* _tmp112_;
			GtkFrame* _tmp113_;
			GtkBox* _tmp114_;
			GtkBox* _tmp115_;
			GtkFrame* _tmp116_;
			_tmp70_ = old_active;
			if (_tmp70_ != NULL) {
				NetworkWifiMenuItem* _tmp71_;
				NetworkWifiMenuItem* _tmp72_;
				gboolean _tmp73_ = FALSE;
				GtkFrame* _tmp74_;
				_tmp71_ = old_active;
				gtk_widget_set_no_show_all ((GtkWidget*) _tmp71_, FALSE);
				_tmp72_ = old_active;
				gtk_widget_set_visible ((GtkWidget*) _tmp72_, TRUE);
				_tmp74_ = self->connected_frame;
				if (_tmp74_ != NULL) {
					GtkFrame* _tmp75_;
					GtkWidget* _tmp76_;
					_tmp75_ = self->connected_frame;
					_tmp76_ = gtk_bin_get_child ((GtkBin*) _tmp75_);
					_tmp73_ = _tmp76_ != NULL;
				} else {
					_tmp73_ = FALSE;
				}
				if (_tmp73_) {
					GtkFrame* _tmp77_;
					GtkWidget* _tmp78_;
					_tmp77_ = self->connected_frame;
					_tmp78_ = gtk_bin_get_child ((GtkBin*) _tmp77_);
					gtk_widget_destroy (_tmp78_);
				}
			}
			_tmp79_ = self->priv->_active_wifi_item;
			gtk_widget_set_no_show_all ((GtkWidget*) _tmp79_, TRUE);
			_tmp80_ = self->priv->_active_wifi_item;
			gtk_widget_set_visible ((GtkWidget*) _tmp80_, FALSE);
			_tmp81_ = active_access_point;
			_tmp82_ = network_wifi_menu_item_new (_tmp81_);
			network_wifi_menu_item_set_state (_tmp82_, NM_DEVICE_STATE_ACTIVATED);
			g_object_ref_sink (_tmp82_);
			top_item = _tmp82_;
			_tmp83_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
			g_object_ref_sink (_tmp83_);
			_g_object_unref0 (self->connected_box);
			self->connected_box = _tmp83_;
			_tmp84_ = self->connected_box;
			_tmp85_ = top_item;
			gtk_container_add ((GtkContainer*) _tmp84_, (GtkWidget*) _tmp85_);
			_tmp86_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
			_tmp87_ = _tmp86_;
			_tmp88_ = (GtkButton*) gtk_button_new_with_label (_ ("Disconnect"));
			gtk_widget_set_sensitive ((GtkWidget*) _tmp88_, nm_device_get_state (_tmp87_) == NM_DEVICE_STATE_ACTIVATED);
			g_object_ref_sink (_tmp88_);
			_g_object_unref0 (self->disconnect_btn);
			self->disconnect_btn = _tmp88_;
			_tmp89_ = self->disconnect_btn;
			_tmp90_ = gtk_widget_get_style_context ((GtkWidget*) _tmp89_);
			gtk_style_context_add_class (_tmp90_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
			_tmp91_ = self->disconnect_btn;
			g_signal_connect_object (_tmp91_, "clicked", (GCallback) _____lambda15__gtk_button_clicked, self, 0);
			_tmp92_ = self->wifi_device;
			_tmp93_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
			_tmp94_ = _tmp93_;
			_tmp95_ = network_widgets_settings_button_new_from_device ((NMDevice*) _tmp92_, _ ("Settings…"));
			gtk_widget_set_sensitive ((GtkWidget*) _tmp95_, nm_device_get_state (_tmp94_) == NM_DEVICE_STATE_ACTIVATED);
			g_object_ref_sink (_tmp95_);
			_g_object_unref0 (self->settings_btn);
			self->settings_btn = (GtkButton*) _tmp95_;
			_tmp96_ = (GtkImage*) gtk_image_new_from_icon_name ("view-more-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
			g_object_ref_sink (_tmp96_);
			_tmp97_ = (GtkToggleButton*) gtk_toggle_button_new ();
			gtk_widget_set_margin_top ((GtkWidget*) _tmp97_, 6);
			gtk_widget_set_margin_bottom ((GtkWidget*) _tmp97_, 6);
			gtk_button_set_image ((GtkButton*) _tmp97_, (GtkWidget*) _tmp96_);
			_g_object_unref0 (_tmp96_);
			g_object_ref_sink (_tmp97_);
			_g_object_unref0 (self->info_btn);
			self->info_btn = _tmp97_;
			_tmp98_ = self->info_btn;
			_tmp99_ = gtk_widget_get_style_context ((GtkWidget*) _tmp98_);
			gtk_style_context_add_class (_tmp99_, GTK_STYLE_CLASS_FLAT);
			_tmp100_ = self->popover;
			_tmp101_ = self->info_btn;
			gtk_popover_set_relative_to (_tmp100_, (GtkWidget*) _tmp101_);
			_tmp102_ = self->info_btn;
			g_signal_connect_object (_tmp102_, "toggled", (GCallback) _____lambda18__gtk_toggle_button_toggled, self, 0);
			_tmp103_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
			gtk_box_set_homogeneous (_tmp103_, TRUE);
			g_object_set ((GtkWidget*) _tmp103_, "margin", 6, NULL);
			gtk_widget_set_valign ((GtkWidget*) _tmp103_, GTK_ALIGN_CENTER);
			g_object_ref_sink (_tmp103_);
			button_box = _tmp103_;
			_tmp104_ = button_box;
			_tmp105_ = self->disconnect_btn;
			gtk_box_pack_end (_tmp104_, (GtkWidget*) _tmp105_, FALSE, FALSE, (guint) 0);
			_tmp106_ = button_box;
			_tmp107_ = self->settings_btn;
			gtk_box_pack_end (_tmp106_, (GtkWidget*) _tmp107_, FALSE, FALSE, (guint) 0);
			_tmp108_ = button_box;
			gtk_widget_show_all ((GtkWidget*) _tmp108_);
			_tmp109_ = self->connected_box;
			_tmp110_ = button_box;
			gtk_box_pack_end (_tmp109_, (GtkWidget*) _tmp110_, FALSE, FALSE, (guint) 0);
			_tmp111_ = self->connected_box;
			_tmp112_ = self->info_btn;
			gtk_box_pack_end (_tmp111_, (GtkWidget*) _tmp112_, FALSE, FALSE, (guint) 0);
			_tmp113_ = self->connected_frame;
			_tmp114_ = self->connected_box;
			gtk_container_add ((GtkContainer*) _tmp113_, (GtkWidget*) _tmp114_);
			_tmp115_ = self->connected_box;
			gtk_widget_show_all ((GtkWidget*) _tmp115_);
			_tmp116_ = self->connected_frame;
			gtk_widget_show_all ((GtkWidget*) _tmp116_);
			_g_object_unref0 (button_box);
			_g_object_unref0 (top_item);
		}
	}
	_g_object_unref0 (old_active);
}

static void
network_wifi_interface_real_update_switch (NetworkWidgetsPage* base)
{
	NetworkWifiInterface * self;
	GtkSwitch* _tmp0_;
	GtkSwitch* _tmp1_;
	self = (NetworkWifiInterface*) base;
	_tmp0_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
	_tmp1_ = _tmp0_;
	gtk_switch_set_active (_tmp1_, !self->priv->software_locked);
}

static void
network_wifi_interface_real_control_switch_activated (NetworkWidgetsPage* base)
{
	NetworkWifiInterface * self;
	gboolean active = FALSE;
	GtkSwitch* _tmp0_;
	GtkSwitch* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	self = (NetworkWifiInterface*) base;
	_tmp0_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = gtk_switch_get_active (_tmp1_);
	_tmp3_ = _tmp2_;
	active = _tmp3_;
	if (active == self->priv->software_locked) {
		RFKillManager* _tmp4_;
		NetworkNetworkManager* network_manager = NULL;
		NetworkNetworkManager* _tmp5_;
		NetworkNetworkManager* _tmp6_;
		NMClient* _tmp7_;
		NMClient* _tmp8_;
		_tmp4_ = self->priv->rfkill;
		rf_kill_manager_set_software_lock (_tmp4_, RF_KILL_DEVICE_TYPE_WLAN, !active);
		_tmp5_ = network_network_manager_get_default ();
		network_manager = _tmp5_;
		_tmp6_ = network_manager;
		_tmp7_ = network_network_manager_get_client (_tmp6_);
		_tmp8_ = _tmp7_;
		nm_client_wireless_set_enabled (_tmp8_, active);
	}
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		NetworkWifiInterface* self;
		self = _data5_->self;
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}

static gpointer
_g_ptr_array_ref0 (gpointer self)
{
	return self ? g_ptr_array_ref (self) : NULL;
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		NetworkWifiInterface* self;
		self = _data6_->_data5_->self;
		_g_object_unref0 (_data6_->wifi_dialog);
		block5_data_unref (_data6_->_data5_);
		_data6_->_data5_ = NULL;
		g_slice_free (Block6Data, _data6_);
	}
}

static void
___lambda10_ (Block6Data* _data6_,
              gint response)
{
	Block5Data* _data5_;
	NetworkWifiInterface* self;
	_data5_ = _data6_->_data5_;
	self = _data5_->self;
	if (response == ((gint) GTK_RESPONSE_OK)) {
		NMAWifiDialog* _tmp0_;
		_tmp0_ = _data6_->wifi_dialog;
		network_wifi_interface_connect_to_network (self, _tmp0_, NULL, NULL);
	}
}

static void
____lambda10__gtk_dialog_response (GtkDialog* _sender,
                                   gint response_id,
                                   gpointer self)
{
	___lambda10_ (self, response_id);
}

static void
___lambda12_ (Block5Data* _data5_,
              GObject* obj,
              GAsyncResult* res)
{
	NetworkWifiInterface* self;
	GError* _inner_error0_ = NULL;
	self = _data5_->self;
	g_return_if_fail (res != NULL);
	{
		NMClient* _tmp0_;
		NMActiveConnection* _tmp1_;
		NMActiveConnection* _tmp2_;
		_tmp0_ = _data5_->client;
		_tmp1_ = nm_client_add_and_activate_connection_finish (_tmp0_, res, &_inner_error0_);
		_tmp2_ = _tmp1_;
		_g_object_unref0 (_tmp2_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		_error_ = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = _error_;
		_tmp4_ = _tmp3_->message;
		g_warning ("WifiPage.vala:543: %s", _tmp4_);
		_g_error_free0 (_error_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
____lambda12__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
	___lambda12_ (self, source_object, res);
	block5_data_unref (self);
}

static gboolean
__lambda13_ (NetworkWifiInterface* self)
{
	gboolean result;
	network_widgets_page_update ((NetworkWidgetsPage*) self);
	result = FALSE;
	return result;
}

static gboolean
___lambda13__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda13_ ((NetworkWifiInterface*) self);
	return result;
}

static void
network_wifi_interface_wifi_activate_cb (NetworkWifiInterface* self,
                                         NetworkWifiMenuItem* row)
{
	Block5Data* _data5_;
	NMDevice* _tmp0_;
	NMDevice* _tmp1_;
	NMDeviceWifi* _tmp2_;
	NMAccessPoint* _tmp3_;
	NMAccessPoint* _tmp4_;
	NMAccessPoint* _tmp5_;
	NetworkNetworkManager* network_manager = NULL;
	NetworkNetworkManager* _tmp6_;
	NetworkNetworkManager* _tmp7_;
	NMClient* _tmp8_;
	NMClient* _tmp9_;
	GPtrArray* connections = NULL;
	NMClient* _tmp10_;
	GPtrArray* _tmp11_;
	GPtrArray* _tmp12_;
	GPtrArray* device_connections = NULL;
	NMDeviceWifi* _tmp13_;
	GPtrArray* _tmp14_;
	GPtrArray* _tmp15_;
	GPtrArray* ap_connections = NULL;
	NMAccessPoint* _tmp16_;
	NMAccessPoint* _tmp17_;
	GPtrArray* _tmp18_;
	GPtrArray* _tmp19_;
	NMConnection* valid_connection = NULL;
	NMAccessPoint* _tmp20_;
	NMAccessPoint* _tmp21_;
	GPtrArray* _tmp22_;
	NMConnection* _tmp23_;
	NMConnection* _tmp24_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (row != NULL);
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = g_object_ref (self);
	_tmp0_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == NULL) {
		block5_data_unref (_data5_);
		_data5_ = NULL;
		return;
	}
	_tmp2_ = self->wifi_device;
	_tmp3_ = nm_device_wifi_get_active_access_point (_tmp2_);
	_tmp4_ = network_wifi_menu_item_get_ap (row);
	_tmp5_ = _tmp4_;
	if (_tmp3_ == _tmp5_) {
		block5_data_unref (_data5_);
		_data5_ = NULL;
		return;
	}
	_tmp6_ = network_network_manager_get_default ();
	network_manager = _tmp6_;
	_tmp7_ = network_manager;
	_tmp8_ = network_network_manager_get_client (_tmp7_);
	_tmp9_ = _tmp8_;
	_data5_->client = _tmp9_;
	_tmp10_ = _data5_->client;
	_tmp11_ = nm_client_get_connections (_tmp10_);
	_tmp12_ = _g_ptr_array_ref0 (_tmp11_);
	connections = _tmp12_;
	_tmp13_ = self->wifi_device;
	_tmp14_ = connections;
	_tmp15_ = nm_device_filter_connections ((NMDevice*) _tmp13_, _tmp14_);
	device_connections = _tmp15_;
	_tmp16_ = network_wifi_menu_item_get_ap (row);
	_tmp17_ = _tmp16_;
	_tmp18_ = device_connections;
	_tmp19_ = nm_access_point_filter_connections (_tmp17_, _tmp18_);
	ap_connections = _tmp19_;
	_tmp20_ = network_wifi_menu_item_get_ap (row);
	_tmp21_ = _tmp20_;
	_tmp22_ = ap_connections;
	_tmp23_ = network_wifi_interface_get_valid_connection (self, _tmp21_, _tmp22_);
	valid_connection = _tmp23_;
	_tmp24_ = valid_connection;
	if (_tmp24_ != NULL) {
		NMClient* _tmp25_;
		NMConnection* _tmp26_;
		NMDeviceWifi* _tmp27_;
		NMAccessPoint* _tmp28_;
		NMAccessPoint* _tmp29_;
		const gchar* _tmp30_;
		_tmp25_ = _data5_->client;
		_tmp26_ = valid_connection;
		_tmp27_ = self->wifi_device;
		_tmp28_ = network_wifi_menu_item_get_ap (row);
		_tmp29_ = _tmp28_;
		_tmp30_ = nm_object_get_path ((NMObject*) _tmp29_);
		nm_client_activate_connection_async (_tmp25_, _tmp26_, (NMDevice*) _tmp27_, _tmp30_, NULL, NULL, NULL);
		_g_object_unref0 (valid_connection);
		_g_ptr_array_unref0 (ap_connections);
		_g_ptr_array_unref0 (device_connections);
		_g_ptr_array_unref0 (connections);
		block5_data_unref (_data5_);
		_data5_ = NULL;
		return;
	}
	_tmp31_ = network_wifi_menu_item_get_is_secured (row);
	_tmp32_ = _tmp31_;
	if (_tmp32_) {
		Block6Data* _data6_;
		NMConnection* connection = NULL;
		NMConnection* _tmp33_;
		NMSettingConnection* s_con = NULL;
		gchar* _tmp34_;
		NMSettingConnection* _tmp35_ = NULL;
		NMConnection* _tmp36_;
		NMSettingConnection* _tmp37_;
		NMSetting* _tmp38_;
		gboolean _tmp39_ = FALSE;
		NMAccessPoint* _tmp40_;
		NMAccessPoint* _tmp41_;
		NMSettingWireless* s_wifi = NULL;
		NMSettingWireless* _tmp49_;
		NMSettingWireless* _tmp50_;
		NMAccessPoint* _tmp51_;
		NMAccessPoint* _tmp52_;
		GBytes* _tmp53_;
		NMConnection* _tmp54_;
		NMSettingWireless* _tmp55_;
		NMSetting* _tmp56_;
		gboolean _tmp57_ = FALSE;
		NMAccessPoint* _tmp58_;
		NMAccessPoint* _tmp59_;
		NMClient* _tmp73_;
		NMConnection* _tmp74_;
		NMDeviceWifi* _tmp75_;
		NMAccessPoint* _tmp76_;
		NMAccessPoint* _tmp77_;
		GtkWidget* _tmp78_;
		GtkWindow* _tmp79_;
		NMAWifiDialog* _tmp80_ = NULL;
		NMAWifiDialog* _tmp81_;
		NMAWifiDialog* _tmp82_;
		NMAWifiDialog* _tmp83_;
		_data6_ = g_slice_new0 (Block6Data);
		_data6_->_ref_count_ = 1;
		_data6_->_data5_ = block5_data_ref (_data5_);
		_tmp33_ = nm_simple_connection_new ();
		connection = _tmp33_;
		_tmp34_ = nm_utils_uuid_generate ();
		_tmp35_ = (NMSettingConnection*) nm_setting_connection_new ();
		g_object_set (_tmp35_, "uuid", _tmp34_, NULL);
		_g_free0 (_tmp34_);
		s_con = _tmp35_;
		_tmp36_ = connection;
		_tmp37_ = s_con;
		_tmp38_ = _g_object_ref0 ((NMSetting*) _tmp37_);
		nm_connection_add_setting (_tmp36_, _tmp38_);
		_tmp40_ = network_wifi_menu_item_get_ap (row);
		_tmp41_ = _tmp40_;
		if ((nm_access_point_get_rsn_flags (_tmp41_) & NM_802_11_AP_SEC_KEY_MGMT_SAE) == NM_802_11_AP_SEC_KEY_MGMT_SAE) {
			_tmp39_ = TRUE;
		} else {
			NMAccessPoint* _tmp42_;
			NMAccessPoint* _tmp43_;
			_tmp42_ = network_wifi_menu_item_get_ap (row);
			_tmp43_ = _tmp42_;
			_tmp39_ = (nm_access_point_get_wpa_flags (_tmp43_) & NM_802_11_AP_SEC_KEY_MGMT_SAE) == NM_802_11_AP_SEC_KEY_MGMT_SAE;
		}
		if (_tmp39_) {
			NMSettingWirelessSecurity* s_wsec = NULL;
			NMSettingWirelessSecurity* _tmp44_;
			NMSettingWirelessSecurity* _tmp45_;
			NMConnection* _tmp46_;
			NMSettingWirelessSecurity* _tmp47_;
			NMSetting* _tmp48_;
			_tmp44_ = (NMSettingWirelessSecurity*) nm_setting_wireless_security_new ();
			s_wsec = _tmp44_;
			_tmp45_ = s_wsec;
			g_object_set (_tmp45_, "key-mgmt", "sae", NULL);
			_tmp46_ = connection;
			_tmp47_ = s_wsec;
			_tmp48_ = _g_object_ref0 ((NMSetting*) _tmp47_);
			nm_connection_add_setting (_tmp46_, _tmp48_);
			_g_object_unref0 (s_wsec);
		}
		_tmp49_ = (NMSettingWireless*) nm_setting_wireless_new ();
		s_wifi = _tmp49_;
		_tmp50_ = s_wifi;
		_tmp51_ = network_wifi_menu_item_get_ap (row);
		_tmp52_ = _tmp51_;
		_tmp53_ = nm_access_point_get_ssid (_tmp52_);
		g_object_set (_tmp50_, "ssid", _tmp53_, NULL);
		_tmp54_ = connection;
		_tmp55_ = s_wifi;
		_tmp56_ = _g_object_ref0 ((NMSetting*) _tmp55_);
		nm_connection_add_setting (_tmp54_, _tmp56_);
		_tmp58_ = network_wifi_menu_item_get_ap (row);
		_tmp59_ = _tmp58_;
		if ((nm_access_point_get_rsn_flags (_tmp59_) & NM_802_11_AP_SEC_KEY_MGMT_802_1X) == NM_802_11_AP_SEC_KEY_MGMT_802_1X) {
			_tmp57_ = TRUE;
		} else {
			NMAccessPoint* _tmp60_;
			NMAccessPoint* _tmp61_;
			_tmp60_ = network_wifi_menu_item_get_ap (row);
			_tmp61_ = _tmp60_;
			_tmp57_ = (nm_access_point_get_wpa_flags (_tmp61_) & NM_802_11_AP_SEC_KEY_MGMT_802_1X) == NM_802_11_AP_SEC_KEY_MGMT_802_1X;
		}
		if (_tmp57_) {
			NMSettingWirelessSecurity* s_wsec = NULL;
			gchar* _tmp62_;
			NMSettingWirelessSecurity* _tmp63_ = NULL;
			NMConnection* _tmp64_;
			NMSettingWirelessSecurity* _tmp65_;
			NMSetting* _tmp66_;
			NMSetting8021x* s_8021x = NULL;
			NMSetting8021x* _tmp67_;
			NMSetting8021x* _tmp68_;
			NMSetting8021x* _tmp69_;
			NMConnection* _tmp70_;
			NMSetting8021x* _tmp71_;
			NMSetting* _tmp72_;
			_tmp62_ = g_strdup ("wpa-eap");
			_tmp63_ = (NMSettingWirelessSecurity*) nm_setting_wireless_security_new ();
			g_object_set (_tmp63_, "key-mgmt", _tmp62_, NULL);
			_g_free0 (_tmp62_);
			s_wsec = _tmp63_;
			_tmp64_ = connection;
			_tmp65_ = s_wsec;
			_tmp66_ = _g_object_ref0 ((NMSetting*) _tmp65_);
			nm_connection_add_setting (_tmp64_, _tmp66_);
			_tmp67_ = (NMSetting8021x*) nm_setting_802_1x_new ();
			s_8021x = _tmp67_;
			_tmp68_ = s_8021x;
			nm_setting_802_1x_add_eap_method (_tmp68_, "ttls");
			_tmp69_ = s_8021x;
			g_object_set (_tmp69_, "phase2-auth", "mschapv2", NULL);
			_tmp70_ = connection;
			_tmp71_ = s_8021x;
			_tmp72_ = _g_object_ref0 ((NMSetting*) _tmp71_);
			nm_connection_add_setting (_tmp70_, _tmp72_);
			_g_object_unref0 (s_8021x);
			_g_object_unref0 (s_wsec);
		}
		_tmp73_ = _data5_->client;
		_tmp74_ = connection;
		_tmp75_ = self->wifi_device;
		_tmp76_ = network_wifi_menu_item_get_ap (row);
		_tmp77_ = _tmp76_;
		_tmp78_ = gtk_widget_get_toplevel ((GtkWidget*) self);
		_tmp79_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp78_, gtk_window_get_type (), GtkWindow));
		_tmp80_ = (NMAWifiDialog*) nma_wifi_dialog_new (_tmp73_, _tmp74_, (NMDevice*) _tmp75_, _tmp77_, FALSE);
		gtk_window_set_deletable ((GtkWindow*) _tmp80_, FALSE);
		gtk_window_set_transient_for ((GtkWindow*) _tmp80_, _tmp79_);
		_g_object_unref0 (_tmp79_);
		g_object_set ((GtkWindow*) _tmp80_, "window-position", GTK_WIN_POS_CENTER_ON_PARENT, NULL);
		g_object_ref_sink (_tmp80_);
		_data6_->wifi_dialog = _tmp80_;
		_tmp81_ = _data6_->wifi_dialog;
		g_signal_connect_data ((GtkDialog*) _tmp81_, "response", (GCallback) ____lambda10__gtk_dialog_response, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
		_tmp82_ = _data6_->wifi_dialog;
		gtk_dialog_run ((GtkDialog*) _tmp82_);
		_tmp83_ = _data6_->wifi_dialog;
		gtk_widget_destroy ((GtkWidget*) _tmp83_);
		_g_object_unref0 (s_wifi);
		_g_object_unref0 (s_con);
		_g_object_unref0 (connection);
		block6_data_unref (_data6_);
		_data6_ = NULL;
	} else {
		NMClient* _tmp84_;
		NMConnection* _tmp85_;
		NMConnection* _tmp86_;
		NMDeviceWifi* _tmp87_;
		NMAccessPoint* _tmp88_;
		NMAccessPoint* _tmp89_;
		const gchar* _tmp90_;
		_tmp84_ = _data5_->client;
		_tmp85_ = nm_simple_connection_new ();
		_tmp86_ = _tmp85_;
		_tmp87_ = self->wifi_device;
		_tmp88_ = network_wifi_menu_item_get_ap (row);
		_tmp89_ = _tmp88_;
		_tmp90_ = nm_object_get_path ((NMObject*) _tmp89_);
		nm_client_add_and_activate_connection_async (_tmp84_, _tmp86_, (NMDevice*) _tmp87_, _tmp90_, NULL, ____lambda12__gasync_ready_callback, block5_data_ref (_data5_));
		_g_object_unref0 (_tmp86_);
	}
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda13__gsource_func, g_object_ref (self), g_object_unref);
	_g_object_unref0 (valid_connection);
	_g_ptr_array_unref0 (ap_connections);
	_g_ptr_array_unref0 (device_connections);
	_g_ptr_array_unref0 (connections);
	block5_data_unref (_data5_);
	_data5_ = NULL;
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = (gint) self->len;
	return result;
}

static NMConnection*
network_wifi_interface_get_valid_connection (NetworkWifiInterface* self,
                                             NMAccessPoint* ap,
                                             GPtrArray* ap_connections)
{
	NMConnection* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (ap != NULL, NULL);
	g_return_val_if_fail (ap_connections != NULL, NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				gint _tmp3_;
				NMConnection* connection = NULL;
				gconstpointer _tmp4_;
				NMConnection* _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = vala_g_ptr_array_get_length (ap_connections);
				_tmp3_ = _tmp2_;
				if (!(i < _tmp3_)) {
					break;
				}
				_tmp4_ = g_ptr_array_index (ap_connections, (guint) i);
				connection = (NMConnection*) _tmp4_;
				_tmp5_ = connection;
				if (nm_access_point_connection_valid (ap, _tmp5_)) {
					NMConnection* _tmp6_;
					NMConnection* _tmp7_;
					_tmp6_ = connection;
					_tmp7_ = _g_object_ref0 (_tmp6_);
					result = _tmp7_;
					return result;
				}
			}
		}
	}
	result = NULL;
	return result;
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		NetworkWifiInterface* self;
		self = _data7_->self;
		_g_object_unref0 (_data7_->hidden_dialog);
		_g_object_unref0 (self);
		g_slice_free (Block7Data, _data7_);
	}
}

static void
__lambda19_ (Block7Data* _data7_,
             gint response)
{
	NetworkWifiInterface* self;
	self = _data7_->self;
	if (response == ((gint) GTK_RESPONSE_OK)) {
		network_wifi_interface_connect_to_network (self, _data7_->hidden_dialog, NULL, NULL);
	}
}

static void
___lambda19__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
	__lambda19_ (self, response_id);
}

static void
network_wifi_interface_connect_to_hidden (NetworkWifiInterface* self)
{
	Block7Data* _data7_;
	NetworkNetworkManager* network_manager = NULL;
	NetworkNetworkManager* _tmp0_;
	NMClient* _tmp1_;
	NMClient* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWindow* _tmp4_;
	NMAWifiDialog* _tmp5_ = NULL;
	g_return_if_fail (self != NULL);
	_data7_ = g_slice_new0 (Block7Data);
	_data7_->_ref_count_ = 1;
	_data7_->self = g_object_ref (self);
	_tmp0_ = network_network_manager_get_default ();
	network_manager = _tmp0_;
	_tmp1_ = network_network_manager_get_client (network_manager);
	_tmp2_ = _tmp1_;
	_tmp3_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_window_get_type (), GtkWindow));
	_tmp5_ = (NMAWifiDialog*) nma_wifi_dialog_new_for_other (_tmp2_);
	gtk_window_set_deletable ((GtkWindow*) _tmp5_, FALSE);
	gtk_window_set_transient_for ((GtkWindow*) _tmp5_, _tmp4_);
	_g_object_unref0 (_tmp4_);
	g_object_set ((GtkWindow*) _tmp5_, "window-position", GTK_WIN_POS_CENTER_ON_PARENT, NULL);
	g_object_ref_sink (_tmp5_);
	_data7_->hidden_dialog = _tmp5_;
	g_signal_connect_data ((GtkDialog*) _data7_->hidden_dialog, "response", (GCallback) ___lambda19__gtk_dialog_response, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	gtk_dialog_run ((GtkDialog*) _data7_->hidden_dialog);
	gtk_widget_destroy ((GtkWidget*) _data7_->hidden_dialog);
	block7_data_unref (_data7_);
	_data7_ = NULL;
}

static void
network_wifi_interface_connect_to_network_data_free (gpointer _data)
{
	NetworkWifiInterfaceConnectToNetworkData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->wifi_dialog);
	_g_object_unref0 (_data_->self);
	g_slice_free (NetworkWifiInterfaceConnectToNetworkData, _data_);
}

static void
network_wifi_interface_connect_to_network (NetworkWifiInterface* self,
                                           NMAWifiDialog* wifi_dialog,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	NetworkWifiInterfaceConnectToNetworkData* _data_;
	NetworkWifiInterface* _tmp0_;
	NMAWifiDialog* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (wifi_dialog != NULL);
	_data_ = g_slice_new0 (NetworkWifiInterfaceConnectToNetworkData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, network_wifi_interface_connect_to_network_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (wifi_dialog);
	_g_object_unref0 (_data_->wifi_dialog);
	_data_->wifi_dialog = _tmp1_;
	network_wifi_interface_connect_to_network_co (_data_);
}

static void
network_wifi_interface_connect_to_network_finish (NetworkWifiInterface* self,
                                                  GAsyncResult* _res_)
{
	NetworkWifiInterfaceConnectToNetworkData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
	g_atomic_int_inc (&_data8_->_ref_count_);
	return _data8_;
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
		NetworkWifiInterface* self;
		self = _data8_->self;
		_g_object_unref0 (_data8_->dialog_connection);
		_g_object_unref0 (_data8_->fuzzy);
		_g_object_unref0 (self);
		g_slice_free (Block8Data, _data8_);
	}
}

static void
__lambda11_ (Block8Data* _data8_,
             NMRemoteConnection* possible)
{
	NetworkWifiInterface* self;
	NMConnection* _tmp0_;
	self = _data8_->self;
	g_return_if_fail (possible != NULL);
	_tmp0_ = _data8_->dialog_connection;
	if (nm_connection_compare (_tmp0_, (NMConnection*) possible, NM_SETTING_COMPARE_FLAG_FUZZY | NM_SETTING_COMPARE_FLAG_IGNORE_ID)) {
		NMConnection* _tmp1_;
		_tmp1_ = _g_object_ref0 ((NMConnection*) possible);
		_g_object_unref0 (_data8_->fuzzy);
		_data8_->fuzzy = _tmp1_;
	}
}

static void
___lambda11__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda11_ (self, (NMRemoteConnection*) data);
}

static void
network_wifi_interface_connect_to_network_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	NetworkWifiInterfaceConnectToNetworkData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	network_wifi_interface_connect_to_network_co (_data_);
}

static gboolean
network_wifi_interface_connect_to_network_co (NetworkWifiInterfaceConnectToNetworkData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data8_ = g_slice_new0 (Block8Data);
	_data_->_data8_->_ref_count_ = 1;
	_data_->_data8_->self = g_object_ref (_data_->self);
	_data_->_data8_->_async_data_ = _data_;
	_data_->_data8_->fuzzy = NULL;
	_data_->dialog_ap = NULL;
	_data_->_tmp0_ = NULL;
	_data_->_tmp1_ = NULL;
	_data_->_tmp2_ = nma_wifi_dialog_get_connection (_data_->wifi_dialog, &_data_->_tmp0_, &_data_->_tmp1_);
	_g_object_unref0 (_data_->dialog_device);
	_data_->dialog_device = _data_->_tmp0_;
	_g_object_unref0 (_data_->dialog_ap);
	_data_->dialog_ap = _data_->_tmp1_;
	_data_->_data8_->dialog_connection = _data_->_tmp2_;
	_data_->_tmp3_ = network_network_manager_get_default ();
	_data_->network_manager = _data_->_tmp3_;
	_data_->_tmp4_ = _data_->network_manager;
	_data_->_tmp5_ = network_network_manager_get_client (_data_->_tmp4_);
	_data_->_tmp6_ = _data_->_tmp5_;
	_data_->client = _data_->_tmp6_;
	_data_->_tmp7_ = _data_->client;
	_data_->_tmp8_ = nm_client_get_connections (_data_->_tmp7_);
	g_ptr_array_foreach (_data_->_tmp8_, ___lambda11__gfunc, _data_->_data8_);
	_data_->path = NULL;
	_data_->_tmp9_ = _data_->dialog_ap;
	if (_data_->_tmp9_ != NULL) {
		_data_->_tmp10_ = _data_->dialog_ap;
		_data_->_tmp11_ = nm_object_get_path ((NMObject*) _data_->_tmp10_);
		_data_->_tmp12_ = g_strdup (_data_->_tmp11_);
		_g_free0 (_data_->path);
		_data_->path = _data_->_tmp12_;
	}
	_data_->_tmp13_ = _data_->_data8_->fuzzy;
	if (_data_->_tmp13_ != NULL) {
		{
			_data_->_tmp14_ = _data_->client;
			_data_->_tmp15_ = _data_->_data8_->fuzzy;
			_data_->_tmp16_ = _data_->self->wifi_device;
			_data_->_tmp17_ = _data_->path;
			_data_->_state_ = 1;
			nm_client_activate_connection_async (_data_->_tmp14_, _data_->_tmp15_, (NMDevice*) _data_->_tmp16_, _data_->_tmp17_, NULL, network_wifi_interface_connect_to_network_ready, _data_);
			return FALSE;
			_state_1:
			_data_->_tmp18_ = nm_client_activate_connection_finish (_data_->_tmp14_, _data_->_res_, &_data_->_inner_error0_);
			_data_->_tmp19_ = _data_->_tmp18_;
			_g_object_unref0 (_data_->_tmp19_);
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			_data_->_error_ = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			_data_->_tmp20_ = _data_->_error_;
			_data_->_tmp21_ = _data_->_tmp20_->message;
			g_critical ("WifiPage.vala:607: %s", _data_->_tmp21_);
			_g_error_free0 (_data_->_error_);
		}
		__finally0:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_free0 (_data_->path);
			_g_object_unref0 (_data_->dialog_ap);
			_g_object_unref0 (_data_->dialog_device);
			block8_data_unref (_data_->_data8_);
			_data_->_data8_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	} else {
		_data_->mode = NULL;
		_data_->_tmp22_ = _data_->_data8_->dialog_connection;
		_data_->_tmp23_ = nm_connection_get_setting_wireless (_data_->_tmp22_);
		_data_->setting_wireless = _data_->_tmp23_;
		_data_->_tmp24_ = _data_->setting_wireless;
		if (_data_->_tmp24_ != NULL) {
			_data_->_tmp25_ = _data_->setting_wireless;
			_data_->_tmp26_ = nm_setting_wireless_get_mode (_data_->_tmp25_);
			_data_->_tmp27_ = g_strdup (_data_->_tmp26_);
			_g_free0 (_data_->mode);
			_data_->mode = _data_->_tmp27_;
		}
		_data_->_tmp28_ = _data_->mode;
		if (g_strcmp0 (_data_->_tmp28_, "adhoc") == 0) {
			_data_->_tmp29_ = _data_->_data8_->dialog_connection;
			_data_->_tmp30_ = nm_connection_get_setting_connection (_data_->_tmp29_);
			_data_->_tmp31_ = _g_object_ref0 (_data_->_tmp30_);
			_data_->connection_setting = _data_->_tmp31_;
			_data_->_tmp32_ = _data_->connection_setting;
			if (_data_->_tmp32_ == NULL) {
				_data_->_tmp33_ = (NMSettingConnection*) nm_setting_connection_new ();
				_g_object_unref0 (_data_->connection_setting);
				_data_->connection_setting = _data_->_tmp33_;
			}
			_data_->_tmp34_ = _data_->_data8_->dialog_connection;
			_data_->_tmp35_ = _data_->connection_setting;
			_data_->_tmp36_ = _g_object_ref0 ((NMSetting*) _data_->_tmp35_);
			nm_connection_add_setting (_data_->_tmp34_, _data_->_tmp36_);
			_g_object_unref0 (_data_->connection_setting);
		}
		{
			_data_->_tmp37_ = _data_->client;
			_data_->_tmp38_ = _data_->_data8_->dialog_connection;
			_data_->_tmp39_ = _data_->dialog_device;
			_data_->_tmp40_ = _data_->path;
			_data_->_state_ = 2;
			nm_client_add_and_activate_connection_async (_data_->_tmp37_, _data_->_tmp38_, _data_->_tmp39_, _data_->_tmp40_, NULL, network_wifi_interface_connect_to_network_ready, _data_);
			return FALSE;
			_state_2:
			_data_->_tmp41_ = nm_client_add_and_activate_connection_finish (_data_->_tmp37_, _data_->_res_, &_data_->_inner_error0_);
			_data_->_tmp42_ = _data_->_tmp41_;
			_g_object_unref0 (_data_->_tmp42_);
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			_data_->_vala1__error_ = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			_data_->_tmp43_ = _data_->_vala1__error_;
			_data_->_tmp44_ = _data_->_tmp43_->message;
			g_critical ("WifiPage.vala:628: %s", _data_->_tmp44_);
			_g_error_free0 (_data_->_vala1__error_);
		}
		__finally1:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_free0 (_data_->mode);
			_g_free0 (_data_->path);
			_g_object_unref0 (_data_->dialog_ap);
			_g_object_unref0 (_data_->dialog_device);
			block8_data_unref (_data_->_data8_);
			_data_->_data8_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_g_free0 (_data_->mode);
	}
	_g_free0 (_data_->path);
	_g_object_unref0 (_data_->dialog_ap);
	_g_object_unref0 (_data_->dialog_device);
	block8_data_unref (_data_->_data8_);
	_data_->_data8_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
network_wifi_interface_cancel_scan (NetworkWifiInterface* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->timeout_scan > ((guint) 0)) {
		g_source_remove (self->priv->timeout_scan);
		self->priv->timeout_scan = (guint) 0;
	}
}

static gboolean
___lambda14_ (NetworkWifiInterface* self)
{
	NMDeviceWifi* _tmp0_;
	GtkStack* _tmp1_;
	gboolean result;
	_tmp0_ = self->wifi_device;
	if (network_utils_get_device_is_hotspot (_tmp0_)) {
		result = FALSE;
		return result;
	}
	self->priv->timeout_scan = (guint) 0;
	_tmp1_ = self->priv->placeholder;
	gtk_stack_set_visible_child_name (_tmp1_, "no-aps");
	result = FALSE;
	return result;
}

static gboolean
____lambda14__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda14_ ((NetworkWifiInterface*) self);
	return result;
}

static void
network_wifi_interface_set_scan_placeholder (NetworkWifiInterface* self)
{
	NMDeviceState _tmp0_;
	NMDeviceState _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = network_widgets_page_get_state ((NetworkWidgetsPage*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == NM_DEVICE_STATE_DISCONNECTED) {
		GtkStack* _tmp2_;
		NMDeviceWifi* _tmp3_;
		_tmp2_ = self->priv->placeholder;
		gtk_stack_set_visible_child_name (_tmp2_, "scanning");
		network_wifi_interface_cancel_scan (self);
		_tmp3_ = self->wifi_device;
		nm_device_wifi_request_scan_async (_tmp3_, NULL, NULL, NULL);
		self->priv->timeout_scan = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 5000, ____lambda14__gsource_func, g_object_ref (self), g_object_unref);
	}
}

static gint
network_wifi_interface_sort_func (NetworkWifiInterface* self,
                                  GtkListBoxRow* r1,
                                  GtkListBoxRow* r2)
{
	gboolean _tmp0_ = FALSE;
	NMAccessPoint* _tmp1_;
	NMAccessPoint* _tmp2_;
	guint8 _tmp3_;
	guint8 _tmp4_;
	NMAccessPoint* _tmp5_;
	NMAccessPoint* _tmp6_;
	guint8 _tmp7_;
	guint8 _tmp8_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (r1 != NULL, 0);
	g_return_val_if_fail (r2 != NULL, 0);
	if (r1 == NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = r2 == NULL;
	}
	if (_tmp0_) {
		result = 0;
		return result;
	}
	_tmp1_ = network_wifi_menu_item_get_ap (G_TYPE_CHECK_INSTANCE_CAST (r2, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem));
	_tmp2_ = _tmp1_;
	_tmp3_ = nm_access_point_get_strength (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = network_wifi_menu_item_get_ap (G_TYPE_CHECK_INSTANCE_CAST (r1, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem));
	_tmp6_ = _tmp5_;
	_tmp7_ = nm_access_point_get_strength (_tmp6_);
	_tmp8_ = _tmp7_;
	result = (gint) (_tmp4_ - _tmp8_);
	return result;
}

static NetworkWifiMenuItem*
network_wifi_interface_get_active_wifi_item (NetworkWifiInterface* self)
{
	NetworkWifiMenuItem* result;
	NetworkWifiMenuItem* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_active_wifi_item;
	result = _tmp0_;
	return result;
}

static void
network_wifi_interface_set_active_wifi_item (NetworkWifiInterface* self,
                                             NetworkWifiMenuItem* value)
{
	NetworkWifiMenuItem* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_active_wifi_item);
	self->priv->_active_wifi_item = _tmp0_;
}

static gint
_network_wifi_interface_sort_func_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                          GtkListBoxRow* row2,
                                                          gpointer self)
{
	gint result;
	result = network_wifi_interface_sort_func ((NetworkWifiInterface*) self, row1, row2);
	return result;
}

static void
_network_wifi_interface___lambda20_ (NetworkWifiInterface* self)
{
	GtkToggleButton* _tmp0_;
	_tmp0_ = self->info_btn;
	gtk_toggle_button_set_active (_tmp0_, FALSE);
}

static void
__network_wifi_interface___lambda20__gtk_widget_hide (GtkWidget* _sender,
                                                      gpointer self)
{
	_network_wifi_interface___lambda20_ ((NetworkWifiInterface*) self);
}

static void
_network_wifi_interface_connect_to_hidden_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self)
{
	network_wifi_interface_connect_to_hidden ((NetworkWifiInterface*) self);
}

static void
_network_widgets_page_update_rf_kill_manager_device_added (RFKillManager* _sender,
                                                           RFKillDevice* device,
                                                           gpointer self)
{
	network_widgets_page_update ((NetworkWidgetsPage*) self);
}

static void
_network_widgets_page_update_rf_kill_manager_device_changed (RFKillManager* _sender,
                                                             RFKillDevice* device,
                                                             gpointer self)
{
	network_widgets_page_update ((NetworkWidgetsPage*) self);
}

static void
_network_widgets_page_update_rf_kill_manager_device_deleted (RFKillManager* _sender,
                                                             RFKillDevice* device,
                                                             gpointer self)
{
	network_widgets_page_update ((NetworkWidgetsPage*) self);
}

static void
_network_widgets_page_update_g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self)
{
	network_widgets_page_update ((NetworkWidgetsPage*) self);
}

static void
_network_wifi_interface_access_point_added_cb_nm_device_wifi_access_point_added (NMDeviceWifi* _sender,
                                                                                 GObject* ap,
                                                                                 gpointer self)
{
	network_wifi_interface_access_point_added_cb ((NetworkWifiInterface*) self, ap);
}

static void
_network_wifi_interface_access_point_removed_cb_nm_device_wifi_access_point_removed (NMDeviceWifi* _sender,
                                                                                     GObject* ap,
                                                                                     gpointer self)
{
	network_wifi_interface_access_point_removed_cb ((NetworkWifiInterface*) self, ap);
}

static void
_network_widgets_page_update_nm_device_state_changed (NMDevice* _sender,
                                                      guint new_state,
                                                      guint old_state,
                                                      guint reason,
                                                      gpointer self)
{
	network_widgets_page_update ((NetworkWidgetsPage*) self);
}

static void
_network_wifi_interface_access_point_added_cb_gfunc (gconstpointer data,
                                                     gpointer self)
{
	network_wifi_interface_access_point_added_cb ((NetworkWifiInterface*) self, (GObject*) data);
}

static GObject *
network_wifi_interface_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkWifiInterface * self;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp1_;
	GtkStack* _tmp2_ = NULL;
	GtkListBox* _tmp3_;
	GtkListBox* _tmp4_;
	GtkListBox* _tmp5_;
	GtkStack* _tmp6_;
	GraniteWidgetsAlertView* hotspot_mode_alert = NULL;
	GraniteWidgetsAlertView* _tmp7_;
	GraniteWidgetsAlertView* _tmp8_;
	GtkListBox* _tmp9_;
	GtkListBox* _tmp10_;
	GtkListBox* _tmp11_;
	GtkScrolledWindow* _tmp12_;
	GtkScrolledWindow* _tmp13_;
	GtkListBox* _tmp14_;
	GtkStack* _tmp15_;
	GtkStack* _tmp16_;
	GraniteWidgetsAlertView* _tmp17_;
	GtkStack* _tmp18_;
	GtkScrolledWindow* _tmp19_;
	GtkStack* _tmp20_;
	GtkScrolledWindow* _tmp21_;
	GtkFrame* main_frame = NULL;
	GtkFrame* _tmp22_ = NULL;
	GtkFrame* _tmp23_;
	GtkStyleContext* _tmp24_;
	GtkFrame* _tmp25_;
	GtkStack* _tmp26_;
	NetworkWidgetsInfoBox* _tmp27_;
	GtkToggleButton* _tmp28_;
	GtkPopover* _tmp29_ = NULL;
	GtkPopover* _tmp30_;
	NetworkWidgetsInfoBox* _tmp31_;
	GtkPopover* _tmp32_;
	GtkFrame* _tmp33_;
	GtkFrame* _tmp34_;
	GtkStyleContext* _tmp35_;
	GtkRevealer* _tmp36_ = NULL;
	GtkRevealer* _tmp37_;
	GtkFrame* _tmp38_;
	GtkButton* _tmp39_;
	GtkButton* _tmp40_;
	GtkButtonBox* _tmp41_;
	GtkButtonBox* _tmp42_;
	NetworkWidgetsSettingsButton* _tmp43_;
	NetworkWidgetsSettingsButton* _tmp44_;
	GtkButtonBox* _tmp45_;
	GtkButtonBox* _tmp46_;
	GtkButton* _tmp47_;
	NMDevice* _tmp48_;
	NMDevice* _tmp49_;
	NMDeviceWifi* _tmp50_;
	GraniteWidgetsAlertView* no_aps_alert = NULL;
	GraniteWidgetsAlertView* _tmp51_;
	GraniteWidgetsAlertView* _tmp52_;
	GraniteWidgetsAlertView* wireless_off_alert = NULL;
	GraniteWidgetsAlertView* _tmp53_;
	GraniteWidgetsAlertView* _tmp54_;
	GtkSpinner* spinner = NULL;
	GtkSpinner* _tmp55_ = NULL;
	GtkSpinner* _tmp56_;
	GtkLabel* scanning = NULL;
	GtkLabel* _tmp57_ = NULL;
	GtkLabel* _tmp58_;
	GtkStyleContext* _tmp59_;
	GtkBox* scanning_box = NULL;
	GtkBox* _tmp60_ = NULL;
	GtkBox* _tmp61_;
	GtkLabel* _tmp62_;
	GtkBox* _tmp63_;
	GtkSpinner* _tmp64_;
	GtkStack* _tmp65_;
	GraniteWidgetsAlertView* _tmp66_;
	GtkStack* _tmp67_;
	GraniteWidgetsAlertView* _tmp68_;
	GtkStack* _tmp69_;
	GtkBox* _tmp70_;
	GtkStack* _tmp71_;
	RFKillManager* _tmp72_;
	RFKillManager* _tmp73_;
	RFKillManager* _tmp74_;
	RFKillManager* _tmp75_;
	RFKillManager* _tmp76_;
	NMDeviceWifi* _tmp77_;
	NMDeviceWifi* _tmp78_;
	NMDeviceWifi* _tmp79_;
	NMDeviceWifi* _tmp80_;
	GPtrArray* aps = NULL;
	NMDeviceWifi* _tmp81_;
	GPtrArray* _tmp82_;
	GPtrArray* _tmp83_;
	gboolean _tmp84_ = FALSE;
	GPtrArray* _tmp85_;
	GtkGrid* _tmp90_;
	GtkGrid* _tmp91_;
	GtkRevealer* _tmp92_;
	GtkGrid* _tmp93_;
	GtkGrid* _tmp94_;
	GtkFrame* _tmp95_;
	GtkGrid* _tmp96_;
	GtkGrid* _tmp97_;
	parent_class = G_OBJECT_CLASS (network_wifi_interface_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_WIFI_INTERFACE, NetworkWifiInterface);
	granite_simple_settings_page_set_icon_name ((GraniteSimpleSettingsPage*) self, "network-wireless");
	_tmp0_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp1_ = _tmp0_;
	gtk_grid_set_row_spacing (_tmp1_, 0);
	_tmp2_ = (GtkStack*) gtk_stack_new ();
	gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->placeholder);
	self->priv->placeholder = _tmp2_;
	_tmp3_ = (GtkListBox*) gtk_list_box_new ();
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->wifi_list);
	self->priv->wifi_list = _tmp3_;
	_tmp4_ = self->priv->wifi_list;
	gtk_list_box_set_sort_func (_tmp4_, _network_wifi_interface_sort_func_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
	_tmp5_ = self->priv->wifi_list;
	_tmp6_ = self->priv->placeholder;
	gtk_list_box_set_placeholder (_tmp5_, (GtkWidget*) _tmp6_);
	_tmp7_ = granite_widgets_alert_view_new (_ ("This device is in Hotspot Mode"), _ ("Turn off the Hotspot Mode to connect to other Access Points."), "");
	g_object_ref_sink (_tmp7_);
	hotspot_mode_alert = _tmp7_;
	_tmp8_ = hotspot_mode_alert;
	gtk_widget_show_all ((GtkWidget*) _tmp8_);
	_tmp9_ = self->priv->wifi_list;
	gtk_list_box_set_selection_mode (_tmp9_, GTK_SELECTION_SINGLE);
	_tmp10_ = self->priv->wifi_list;
	gtk_list_box_set_activate_on_single_click (_tmp10_, FALSE);
	_tmp11_ = self->priv->wifi_list;
	gtk_widget_set_visible ((GtkWidget*) _tmp11_, TRUE);
	_tmp12_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp12_);
	_g_object_unref0 (self->scrolled);
	self->scrolled = _tmp12_;
	_tmp13_ = self->scrolled;
	_tmp14_ = self->priv->wifi_list;
	gtk_container_add ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
	_tmp15_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp15_);
	_g_object_unref0 (self->list_stack);
	self->list_stack = _tmp15_;
	_tmp16_ = self->list_stack;
	_tmp17_ = hotspot_mode_alert;
	gtk_container_add ((GtkContainer*) _tmp16_, (GtkWidget*) _tmp17_);
	_tmp18_ = self->list_stack;
	_tmp19_ = self->scrolled;
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
	_tmp20_ = self->list_stack;
	_tmp21_ = self->scrolled;
	gtk_stack_set_visible_child (_tmp20_, (GtkWidget*) _tmp21_);
	_tmp22_ = (GtkFrame*) gtk_frame_new (NULL);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp22_, 12);
	gtk_widget_set_vexpand ((GtkWidget*) _tmp22_, TRUE);
	g_object_ref_sink (_tmp22_);
	main_frame = _tmp22_;
	_tmp23_ = main_frame;
	_tmp24_ = gtk_widget_get_style_context ((GtkWidget*) _tmp23_);
	gtk_style_context_add_class (_tmp24_, GTK_STYLE_CLASS_VIEW);
	_tmp25_ = main_frame;
	_tmp26_ = self->list_stack;
	gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) _tmp26_);
	_tmp27_ = ((NetworkWidgetsPage*) self)->info_box;
	g_object_set ((GtkWidget*) _tmp27_, "margin", 12, NULL);
	_tmp28_ = self->info_btn;
	_tmp29_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) _tmp28_);
	gtk_popover_set_position (_tmp29_, GTK_POS_BOTTOM);
	g_object_ref_sink (_tmp29_);
	_g_object_unref0 (self->popover);
	self->popover = _tmp29_;
	_tmp30_ = self->popover;
	_tmp31_ = ((NetworkWidgetsPage*) self)->info_box;
	gtk_container_add ((GtkContainer*) _tmp30_, (GtkWidget*) _tmp31_);
	_tmp32_ = self->popover;
	g_signal_connect_object ((GtkWidget*) _tmp32_, "hide", (GCallback) __network_wifi_interface___lambda20__gtk_widget_hide, self, 0);
	_tmp33_ = (GtkFrame*) gtk_frame_new (NULL);
	g_object_ref_sink (_tmp33_);
	_g_object_unref0 (self->connected_frame);
	self->connected_frame = _tmp33_;
	_tmp34_ = self->connected_frame;
	_tmp35_ = gtk_widget_get_style_context ((GtkWidget*) _tmp34_);
	gtk_style_context_add_class (_tmp35_, GTK_STYLE_CLASS_VIEW);
	_tmp36_ = (GtkRevealer*) gtk_revealer_new ();
	gtk_revealer_set_transition_type (_tmp36_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
	g_object_ref_sink (_tmp36_);
	_g_object_unref0 (self->top_revealer);
	self->top_revealer = _tmp36_;
	_tmp37_ = self->top_revealer;
	_tmp38_ = self->connected_frame;
	gtk_container_add ((GtkContainer*) _tmp37_, (GtkWidget*) _tmp38_);
	_tmp39_ = (GtkButton*) gtk_button_new_with_label (_ ("Connect to Hidden Network…"));
	g_object_ref_sink (_tmp39_);
	_g_object_unref0 (self->hidden_btn);
	self->hidden_btn = _tmp39_;
	_tmp40_ = self->hidden_btn;
	g_signal_connect_object (_tmp40_, "clicked", (GCallback) _network_wifi_interface_connect_to_hidden_gtk_button_clicked, self, 0);
	_tmp41_ = granite_simple_settings_page_get_action_area ((GraniteSimpleSettingsPage*) self);
	_tmp42_ = _tmp41_;
	_tmp43_ = network_widgets_settings_button_new ();
	g_object_ref_sink (_tmp43_);
	_tmp44_ = _tmp43_;
	gtk_container_add ((GtkContainer*) _tmp42_, (GtkWidget*) _tmp44_);
	_g_object_unref0 (_tmp44_);
	_tmp45_ = granite_simple_settings_page_get_action_area ((GraniteSimpleSettingsPage*) self);
	_tmp46_ = _tmp45_;
	_tmp47_ = self->hidden_btn;
	gtk_container_add ((GtkContainer*) _tmp46_, (GtkWidget*) _tmp47_);
	_tmp48_ = network_widgets_page_get_device ((NetworkWidgetsPage*) self);
	_tmp49_ = _tmp48_;
	_tmp50_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, nm_device_wifi_get_type (), NMDeviceWifi));
	_g_object_unref0 (self->wifi_device);
	self->wifi_device = _tmp50_;
	network_wifi_interface_set_active_wifi_item (self, NULL);
	_tmp51_ = granite_widgets_alert_view_new (_ ("No Access Points Available"), _ ("There are no wireless access points within range."), "");
	g_object_ref_sink (_tmp51_);
	no_aps_alert = _tmp51_;
	_tmp52_ = no_aps_alert;
	gtk_widget_show_all ((GtkWidget*) _tmp52_);
	_tmp53_ = granite_widgets_alert_view_new (_ ("Wireless Is Disabled"), _ ("Enable wireless to discover nearby wireless access points."), "");
	g_object_ref_sink (_tmp53_);
	wireless_off_alert = _tmp53_;
	_tmp54_ = wireless_off_alert;
	gtk_widget_show_all ((GtkWidget*) _tmp54_);
	_tmp55_ = (GtkSpinner*) gtk_spinner_new ();
	gtk_widget_set_visible ((GtkWidget*) _tmp55_, TRUE);
	gtk_widget_set_halign ((GtkWidget*) _tmp55_, GTK_ALIGN_CENTER);
	gtk_widget_set_valign ((GtkWidget*) _tmp55_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp55_);
	spinner = _tmp55_;
	_tmp56_ = spinner;
	gtk_spinner_start (_tmp56_);
	_tmp57_ = (GtkLabel*) gtk_label_new (_ ("Scanning for Access Points…"));
	gtk_widget_set_visible ((GtkWidget*) _tmp57_, TRUE);
	g_object_set (_tmp57_, "wrap", TRUE, NULL);
	g_object_set (_tmp57_, "wrap-mode", PANGO_WRAP_WORD_CHAR, NULL);
	gtk_label_set_max_width_chars (_tmp57_, 30);
	gtk_label_set_justify (_tmp57_, GTK_JUSTIFY_CENTER);
	g_object_ref_sink (_tmp57_);
	scanning = _tmp57_;
	_tmp58_ = scanning;
	_tmp59_ = gtk_widget_get_style_context ((GtkWidget*) _tmp58_);
	gtk_style_context_add_class (_tmp59_, "h2");
	_tmp60_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
	gtk_widget_set_visible ((GtkWidget*) _tmp60_, TRUE);
	gtk_widget_set_valign ((GtkWidget*) _tmp60_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp60_);
	scanning_box = _tmp60_;
	_tmp61_ = scanning_box;
	_tmp62_ = scanning;
	gtk_container_add ((GtkContainer*) _tmp61_, (GtkWidget*) _tmp62_);
	_tmp63_ = scanning_box;
	_tmp64_ = spinner;
	gtk_container_add ((GtkContainer*) _tmp63_, (GtkWidget*) _tmp64_);
	_tmp65_ = self->priv->placeholder;
	_tmp66_ = no_aps_alert;
	gtk_stack_add_named (_tmp65_, (GtkWidget*) _tmp66_, "no-aps");
	_tmp67_ = self->priv->placeholder;
	_tmp68_ = wireless_off_alert;
	gtk_stack_add_named (_tmp67_, (GtkWidget*) _tmp68_, "wireless-off");
	_tmp69_ = self->priv->placeholder;
	_tmp70_ = scanning_box;
	gtk_stack_add_named (_tmp69_, (GtkWidget*) _tmp70_, "scanning");
	_tmp71_ = self->priv->placeholder;
	gtk_stack_set_visible_child_name (_tmp71_, "no-aps");
	_tmp72_ = rf_kill_manager_new ();
	_g_object_unref0 (self->priv->rfkill);
	self->priv->rfkill = _tmp72_;
	_tmp73_ = self->priv->rfkill;
	rf_kill_manager_open (_tmp73_);
	_tmp74_ = self->priv->rfkill;
	g_signal_connect_object (_tmp74_, "device-added", (GCallback) _network_widgets_page_update_rf_kill_manager_device_added, (NetworkWidgetsPage*) self, 0);
	_tmp75_ = self->priv->rfkill;
	g_signal_connect_object (_tmp75_, "device-changed", (GCallback) _network_widgets_page_update_rf_kill_manager_device_changed, (NetworkWidgetsPage*) self, 0);
	_tmp76_ = self->priv->rfkill;
	g_signal_connect_object (_tmp76_, "device-deleted", (GCallback) _network_widgets_page_update_rf_kill_manager_device_deleted, (NetworkWidgetsPage*) self, 0);
	_tmp77_ = self->wifi_device;
	g_signal_connect_object ((GObject*) _tmp77_, "notify::active-access-point", (GCallback) _network_widgets_page_update_g_object_notify, (NetworkWidgetsPage*) self, 0);
	_tmp78_ = self->wifi_device;
	g_signal_connect_object (_tmp78_, "access-point-added", (GCallback) _network_wifi_interface_access_point_added_cb_nm_device_wifi_access_point_added, self, 0);
	_tmp79_ = self->wifi_device;
	g_signal_connect_object (_tmp79_, "access-point-removed", (GCallback) _network_wifi_interface_access_point_removed_cb_nm_device_wifi_access_point_removed, self, 0);
	_tmp80_ = self->wifi_device;
	g_signal_connect_object ((NMDevice*) _tmp80_, "state-changed", (GCallback) _network_widgets_page_update_nm_device_state_changed, (NetworkWidgetsPage*) self, 0);
	_tmp81_ = self->wifi_device;
	_tmp82_ = nm_device_wifi_get_access_points (_tmp81_);
	_tmp83_ = _g_ptr_array_ref0 (_tmp82_);
	aps = _tmp83_;
	_tmp85_ = aps;
	if (_tmp85_ != NULL) {
		GPtrArray* _tmp86_;
		gint _tmp87_;
		gint _tmp88_;
		_tmp86_ = aps;
		_tmp87_ = vala_g_ptr_array_get_length (_tmp86_);
		_tmp88_ = _tmp87_;
		_tmp84_ = _tmp88_ > 0;
	} else {
		_tmp84_ = FALSE;
	}
	if (_tmp84_) {
		GPtrArray* _tmp89_;
		_tmp89_ = aps;
		g_ptr_array_foreach (_tmp89_, _network_wifi_interface_access_point_added_cb_gfunc, self);
	}
	_tmp90_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp91_ = _tmp90_;
	_tmp92_ = self->top_revealer;
	gtk_container_add ((GtkContainer*) _tmp91_, (GtkWidget*) _tmp92_);
	_tmp93_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp94_ = _tmp93_;
	_tmp95_ = main_frame;
	gtk_container_add ((GtkContainer*) _tmp94_, (GtkWidget*) _tmp95_);
	_tmp96_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp97_ = _tmp96_;
	gtk_widget_show_all ((GtkWidget*) _tmp97_);
	network_widgets_page_update ((NetworkWidgetsPage*) self);
	_g_ptr_array_unref0 (aps);
	_g_object_unref0 (scanning_box);
	_g_object_unref0 (scanning);
	_g_object_unref0 (spinner);
	_g_object_unref0 (wireless_off_alert);
	_g_object_unref0 (no_aps_alert);
	_g_object_unref0 (main_frame);
	_g_object_unref0 (hotspot_mode_alert);
	return obj;
}

static void
network_wifi_interface_class_init (NetworkWifiInterfaceClass * klass,
                                   gpointer klass_data)
{
	network_wifi_interface_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NetworkWifiInterface_private_offset);
	((NetworkWidgetsPageClass *) klass)->update_name = (void (*) (NetworkWidgetsPage*, gint)) network_wifi_interface_real_update_name;
	((NetworkWidgetsPageClass *) klass)->update = (void (*) (NetworkWidgetsPage*)) network_wifi_interface_real_update;
	((NetworkWidgetsPageClass *) klass)->update_switch = (void (*) (NetworkWidgetsPage*)) network_wifi_interface_real_update_switch;
	((NetworkWidgetsPageClass *) klass)->control_switch_activated = (void (*) (NetworkWidgetsPage*)) network_wifi_interface_real_control_switch_activated;
	G_OBJECT_CLASS (klass)->get_property = _vala_network_wifi_interface_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_network_wifi_interface_set_property;
	G_OBJECT_CLASS (klass)->constructor = network_wifi_interface_constructor;
	G_OBJECT_CLASS (klass)->finalize = network_wifi_interface_finalize;
}

static void
network_wifi_interface_instance_init (NetworkWifiInterface * self,
                                      gpointer klass)
{
	self->priv = network_wifi_interface_get_instance_private (self);
	self->priv->timeout_scan = (guint) 0;
	self->connected_box = NULL;
}

static void
network_wifi_interface_finalize (GObject * obj)
{
	NetworkWifiInterface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_WIFI_INTERFACE, NetworkWifiInterface);
	_g_object_unref0 (self->priv->rfkill);
	_g_object_unref0 (self->wifi_device);
	_g_object_unref0 (self->priv->active_ap);
	_g_object_unref0 (self->priv->wifi_list);
	_g_object_unref0 (self->priv->_active_wifi_item);
	_g_object_unref0 (self->priv->placeholder);
	_g_object_unref0 (self->connected_frame);
	_g_object_unref0 (self->list_stack);
	_g_object_unref0 (self->scrolled);
	_g_object_unref0 (self->hotspot_mode_alert);
	_g_object_unref0 (self->connected_box);
	_g_object_unref0 (self->top_revealer);
	_g_object_unref0 (self->disconnect_btn);
	_g_object_unref0 (self->settings_btn);
	_g_object_unref0 (self->hidden_btn);
	_g_object_unref0 (self->info_btn);
	_g_object_unref0 (self->popover);
	G_OBJECT_CLASS (network_wifi_interface_parent_class)->finalize (obj);
}

static GType
network_wifi_interface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkWifiInterfaceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_wifi_interface_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWifiInterface), 0, (GInstanceInitFunc) network_wifi_interface_instance_init, NULL };
	GType network_wifi_interface_type_id;
	network_wifi_interface_type_id = g_type_register_static (NETWORK_WIDGETS_TYPE_PAGE, "NetworkWifiInterface", &g_define_type_info, 0);
	NetworkWifiInterface_private_offset = g_type_add_instance_private (network_wifi_interface_type_id, sizeof (NetworkWifiInterfacePrivate));
	return network_wifi_interface_type_id;
}

GType
network_wifi_interface_get_type (void)
{
	static volatile gsize network_wifi_interface_type_id__once = 0;
	if (g_once_init_enter (&network_wifi_interface_type_id__once)) {
		GType network_wifi_interface_type_id;
		network_wifi_interface_type_id = network_wifi_interface_get_type_once ();
		g_once_init_leave (&network_wifi_interface_type_id__once, network_wifi_interface_type_id);
	}
	return network_wifi_interface_type_id__once;
}

static void
_vala_network_wifi_interface_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiInterface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_INTERFACE, NetworkWifiInterface);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_network_wifi_interface_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiInterface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_INTERFACE, NetworkWifiInterface);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

