/* DeviceItem.c generated by valac 0.56.2, the Vala compiler
 * generated from DeviceItem.vala, do not modify */

/*-
 * Copyright (c) 2015-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include "networking.h"
#include <NetworkManager.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <granite.h>

enum  {
	NETWORK_WIDGETS_DEVICE_ITEM_0_PROPERTY,
	NETWORK_WIDGETS_DEVICE_ITEM_DEVICE_PROPERTY,
	NETWORK_WIDGETS_DEVICE_ITEM_PAGE_PROPERTY,
	NETWORK_WIDGETS_DEVICE_ITEM_TITLE_PROPERTY,
	NETWORK_WIDGETS_DEVICE_ITEM_SUBTITLE_PROPERTY,
	NETWORK_WIDGETS_DEVICE_ITEM_ICON_NAME_PROPERTY,
	NETWORK_WIDGETS_DEVICE_ITEM_ITEM_TYPE_PROPERTY,
	NETWORK_WIDGETS_DEVICE_ITEM_NUM_PROPERTIES
};
static GParamSpec* network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block12Data Block12Data;

struct _NetworkWidgetsDeviceItemPrivate {
	NMDevice* _device;
	NetworkWidgetsPage* _page;
	gchar* _title;
	gchar* _subtitle;
	gchar* _icon_name;
	NetworkUtilsItemType _item_type;
	GtkImage* status_image;
};

struct _Block12Data {
	int _ref_count_;
	NetworkWidgetsDeviceItem* self;
	NetworkWidgetsPage* page;
};

static gint NetworkWidgetsDeviceItem_private_offset;
static gpointer network_widgets_device_item_parent_class = NULL;

static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
static void __lambda6_ (Block12Data* _data12_);
static void ___lambda6__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static gboolean _nm_device_state_equal (const NMDeviceState * s1,
                                 const NMDeviceState * s2);
static GObject * network_widgets_device_item_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void network_widgets_device_item_finalize (GObject * obj);
static GType network_widgets_device_item_get_type_once (void);
static void _vala_network_widgets_device_item_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_network_widgets_device_item_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);

static inline gpointer
network_widgets_device_item_get_instance_private (NetworkWidgetsDeviceItem* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkWidgetsDeviceItem_private_offset);
}

NetworkWidgetsDeviceItem*
network_widgets_device_item_construct (GType object_type,
                                       const gchar* title,
                                       const gchar* icon_name)
{
	NetworkWidgetsDeviceItem * self = NULL;
	g_return_val_if_fail (title != NULL, NULL);
	g_return_val_if_fail (icon_name != NULL, NULL);
	self = (NetworkWidgetsDeviceItem*) g_object_new (object_type, "title", title, "icon-name", icon_name, NULL);
	return self;
}

NetworkWidgetsDeviceItem*
network_widgets_device_item_new (const gchar* title,
                                 const gchar* icon_name)
{
	return network_widgets_device_item_construct (NETWORK_WIDGETS_TYPE_DEVICE_ITEM, title, icon_name);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
	g_atomic_int_inc (&_data12_->_ref_count_);
	return _data12_;
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
		NetworkWidgetsDeviceItem* self;
		self = _data12_->self;
		_g_object_unref0 (_data12_->page);
		_g_object_unref0 (self);
		g_slice_free (Block12Data, _data12_);
	}
}

static void
__lambda6_ (Block12Data* _data12_)
{
	NetworkWidgetsDeviceItem* self;
	NMDeviceState _tmp0_;
	NMDeviceState _tmp1_;
	self = _data12_->self;
	_tmp0_ = network_widgets_page_get_state (_data12_->page);
	_tmp1_ = _tmp0_;
	network_widgets_device_item_switch_status (self, NETWORK_UTILS_CUSTOM_MODE_INVALID, &_tmp1_);
}

static void
___lambda6__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda6_ (self);
}

NetworkWidgetsDeviceItem*
network_widgets_device_item_construct_from_page (GType object_type,
                                                 NetworkWidgetsPage* page,
                                                 const gchar* icon_name)
{
	NetworkWidgetsDeviceItem * self = NULL;
	Block12Data* _data12_;
	NetworkWidgetsPage* _tmp0_;
	NMDevice* _tmp1_;
	NMDevice* _tmp2_;
	NMDeviceState _tmp3_;
	NMDeviceState _tmp4_;
	g_return_val_if_fail (page != NULL, NULL);
	g_return_val_if_fail (icon_name != NULL, NULL);
	_data12_ = g_slice_new0 (Block12Data);
	_data12_->_ref_count_ = 1;
	_tmp0_ = _g_object_ref0 (page);
	_g_object_unref0 (_data12_->page);
	_data12_->page = _tmp0_;
	_tmp1_ = network_widgets_page_get_device (_data12_->page);
	_tmp2_ = _tmp1_;
	self = (NetworkWidgetsDeviceItem*) g_object_new (object_type, "device", _tmp2_, "icon-name", icon_name, "item-type", NETWORK_UTILS_ITEM_TYPE_DEVICE, "page", _data12_->page, NULL);
	_data12_->self = g_object_ref (self);
	g_object_bind_property_with_closures ((GObject*) _data12_->page, "title", (GObject*) self, "title", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	g_object_bind_property_with_closures ((GObject*) _data12_->page, "icon-name", (GObject*) self, "icon-name", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp3_ = network_widgets_page_get_state (_data12_->page);
	_tmp4_ = _tmp3_;
	network_widgets_device_item_switch_status (self, NETWORK_UTILS_CUSTOM_MODE_INVALID, &_tmp4_);
	g_signal_connect_data ((GObject*) _data12_->page, "notify::state", (GCallback) ___lambda6__g_object_notify, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
	block12_data_unref (_data12_);
	_data12_ = NULL;
	return self;
}

NetworkWidgetsDeviceItem*
network_widgets_device_item_new_from_page (NetworkWidgetsPage* page,
                                           const gchar* icon_name)
{
	return network_widgets_device_item_construct_from_page (NETWORK_WIDGETS_TYPE_DEVICE_ITEM, page, icon_name);
}

static gboolean
_nm_device_state_equal (const NMDeviceState * s1,
                        const NMDeviceState * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	return (*s1) == (*s2);
}

void
network_widgets_device_item_switch_status (NetworkWidgetsDeviceItem* self,
                                           NetworkUtilsCustomMode custom_mode,
                                           NMDeviceState* state)
{
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	g_return_if_fail (self != NULL);
	if (state != NULL) {
		gboolean _tmp4_ = FALSE;
		NMDevice* _tmp5_;
		switch (*state) {
			case NM_DEVICE_STATE_ACTIVATED:
			{
				GtkImage* _tmp0_;
				_tmp0_ = self->priv->status_image;
				g_object_set (_tmp0_, "icon-name", "user-available", NULL);
				break;
			}
			case NM_DEVICE_STATE_DISCONNECTED:
			{
				GtkImage* _tmp1_;
				_tmp1_ = self->priv->status_image;
				g_object_set (_tmp1_, "icon-name", "user-offline", NULL);
				break;
			}
			case NM_DEVICE_STATE_FAILED:
			{
				GtkImage* _tmp2_;
				_tmp2_ = self->priv->status_image;
				g_object_set (_tmp2_, "icon-name", "user-busy", NULL);
				break;
			}
			default:
			{
				GtkImage* _tmp3_;
				_tmp3_ = self->priv->status_image;
				g_object_set (_tmp3_, "icon-name", "user-away", NULL);
				break;
			}
		}
		_tmp5_ = self->priv->_device;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, nm_device_wifi_get_type ())) {
			NMDeviceState _tmp6_;
			_tmp6_ = NM_DEVICE_STATE_UNAVAILABLE;
			_tmp4_ = _nm_device_state_equal (state, &_tmp6_) == TRUE;
		} else {
			_tmp4_ = FALSE;
		}
		if (_tmp4_) {
			network_widgets_device_item_set_subtitle (self, _ ("Disabled"));
		} else {
			gchar* _tmp7_;
			gchar* _tmp8_;
			_tmp7_ = network_utils_state_to_string (*state);
			_tmp8_ = _tmp7_;
			network_widgets_device_item_set_subtitle (self, _tmp8_);
			_g_free0 (_tmp8_);
		}
	} else {
		if (custom_mode != NETWORK_UTILS_CUSTOM_MODE_INVALID) {
			switch (custom_mode) {
				case NETWORK_UTILS_CUSTOM_MODE_PROXY_NONE:
				{
					GtkImage* _tmp9_;
					network_widgets_device_item_set_subtitle (self, _ ("Disabled"));
					_tmp9_ = self->priv->status_image;
					g_object_set (_tmp9_, "icon-name", "user-offline", NULL);
					break;
				}
				case NETWORK_UTILS_CUSTOM_MODE_PROXY_MANUAL:
				{
					GtkImage* _tmp10_;
					network_widgets_device_item_set_subtitle (self, _ ("Enabled (manual mode)"));
					_tmp10_ = self->priv->status_image;
					g_object_set (_tmp10_, "icon-name", "user-available", NULL);
					break;
				}
				case NETWORK_UTILS_CUSTOM_MODE_PROXY_AUTO:
				{
					GtkImage* _tmp11_;
					network_widgets_device_item_set_subtitle (self, _ ("Enabled (auto mode)"));
					_tmp11_ = self->priv->status_image;
					g_object_set (_tmp11_, "icon-name", "user-available", NULL);
					break;
				}
				default:
				break;
			}
		}
	}
	_tmp12_ = self->priv->_subtitle;
	_tmp13_ = g_strconcat ("<span font_size='small'>", _tmp12_, NULL);
	_tmp14_ = _tmp13_;
	_tmp15_ = g_strconcat (_tmp14_, "</span>", NULL);
	_tmp16_ = _tmp15_;
	network_widgets_device_item_set_subtitle (self, _tmp16_);
	_g_free0 (_tmp16_);
	_g_free0 (_tmp14_);
}

NMDevice*
network_widgets_device_item_get_device (NetworkWidgetsDeviceItem* self)
{
	NMDevice* result;
	NMDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_device;
	result = _tmp0_;
	return result;
}

static void
network_widgets_device_item_set_device (NetworkWidgetsDeviceItem* self,
                                        NMDevice* value)
{
	NMDevice* old_value;
	g_return_if_fail (self != NULL);
	old_value = network_widgets_device_item_get_device (self);
	if (old_value != value) {
		NMDevice* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_device);
		self->priv->_device = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_DEVICE_PROPERTY]);
	}
}

NetworkWidgetsPage*
network_widgets_device_item_get_page (NetworkWidgetsDeviceItem* self)
{
	NetworkWidgetsPage* result;
	NetworkWidgetsPage* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_page;
	result = _tmp0_;
	return result;
}

void
network_widgets_device_item_set_page (NetworkWidgetsDeviceItem* self,
                                      NetworkWidgetsPage* value)
{
	NetworkWidgetsPage* old_value;
	g_return_if_fail (self != NULL);
	old_value = network_widgets_device_item_get_page (self);
	if (old_value != value) {
		NetworkWidgetsPage* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_page);
		self->priv->_page = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_PAGE_PROPERTY]);
	}
}

const gchar*
network_widgets_device_item_get_title (NetworkWidgetsDeviceItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_title;
	result = _tmp0_;
	return result;
}

void
network_widgets_device_item_set_title (NetworkWidgetsDeviceItem* self,
                                       const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = network_widgets_device_item_get_title (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_title);
		self->priv->_title = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_TITLE_PROPERTY]);
	}
}

const gchar*
network_widgets_device_item_get_subtitle (NetworkWidgetsDeviceItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_subtitle;
	result = _tmp0_;
	return result;
}

void
network_widgets_device_item_set_subtitle (NetworkWidgetsDeviceItem* self,
                                          const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = network_widgets_device_item_get_subtitle (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_subtitle);
		self->priv->_subtitle = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_SUBTITLE_PROPERTY]);
	}
}

const gchar*
network_widgets_device_item_get_icon_name (NetworkWidgetsDeviceItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_icon_name;
	result = _tmp0_;
	return result;
}

void
network_widgets_device_item_set_icon_name (NetworkWidgetsDeviceItem* self,
                                           const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = network_widgets_device_item_get_icon_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_icon_name);
		self->priv->_icon_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_ICON_NAME_PROPERTY]);
	}
}

NetworkUtilsItemType
network_widgets_device_item_get_item_type (NetworkWidgetsDeviceItem* self)
{
	NetworkUtilsItemType result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_item_type;
	return result;
}

void
network_widgets_device_item_set_item_type (NetworkWidgetsDeviceItem* self,
                                           NetworkUtilsItemType value)
{
	NetworkUtilsItemType old_value;
	g_return_if_fail (self != NULL);
	old_value = network_widgets_device_item_get_item_type (self);
	if (old_value != value) {
		self->priv->_item_type = value;
		g_object_notify_by_pspec ((GObject *) self, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_ITEM_TYPE_PROPERTY]);
	}
}

static GObject *
network_widgets_device_item_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkWidgetsDeviceItem * self;
	GtkImage* row_image = NULL;
	const gchar* _tmp0_;
	GtkImage* _tmp1_ = NULL;
	GtkLabel* row_title = NULL;
	const gchar* _tmp2_;
	GtkLabel* _tmp3_ = NULL;
	GtkLabel* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkLabel* row_description = NULL;
	const gchar* _tmp6_;
	GtkLabel* _tmp7_ = NULL;
	GtkImage* _tmp8_ = NULL;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp9_ = NULL;
	GtkOverlay* _tmp10_;
	GtkImage* _tmp11_;
	GtkOverlay* _tmp12_;
	GtkImage* _tmp13_;
	GtkGrid* row_grid = NULL;
	GtkGrid* _tmp14_ = NULL;
	GtkGrid* _tmp15_;
	GtkOverlay* _tmp16_;
	GtkGrid* _tmp17_;
	GtkLabel* _tmp18_;
	GtkGrid* _tmp19_;
	GtkLabel* _tmp20_;
	GtkGrid* _tmp21_;
	GtkLabel* _tmp22_;
	GtkLabel* _tmp23_;
	GtkImage* _tmp24_;
	parent_class = G_OBJECT_CLASS (network_widgets_device_item_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem);
	_tmp0_ = self->priv->_icon_name;
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp0_, (GtkIconSize) GTK_ICON_SIZE_DND);
	gtk_image_set_pixel_size (_tmp1_, 32);
	g_object_ref_sink (_tmp1_);
	row_image = _tmp1_;
	_tmp2_ = self->priv->_title;
	_tmp3_ = (GtkLabel*) gtk_label_new (_tmp2_);
	gtk_label_set_ellipsize (_tmp3_, PANGO_ELLIPSIZE_END);
	gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_START);
	gtk_widget_set_valign ((GtkWidget*) _tmp3_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp3_);
	row_title = _tmp3_;
	_tmp4_ = row_title;
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
	gtk_style_context_add_class (_tmp5_, GRANITE_STYLE_CLASS_H3_LABEL);
	_tmp6_ = self->priv->_subtitle;
	_tmp7_ = (GtkLabel*) gtk_label_new (_tmp6_);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp7_, 2);
	gtk_label_set_use_markup (_tmp7_, TRUE);
	gtk_label_set_ellipsize (_tmp7_, PANGO_ELLIPSIZE_END);
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_START);
	gtk_widget_set_valign ((GtkWidget*) _tmp7_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp7_);
	row_description = _tmp7_;
	_tmp8_ = (GtkImage*) gtk_image_new_from_icon_name ("user-available", (GtkIconSize) GTK_ICON_SIZE_MENU);
	gtk_widget_set_halign ((GtkWidget*) _tmp8_, GTK_ALIGN_END);
	gtk_widget_set_valign ((GtkWidget*) _tmp8_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->priv->status_image);
	self->priv->status_image = _tmp8_;
	_tmp9_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_set ((GtkWidget*) _tmp9_, "width-request", 38, NULL);
	g_object_ref_sink (_tmp9_);
	overlay = _tmp9_;
	_tmp10_ = overlay;
	_tmp11_ = row_image;
	gtk_container_add ((GtkContainer*) _tmp10_, (GtkWidget*) _tmp11_);
	_tmp12_ = overlay;
	_tmp13_ = self->priv->status_image;
	gtk_overlay_add_overlay (_tmp12_, (GtkWidget*) _tmp13_);
	_tmp14_ = (GtkGrid*) gtk_grid_new ();
	g_object_set ((GtkWidget*) _tmp14_, "margin", 6, NULL);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp14_, 3);
	gtk_grid_set_column_spacing (_tmp14_, 3);
	g_object_ref_sink (_tmp14_);
	row_grid = _tmp14_;
	_tmp15_ = row_grid;
	_tmp16_ = overlay;
	gtk_grid_attach (_tmp15_, (GtkWidget*) _tmp16_, 0, 0, 1, 2);
	_tmp17_ = row_grid;
	_tmp18_ = row_title;
	gtk_grid_attach (_tmp17_, (GtkWidget*) _tmp18_, 1, 0, 1, 1);
	_tmp19_ = row_grid;
	_tmp20_ = row_description;
	gtk_grid_attach (_tmp19_, (GtkWidget*) _tmp20_, 1, 1, 1, 1);
	_tmp21_ = row_grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp21_);
	_tmp22_ = row_title;
	g_object_bind_property_with_closures ((GObject*) self, "title", (GObject*) _tmp22_, "label", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp23_ = row_description;
	g_object_bind_property_with_closures ((GObject*) self, "subtitle", (GObject*) _tmp23_, "label", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp24_ = row_image;
	g_object_bind_property_with_closures ((GObject*) self, "icon-name", (GObject*) _tmp24_, "icon-name", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (row_grid);
	_g_object_unref0 (overlay);
	_g_object_unref0 (row_description);
	_g_object_unref0 (row_title);
	_g_object_unref0 (row_image);
	return obj;
}

static void
network_widgets_device_item_class_init (NetworkWidgetsDeviceItemClass * klass,
                                        gpointer klass_data)
{
	network_widgets_device_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NetworkWidgetsDeviceItem_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_network_widgets_device_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_network_widgets_device_item_set_property;
	G_OBJECT_CLASS (klass)->constructor = network_widgets_device_item_constructor;
	G_OBJECT_CLASS (klass)->finalize = network_widgets_device_item_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_DEVICE_ITEM_DEVICE_PROPERTY, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", nm_device_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_DEVICE_ITEM_PAGE_PROPERTY, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_PAGE_PROPERTY] = g_param_spec_object ("page", "page", "page", NETWORK_WIDGETS_TYPE_PAGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_DEVICE_ITEM_TITLE_PROPERTY, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_DEVICE_ITEM_SUBTITLE_PROPERTY, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_SUBTITLE_PROPERTY] = g_param_spec_string ("subtitle", "subtitle", "subtitle", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_DEVICE_ITEM_ICON_NAME_PROPERTY, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_DEVICE_ITEM_ITEM_TYPE_PROPERTY, network_widgets_device_item_properties[NETWORK_WIDGETS_DEVICE_ITEM_ITEM_TYPE_PROPERTY] = g_param_spec_enum ("item-type", "item-type", "item-type", NETWORK_UTILS_TYPE_ITEM_TYPE, NETWORK_UTILS_ITEM_TYPE_INVALID, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
network_widgets_device_item_instance_init (NetworkWidgetsDeviceItem * self,
                                           gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	self->priv = network_widgets_device_item_get_instance_private (self);
	self->priv->_device = NULL;
	self->priv->_page = NULL;
	_tmp0_ = g_strdup ("");
	self->priv->_title = _tmp0_;
	_tmp1_ = g_strdup ("");
	self->priv->_subtitle = _tmp1_;
	_tmp2_ = g_strdup ("network-wired");
	self->priv->_icon_name = _tmp2_;
	self->priv->_item_type = NETWORK_UTILS_ITEM_TYPE_INVALID;
}

static void
network_widgets_device_item_finalize (GObject * obj)
{
	NetworkWidgetsDeviceItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem);
	_g_object_unref0 (self->priv->_device);
	_g_object_unref0 (self->priv->_page);
	_g_free0 (self->priv->_title);
	_g_free0 (self->priv->_subtitle);
	_g_free0 (self->priv->_icon_name);
	_g_object_unref0 (self->priv->status_image);
	G_OBJECT_CLASS (network_widgets_device_item_parent_class)->finalize (obj);
}

static GType
network_widgets_device_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkWidgetsDeviceItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_widgets_device_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWidgetsDeviceItem), 0, (GInstanceInitFunc) network_widgets_device_item_instance_init, NULL };
	GType network_widgets_device_item_type_id;
	network_widgets_device_item_type_id = g_type_register_static (gtk_list_box_row_get_type (), "NetworkWidgetsDeviceItem", &g_define_type_info, 0);
	NetworkWidgetsDeviceItem_private_offset = g_type_add_instance_private (network_widgets_device_item_type_id, sizeof (NetworkWidgetsDeviceItemPrivate));
	return network_widgets_device_item_type_id;
}

GType
network_widgets_device_item_get_type (void)
{
	static volatile gsize network_widgets_device_item_type_id__once = 0;
	if (g_once_init_enter (&network_widgets_device_item_type_id__once)) {
		GType network_widgets_device_item_type_id;
		network_widgets_device_item_type_id = network_widgets_device_item_get_type_once ();
		g_once_init_leave (&network_widgets_device_item_type_id__once, network_widgets_device_item_type_id);
	}
	return network_widgets_device_item_type_id__once;
}

static void
_vala_network_widgets_device_item_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	NetworkWidgetsDeviceItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem);
	switch (property_id) {
		case NETWORK_WIDGETS_DEVICE_ITEM_DEVICE_PROPERTY:
		g_value_set_object (value, network_widgets_device_item_get_device (self));
		break;
		case NETWORK_WIDGETS_DEVICE_ITEM_PAGE_PROPERTY:
		g_value_set_object (value, network_widgets_device_item_get_page (self));
		break;
		case NETWORK_WIDGETS_DEVICE_ITEM_TITLE_PROPERTY:
		g_value_set_string (value, network_widgets_device_item_get_title (self));
		break;
		case NETWORK_WIDGETS_DEVICE_ITEM_SUBTITLE_PROPERTY:
		g_value_set_string (value, network_widgets_device_item_get_subtitle (self));
		break;
		case NETWORK_WIDGETS_DEVICE_ITEM_ICON_NAME_PROPERTY:
		g_value_set_string (value, network_widgets_device_item_get_icon_name (self));
		break;
		case NETWORK_WIDGETS_DEVICE_ITEM_ITEM_TYPE_PROPERTY:
		g_value_set_enum (value, network_widgets_device_item_get_item_type (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_network_widgets_device_item_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	NetworkWidgetsDeviceItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem);
	switch (property_id) {
		case NETWORK_WIDGETS_DEVICE_ITEM_DEVICE_PROPERTY:
		network_widgets_device_item_set_device (self, g_value_get_object (value));
		break;
		case NETWORK_WIDGETS_DEVICE_ITEM_PAGE_PROPERTY:
		network_widgets_device_item_set_page (self, g_value_get_object (value));
		break;
		case NETWORK_WIDGETS_DEVICE_ITEM_TITLE_PROPERTY:
		network_widgets_device_item_set_title (self, g_value_get_string (value));
		break;
		case NETWORK_WIDGETS_DEVICE_ITEM_SUBTITLE_PROPERTY:
		network_widgets_device_item_set_subtitle (self, g_value_get_string (value));
		break;
		case NETWORK_WIDGETS_DEVICE_ITEM_ICON_NAME_PROPERTY:
		network_widgets_device_item_set_icon_name (self, g_value_get_string (value));
		break;
		case NETWORK_WIDGETS_DEVICE_ITEM_ITEM_TYPE_PROPERTY:
		network_widgets_device_item_set_item_type (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

