/* DeviceList.c generated by valac 0.56.2, the Vala compiler
 * generated from DeviceList.vala, do not modify */

/*-
 * Copyright (c) 2015-2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include "networking.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <NetworkManager.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <granite.h>

enum  {
	NETWORK_WIDGETS_DEVICE_LIST_0_PROPERTY,
	NETWORK_WIDGETS_DEVICE_LIST_NUM_PROPERTIES
};
static GParamSpec* network_widgets_device_list_properties[NETWORK_WIDGETS_DEVICE_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	NETWORK_WIDGETS_DEVICE_LIST_SHOW_NO_DEVICES_SIGNAL,
	NETWORK_WIDGETS_DEVICE_LIST_NUM_SIGNALS
};
static guint network_widgets_device_list_signals[NETWORK_WIDGETS_DEVICE_LIST_NUM_SIGNALS] = {0};

struct _NetworkWidgetsDeviceListPrivate {
	GtkLabel* virtual_l;
	GtkLabel* devices_l;
	NetworkWidgetsDeviceItem* proxy;
	NetworkWidgetsDeviceItem* vpn;
};

static gint NetworkWidgetsDeviceList_private_offset;
static gpointer network_widgets_device_list_parent_class = NULL;

static void network_widgets_device_list_add_proxy (NetworkWidgetsDeviceList* self);
static void network_widgets_device_list_add_vpn (NetworkWidgetsDeviceList* self);
static gint network_widgets_device_list_sort_items (NetworkWidgetsDeviceList* self,
                                             GtkListBoxRow* row1,
                                             GtkListBoxRow* row2);
static void network_widgets_device_list_update_headers (NetworkWidgetsDeviceList* self,
                                                 GtkListBoxRow* row,
                                                 GtkListBoxRow* before);
static GObject * network_widgets_device_list_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void _network_widgets_device_list_update_headers_gtk_list_box_update_header_func (GtkListBoxRow* row,
                                                                                  GtkListBoxRow* before,
                                                                                  gpointer self);
static gint _network_widgets_device_list_sort_items_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                     GtkListBoxRow* row2,
                                                                     gpointer self);
static void _network_widgets_device_list___lambda46_ (NetworkWidgetsDeviceList* self,
                                               GtkListBoxRow* row);
static void __network_widgets_device_list___lambda46__gtk_list_box_row_selected (GtkListBox* _sender,
                                                                          GtkListBoxRow* row,
                                                                          gpointer self);
static void network_widgets_device_list_finalize (GObject * obj);
static GType network_widgets_device_list_get_type_once (void);

static inline gpointer
network_widgets_device_list_get_instance_private (NetworkWidgetsDeviceList* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkWidgetsDeviceList_private_offset);
}

void
network_widgets_device_list_add_iface_to_list (NetworkWidgetsDeviceList* self,
                                               NetworkWidgetsPage* page)
{
	NetworkWidgetsDeviceItem* item = NULL;
	NetworkWidgetsDeviceItem* _tmp9_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (page != NULL);
	if (NETWORK_IS_WIFI_INTERFACE (page)) {
		NetworkWidgetsDeviceItem* _tmp0_;
		_tmp0_ = network_widgets_device_item_new_from_page (page, "network-wired");
		g_object_ref_sink (_tmp0_);
		_g_object_unref0 (item);
		item = _tmp0_;
	} else {
		if (NETWORK_WIDGETS_IS_HOTSPOT_INTERFACE (page)) {
			NetworkWidgetsDeviceItem* _tmp1_;
			NetworkWidgetsDeviceItem* _tmp2_;
			_tmp1_ = network_widgets_device_item_new_from_page (page, "network-wired");
			g_object_ref_sink (_tmp1_);
			_g_object_unref0 (item);
			item = _tmp1_;
			_tmp2_ = item;
			network_widgets_device_item_set_item_type (_tmp2_, NETWORK_UTILS_ITEM_TYPE_VIRTUAL);
		} else {
			if (NETWORK_WIDGETS_IS_MODEM_INTERFACE (page)) {
				NetworkWidgetsDeviceItem* _tmp3_;
				_tmp3_ = network_widgets_device_item_new_from_page (page, "network-wired");
				g_object_ref_sink (_tmp3_);
				_g_object_unref0 (item);
				item = _tmp3_;
			} else {
				NMDevice* _tmp4_;
				NMDevice* _tmp5_;
				const gchar* _tmp6_;
				_tmp4_ = network_widgets_page_get_device (page);
				_tmp5_ = _tmp4_;
				_tmp6_ = nm_device_get_iface (_tmp5_);
				if (g_str_has_prefix (_tmp6_, "usb")) {
					NetworkWidgetsDeviceItem* _tmp7_;
					_tmp7_ = network_widgets_device_item_new_from_page (page, "drive-removable-media");
					g_object_ref_sink (_tmp7_);
					_g_object_unref0 (item);
					item = _tmp7_;
				} else {
					NetworkWidgetsDeviceItem* _tmp8_;
					_tmp8_ = network_widgets_device_item_new_from_page (page, "network-wired");
					g_object_ref_sink (_tmp8_);
					_g_object_unref0 (item);
					item = _tmp8_;
				}
			}
		}
	}
	_tmp9_ = item;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp9_);
	_g_object_unref0 (item);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
network_widgets_device_list_remove_iface_from_list (NetworkWidgetsDeviceList* self,
                                                    NetworkWidgetsPage* iface)
{
	GList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (iface != NULL);
	_tmp0_ = gtk_container_get_children ((GtkContainer*) self);
	{
		GList* _list_item_collection = NULL;
		GList* _list_item_it = NULL;
		_list_item_collection = _tmp0_;
		for (_list_item_it = _list_item_collection; _list_item_it != NULL; _list_item_it = _list_item_it->next) {
			GtkWidget* _tmp1_;
			GtkWidget* _list_item = NULL;
			_tmp1_ = _g_object_ref0 ((GtkWidget*) _list_item_it->data);
			_list_item = _tmp1_;
			{
				NetworkWidgetsDeviceItem* list_item = NULL;
				GtkWidget* _tmp2_;
				NetworkWidgetsDeviceItem* _tmp3_;
				NetworkWidgetsDeviceItem* _tmp4_;
				NetworkWidgetsPage* _tmp5_;
				NetworkWidgetsPage* _tmp6_;
				_tmp2_ = _list_item;
				_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem));
				list_item = _tmp3_;
				_tmp4_ = list_item;
				_tmp5_ = network_widgets_device_item_get_page (_tmp4_);
				_tmp6_ = _tmp5_;
				if (_tmp6_ == iface) {
					NetworkWidgetsDeviceItem* _tmp7_;
					_tmp7_ = list_item;
					network_widgets_device_list_remove_row_from_list (self, _tmp7_);
				}
				_g_object_unref0 (list_item);
				_g_object_unref0 (_list_item);
			}
		}
		(_list_item_collection == NULL) ? NULL : (_list_item_collection = (g_list_free (_list_item_collection), NULL));
	}
}

void
network_widgets_device_list_add_connection (NetworkWidgetsDeviceList* self,
                                            NMRemoteConnection* connection)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
	static GQuark _tmp2_label0 = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	_tmp0_ = nm_connection_get_connection_type ((NMConnection*) connection);
	_tmp1_ = _tmp0_;
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string (NM_SETTING_VPN_SETTING_NAME)))) {
		switch (0) {
			default:
			{
				NetworkWidgetsDeviceItem* _tmp4_;
				NetworkWidgetsPage* _tmp5_;
				NetworkWidgetsPage* _tmp6_;
				_tmp4_ = self->priv->vpn;
				_tmp5_ = network_widgets_device_item_get_page (_tmp4_);
				_tmp6_ = _tmp5_;
				network_vpn_page_add_connection (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, NETWORK_TYPE_VPN_PAGE, NetworkVPNPage), connection);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				break;
			}
		}
	}
}

void
network_widgets_device_list_remove_connection (NetworkWidgetsDeviceList* self,
                                               NMRemoteConnection* connection)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
	static GQuark _tmp2_label0 = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	_tmp0_ = nm_connection_get_connection_type ((NMConnection*) connection);
	_tmp1_ = _tmp0_;
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string (NM_SETTING_VPN_SETTING_NAME)))) {
		switch (0) {
			default:
			{
				NetworkWidgetsDeviceItem* _tmp4_;
				NetworkWidgetsPage* _tmp5_;
				NetworkWidgetsPage* _tmp6_;
				_tmp4_ = self->priv->vpn;
				_tmp5_ = network_widgets_device_item_get_page (_tmp4_);
				_tmp6_ = _tmp5_;
				network_vpn_page_remove_connection (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, NETWORK_TYPE_VPN_PAGE, NetworkVPNPage), connection);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				break;
			}
		}
	}
}

void
network_widgets_device_list_remove_row_from_list (NetworkWidgetsDeviceList* self,
                                                  NetworkWidgetsDeviceItem* item)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	gtk_container_remove ((GtkContainer*) self, (GtkWidget*) item);
	gtk_widget_show_all ((GtkWidget*) self);
}

static void
network_widgets_device_list_add_proxy (NetworkWidgetsDeviceList* self)
{
	NetworkWidgetsDeviceItem* _tmp0_ = NULL;
	NetworkWidgetsDeviceItem* _tmp1_;
	NetworkWidgetsDeviceItem* _tmp2_;
	NetworkWidgetsProxyPage* _tmp3_;
	NetworkWidgetsProxyPage* _tmp4_;
	NetworkWidgetsDeviceItem* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = network_widgets_device_item_new (_ ("Proxy"), "preferences-system-network");
	network_widgets_device_item_set_item_type (_tmp0_, NETWORK_UTILS_ITEM_TYPE_VIRTUAL);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->proxy);
	self->priv->proxy = _tmp0_;
	_tmp1_ = self->priv->proxy;
	_tmp2_ = self->priv->proxy;
	_tmp3_ = network_widgets_proxy_page_new (_tmp2_);
	g_object_ref_sink (_tmp3_);
	_tmp4_ = _tmp3_;
	network_widgets_device_item_set_page (_tmp1_, (NetworkWidgetsPage*) _tmp4_);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = self->priv->proxy;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp5_);
}

static void
network_widgets_device_list_add_vpn (NetworkWidgetsDeviceList* self)
{
	NetworkWidgetsDeviceItem* _tmp0_ = NULL;
	NetworkWidgetsDeviceItem* _tmp1_;
	NetworkWidgetsDeviceItem* _tmp2_;
	NetworkVPNPage* _tmp3_;
	NetworkVPNPage* _tmp4_;
	NetworkWidgetsDeviceItem* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = network_widgets_device_item_new (_ ("VPN"), "network-vpn");
	network_widgets_device_item_set_item_type (_tmp0_, NETWORK_UTILS_ITEM_TYPE_VIRTUAL);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->vpn);
	self->priv->vpn = _tmp0_;
	_tmp1_ = self->priv->vpn;
	_tmp2_ = self->priv->vpn;
	_tmp3_ = network_vpn_page_new (_tmp2_);
	g_object_ref_sink (_tmp3_);
	_tmp4_ = _tmp3_;
	network_widgets_device_item_set_page (_tmp1_, (NetworkWidgetsPage*) _tmp4_);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = self->priv->vpn;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp5_);
}

void
network_widgets_device_list_select_first_item (NetworkWidgetsDeviceList* self)
{
	GtkListBoxRow* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_list_box_get_row_at_index ((GtkListBox*) self, 0);
	g_signal_emit_by_name (_tmp0_, "activate");
}

static gint
network_widgets_device_list_sort_items (NetworkWidgetsDeviceList* self,
                                        GtkListBoxRow* row1,
                                        GtkListBoxRow* row2)
{
	NetworkUtilsItemType _tmp0_;
	NetworkUtilsItemType _tmp1_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (row1 != NULL, 0);
	g_return_val_if_fail (row2 != NULL, 0);
	_tmp0_ = network_widgets_device_item_get_item_type (G_TYPE_CHECK_INSTANCE_CAST (row1, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem));
	_tmp1_ = _tmp0_;
	if (_tmp1_ == NETWORK_UTILS_ITEM_TYPE_DEVICE) {
		result = -1;
		return result;
	} else {
		NetworkUtilsItemType _tmp2_;
		NetworkUtilsItemType _tmp3_;
		_tmp2_ = network_widgets_device_item_get_item_type (G_TYPE_CHECK_INSTANCE_CAST (row1, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem));
		_tmp3_ = _tmp2_;
		if (_tmp3_ == NETWORK_UTILS_ITEM_TYPE_VIRTUAL) {
			result = 1;
			return result;
		} else {
			result = 0;
			return result;
		}
	}
}

static void
network_widgets_device_list_update_headers (NetworkWidgetsDeviceList* self,
                                            GtkListBoxRow* row,
                                            GtkListBoxRow* before)
{
	NetworkWidgetsDeviceItem* row_item = NULL;
	NetworkWidgetsDeviceItem* before_item = NULL;
	NetworkWidgetsDeviceItem* _tmp0_;
	NetworkUtilsItemType _tmp1_;
	NetworkUtilsItemType _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (row != NULL);
	row_item = G_TYPE_CHECK_INSTANCE_CAST (row, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem);
	before_item = G_TYPE_CHECK_INSTANCE_CAST (before, NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem);
	_tmp0_ = row_item;
	_tmp1_ = network_widgets_device_item_get_item_type (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == NETWORK_UTILS_ITEM_TYPE_VIRTUAL) {
		gboolean _tmp3_ = FALSE;
		NetworkWidgetsDeviceItem* _tmp4_;
		GtkLabel* _tmp8_;
		GtkContainer* _tmp9_;
		GtkLabel* _tmp11_;
		_tmp4_ = before_item;
		if (_tmp4_ != NULL) {
			NetworkWidgetsDeviceItem* _tmp5_;
			NetworkUtilsItemType _tmp6_;
			NetworkUtilsItemType _tmp7_;
			_tmp5_ = before_item;
			_tmp6_ = network_widgets_device_item_get_item_type (_tmp5_);
			_tmp7_ = _tmp6_;
			_tmp3_ = _tmp7_ == NETWORK_UTILS_ITEM_TYPE_VIRTUAL;
		} else {
			_tmp3_ = FALSE;
		}
		if (_tmp3_) {
			gtk_list_box_row_set_header (row, NULL);
			return;
		}
		_tmp8_ = self->priv->virtual_l;
		_tmp9_ = gtk_widget_get_parent ((GtkWidget*) _tmp8_);
		if (_tmp9_ != NULL) {
			GtkLabel* _tmp10_;
			_tmp10_ = self->priv->virtual_l;
			gtk_widget_unparent ((GtkWidget*) _tmp10_);
		}
		_tmp11_ = self->priv->virtual_l;
		gtk_list_box_row_set_header (row, (GtkWidget*) _tmp11_);
	} else {
		NetworkWidgetsDeviceItem* _tmp12_;
		NetworkUtilsItemType _tmp13_;
		NetworkUtilsItemType _tmp14_;
		_tmp12_ = row_item;
		_tmp13_ = network_widgets_device_item_get_item_type (_tmp12_);
		_tmp14_ = _tmp13_;
		if (_tmp14_ == NETWORK_UTILS_ITEM_TYPE_DEVICE) {
			gboolean _tmp15_ = FALSE;
			NetworkWidgetsDeviceItem* _tmp16_;
			GtkLabel* _tmp20_;
			GtkContainer* _tmp21_;
			GtkLabel* _tmp23_;
			_tmp16_ = before_item;
			if (_tmp16_ != NULL) {
				NetworkWidgetsDeviceItem* _tmp17_;
				NetworkUtilsItemType _tmp18_;
				NetworkUtilsItemType _tmp19_;
				_tmp17_ = before_item;
				_tmp18_ = network_widgets_device_item_get_item_type (_tmp17_);
				_tmp19_ = _tmp18_;
				_tmp15_ = _tmp19_ == NETWORK_UTILS_ITEM_TYPE_DEVICE;
			} else {
				_tmp15_ = FALSE;
			}
			if (_tmp15_) {
				gtk_list_box_row_set_header (row, NULL);
				return;
			}
			_tmp20_ = self->priv->devices_l;
			_tmp21_ = gtk_widget_get_parent ((GtkWidget*) _tmp20_);
			if (_tmp21_ != NULL) {
				GtkLabel* _tmp22_;
				_tmp22_ = self->priv->devices_l;
				gtk_widget_unparent ((GtkWidget*) _tmp22_);
			}
			_tmp23_ = self->priv->devices_l;
			gtk_list_box_row_set_header (row, (GtkWidget*) _tmp23_);
		} else {
			gtk_list_box_row_set_header (row, NULL);
		}
	}
}

NetworkWidgetsDeviceList*
network_widgets_device_list_construct (GType object_type)
{
	NetworkWidgetsDeviceList * self = NULL;
	self = (NetworkWidgetsDeviceList*) g_object_new (object_type, NULL);
	return self;
}

NetworkWidgetsDeviceList*
network_widgets_device_list_new (void)
{
	return network_widgets_device_list_construct (NETWORK_WIDGETS_TYPE_DEVICE_LIST);
}

static void
_network_widgets_device_list_update_headers_gtk_list_box_update_header_func (GtkListBoxRow* row,
                                                                             GtkListBoxRow* before,
                                                                             gpointer self)
{
	network_widgets_device_list_update_headers ((NetworkWidgetsDeviceList*) self, row, before);
}

static gint
_network_widgets_device_list_sort_items_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                GtkListBoxRow* row2,
                                                                gpointer self)
{
	gint result;
	result = network_widgets_device_list_sort_items ((NetworkWidgetsDeviceList*) self, row1, row2);
	return result;
}

static void
_network_widgets_device_list___lambda46_ (NetworkWidgetsDeviceList* self,
                                          GtkListBoxRow* row)
{
	g_signal_emit_by_name (row, "activate");
}

static void
__network_widgets_device_list___lambda46__gtk_list_box_row_selected (GtkListBox* _sender,
                                                                     GtkListBoxRow* row,
                                                                     gpointer self)
{
	_network_widgets_device_list___lambda46_ ((NetworkWidgetsDeviceList*) self, row);
}

static GObject *
network_widgets_device_list_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkWidgetsDeviceList * self;
	GtkLabel* _tmp0_ = NULL;
	GtkLabel* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkLabel* _tmp3_ = NULL;
	GtkLabel* _tmp4_;
	GtkStyleContext* _tmp5_;
	gboolean show = FALSE;
	GList* _tmp6_;
	GList* _tmp7_;
	gboolean _tmp8_;
	parent_class = G_OBJECT_CLASS (network_widgets_device_list_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_WIDGETS_TYPE_DEVICE_LIST, NetworkWidgetsDeviceList);
	gtk_list_box_set_selection_mode ((GtkListBox*) self, GTK_SELECTION_SINGLE);
	gtk_list_box_set_activate_on_single_click ((GtkListBox*) self, TRUE);
	_tmp0_ = (GtkLabel*) gtk_label_new (_ ("Virtual"));
	gtk_widget_set_halign ((GtkWidget*) _tmp0_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->virtual_l);
	self->priv->virtual_l = _tmp0_;
	_tmp1_ = self->priv->virtual_l;
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
	gtk_style_context_add_class (_tmp2_, GRANITE_STYLE_CLASS_H4_LABEL);
	_tmp3_ = (GtkLabel*) gtk_label_new (_ ("Devices"));
	gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->devices_l);
	self->priv->devices_l = _tmp3_;
	_tmp4_ = self->priv->devices_l;
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
	gtk_style_context_add_class (_tmp5_, GRANITE_STYLE_CLASS_H4_LABEL);
	gtk_list_box_set_header_func ((GtkListBox*) self, _network_widgets_device_list_update_headers_gtk_list_box_update_header_func, g_object_ref (self), g_object_unref);
	gtk_list_box_set_sort_func ((GtkListBox*) self, _network_widgets_device_list_sort_items_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
	_tmp6_ = gtk_container_get_children ((GtkContainer*) self);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_list_length (_tmp7_) > ((guint) 0);
	(_tmp7_ == NULL) ? NULL : (_tmp7_ = (g_list_free (_tmp7_), NULL));
	show = _tmp8_;
	g_signal_emit (self, network_widgets_device_list_signals[NETWORK_WIDGETS_DEVICE_LIST_SHOW_NO_DEVICES_SIGNAL], 0, !show);
	network_widgets_device_list_add_proxy (self);
	network_widgets_device_list_add_vpn (self);
	g_signal_connect_object ((GtkListBox*) self, "row-selected", (GCallback) __network_widgets_device_list___lambda46__gtk_list_box_row_selected, self, 0);
	return obj;
}

static void
network_widgets_device_list_class_init (NetworkWidgetsDeviceListClass * klass,
                                        gpointer klass_data)
{
	network_widgets_device_list_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NetworkWidgetsDeviceList_private_offset);
	G_OBJECT_CLASS (klass)->constructor = network_widgets_device_list_constructor;
	G_OBJECT_CLASS (klass)->finalize = network_widgets_device_list_finalize;
	network_widgets_device_list_signals[NETWORK_WIDGETS_DEVICE_LIST_SHOW_NO_DEVICES_SIGNAL] = g_signal_new ("show-no-devices", NETWORK_WIDGETS_TYPE_DEVICE_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
}

static void
network_widgets_device_list_instance_init (NetworkWidgetsDeviceList * self,
                                           gpointer klass)
{
	self->priv = network_widgets_device_list_get_instance_private (self);
}

static void
network_widgets_device_list_finalize (GObject * obj)
{
	NetworkWidgetsDeviceList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_WIDGETS_TYPE_DEVICE_LIST, NetworkWidgetsDeviceList);
	_g_object_unref0 (self->priv->virtual_l);
	_g_object_unref0 (self->priv->devices_l);
	_g_object_unref0 (self->priv->proxy);
	_g_object_unref0 (self->priv->vpn);
	G_OBJECT_CLASS (network_widgets_device_list_parent_class)->finalize (obj);
}

static GType
network_widgets_device_list_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkWidgetsDeviceListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_widgets_device_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWidgetsDeviceList), 0, (GInstanceInitFunc) network_widgets_device_list_instance_init, NULL };
	GType network_widgets_device_list_type_id;
	network_widgets_device_list_type_id = g_type_register_static (gtk_list_box_get_type (), "NetworkWidgetsDeviceList", &g_define_type_info, 0);
	NetworkWidgetsDeviceList_private_offset = g_type_add_instance_private (network_widgets_device_list_type_id, sizeof (NetworkWidgetsDeviceListPrivate));
	return network_widgets_device_list_type_id;
}

GType
network_widgets_device_list_get_type (void)
{
	static volatile gsize network_widgets_device_list_type_id__once = 0;
	if (g_once_init_enter (&network_widgets_device_list_type_id__once)) {
		GType network_widgets_device_list_type_id;
		network_widgets_device_list_type_id = network_widgets_device_list_get_type_once ();
		g_once_init_leave (&network_widgets_device_list_type_id__once, network_widgets_device_list_type_id);
	}
	return network_widgets_device_list_type_id__once;
}

