/* InfoBox.c generated by valac 0.56.2, the Vala compiler
 * generated from InfoBox.vala, do not modify */

/*-
 * Copyright (c) 2015-2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include "networking.h"
#include <NetworkManager.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <float.h>
#include <math.h>

#define NETWORK_UNKNOWN_STR _ ("Unknown")

enum  {
	NETWORK_WIDGETS_INFO_BOX_0_PROPERTY,
	NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY,
	NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY,
	NETWORK_WIDGETS_INFO_BOX_NUM_PROPERTIES
};
static GParamSpec* network_widgets_info_box_properties[NETWORK_WIDGETS_INFO_BOX_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block10Data Block10Data;
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
enum  {
	NETWORK_WIDGETS_INFO_BOX_UPDATE_SIDEBAR_SIGNAL,
	NETWORK_WIDGETS_INFO_BOX_INFO_CHANGED_SIGNAL,
	NETWORK_WIDGETS_INFO_BOX_NUM_SIGNALS
};
static guint network_widgets_info_box_signals[NETWORK_WIDGETS_INFO_BOX_NUM_SIGNALS] = {0};

struct _NetworkWidgetsInfoBoxPrivate {
	NMDevice* _device;
	NetworkWidgetsDeviceItem* _owner;
	GtkLabel* ip4address;
	GtkLabel* ip6address;
	GtkLabel* mask;
	GtkLabel* router;
	GtkLabel* dns;
	GtkLabel* sent;
	GtkLabel* received;
	GtkLabel* ip6address_head;
};

struct _Block10Data {
	int _ref_count_;
	NetworkWidgetsInfoBox* self;
	gint i;
	GPtrArray* addresses;
};

static gint NetworkWidgetsInfoBox_private_offset;
static gpointer network_widgets_info_box_parent_class = NULL;

static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void ___lambda7_ (Block10Data* _data10_,
                  NMIPAddress* addr);
static void ____lambda7__gfunc (gconstpointer data,
                         gpointer self);
static GObject * network_widgets_info_box_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void _network_widgets_info_box___lambda8_ (NetworkWidgetsInfoBox* self);
static void __network_widgets_info_box___lambda8__nm_device_state_changed (NMDevice* _sender,
                                                                    guint new_state,
                                                                    guint old_state,
                                                                    guint reason,
                                                                    gpointer self);
static void network_widgets_info_box_finalize (GObject * obj);
static GType network_widgets_info_box_get_type_once (void);
static void _vala_network_widgets_info_box_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_network_widgets_info_box_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
network_widgets_info_box_get_instance_private (NetworkWidgetsInfoBox* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkWidgetsInfoBox_private_offset);
}

NetworkWidgetsInfoBox*
network_widgets_info_box_construct_from_device (GType object_type,
                                                NMDevice* device)
{
	NetworkWidgetsInfoBox * self = NULL;
	g_return_val_if_fail (device != NULL, NULL);
	self = (NetworkWidgetsInfoBox*) g_object_new (object_type, "device", device, NULL);
	return self;
}

NetworkWidgetsInfoBox*
network_widgets_info_box_new_from_device (NMDevice* device)
{
	return network_widgets_info_box_construct_from_device (NETWORK_WIDGETS_TYPE_INFO_BOX, device);
}

NetworkWidgetsInfoBox*
network_widgets_info_box_construct_from_owner (GType object_type,
                                               NetworkWidgetsDeviceItem* owner)
{
	NetworkWidgetsInfoBox * self = NULL;
	NMDevice* _tmp0_;
	NMDevice* _tmp1_;
	g_return_val_if_fail (owner != NULL, NULL);
	_tmp0_ = network_widgets_device_item_get_device (owner);
	_tmp1_ = _tmp0_;
	self = (NetworkWidgetsInfoBox*) g_object_new (object_type, "owner", owner, "device", _tmp1_, NULL);
	return self;
}

NetworkWidgetsInfoBox*
network_widgets_info_box_new_from_owner (NetworkWidgetsDeviceItem* owner)
{
	return network_widgets_info_box_construct_from_owner (NETWORK_WIDGETS_TYPE_INFO_BOX, owner);
}

void
network_widgets_info_box_update_activity (NetworkWidgetsInfoBox* self,
                                          const gchar* sent_bytes,
                                          const gchar* received_bytes)
{
	const gchar* _tmp0_ = NULL;
	GtkLabel* _tmp1_;
	const gchar* _tmp2_ = NULL;
	GtkLabel* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sent_bytes != NULL);
	g_return_if_fail (received_bytes != NULL);
	_tmp0_ = sent_bytes;
	if (_tmp0_ == NULL) {
		_tmp0_ = NETWORK_UNKNOWN_STR;
	}
	_tmp1_ = self->priv->sent;
	gtk_label_set_label (_tmp1_, _tmp0_);
	_tmp2_ = received_bytes;
	if (_tmp2_ == NULL) {
		_tmp2_ = NETWORK_UNKNOWN_STR;
	}
	_tmp3_ = self->priv->received;
	gtk_label_set_label (_tmp3_, _tmp2_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = (gint) self->len;
	return result;
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
	if (length >= 0) {
		gchar** result;
		gssize i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
	g_atomic_int_inc (&_data10_->_ref_count_);
	return _data10_;
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
		NetworkWidgetsInfoBox* self;
		self = _data10_->self;
		_g_ptr_array_unref0 (_data10_->addresses);
		_g_object_unref0 (self);
		g_slice_free (Block10Data, _data10_);
	}
}

static gpointer
_g_ptr_array_ref0 (gpointer self)
{
	return self ? g_ptr_array_ref (self) : NULL;
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

static void
___lambda7_ (Block10Data* _data10_,
             NMIPAddress* addr)
{
	NetworkWidgetsInfoBox* self;
	gchar* inet_str = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GPtrArray* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	gint _tmp28_;
	self = _data10_->self;
	g_return_if_fail (addr != NULL);
	nm_ip_address_ref (addr);
	_tmp0_ = nm_ip_address_get_address (addr);
	_tmp1_ = g_strconcat (_tmp0_, "/", NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup_printf ("%u", nm_ip_address_get_prefix (addr));
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp2_, _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	inet_str = _tmp6_;
	_tmp7_ = self->priv->ip6address;
	_tmp8_ = self->priv->ip6address_head;
	_tmp9_ = inet_str;
	_tmp10_ = string_strip (_tmp9_);
	_tmp11_ = _tmp10_;
	gtk_widget_set_visible ((GtkWidget*) _tmp8_, g_strcmp0 (_tmp11_, "") != 0);
	gtk_widget_set_visible ((GtkWidget*) _tmp7_, g_strcmp0 (_tmp11_, "") != 0);
	_g_free0 (_tmp11_);
	_tmp12_ = self->priv->ip6address;
	_tmp13_ = self->priv->ip6address;
	_tmp14_ = gtk_label_get_label (_tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = inet_str;
	_tmp17_ = g_strconcat (_tmp15_, _tmp16_, NULL);
	_tmp18_ = _tmp17_;
	gtk_label_set_label (_tmp13_, _tmp18_);
	_g_free0 (_tmp18_);
	_tmp19_ = _data10_->addresses;
	_tmp20_ = vala_g_ptr_array_get_length (_tmp19_);
	_tmp21_ = _tmp20_;
	if (_data10_->i < _tmp21_) {
		GtkLabel* _tmp22_;
		GtkLabel* _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		_tmp22_ = self->priv->ip6address;
		_tmp23_ = self->priv->ip6address;
		_tmp24_ = gtk_label_get_label (_tmp23_);
		_tmp25_ = _tmp24_;
		_tmp26_ = g_strconcat (_tmp25_, "\n", NULL);
		_tmp27_ = _tmp26_;
		gtk_label_set_label (_tmp23_, _tmp27_);
		_g_free0 (_tmp27_);
	}
	_tmp28_ = _data10_->i;
	_data10_->i = _tmp28_ + 1;
	_g_free0 (inet_str);
}

static void
____lambda7__gfunc (gconstpointer data,
                    gpointer self)
{
	___lambda7_ (self, (NMIPAddress*) data);
}

void
network_widgets_info_box_update_status (NetworkWidgetsInfoBox* self)
{
	NMIPConfig* ipv4 = NULL;
	NMDevice* _tmp0_;
	NMIPConfig* _tmp1_;
	NMIPConfig* _tmp2_;
	NMIPConfig* _tmp3_;
	NMIPConfig* ip6 = NULL;
	NMDevice* _tmp51_;
	NMIPConfig* _tmp52_;
	NMIPConfig* _tmp53_;
	GtkLabel* _tmp54_;
	GtkLabel* _tmp55_;
	NMIPConfig* _tmp56_;
	GtkLabel* _tmp57_;
	NMIPConfig* _tmp58_;
	NetworkWidgetsDeviceItem* _tmp63_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_device;
	_tmp1_ = nm_device_get_ip4_config (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	ipv4 = _tmp2_;
	_tmp3_ = ipv4;
	if (_tmp3_ != NULL) {
		NMIPConfig* _tmp4_;
		GPtrArray* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		const gchar* _tmp19_ = NULL;
		NMIPConfig* _tmp20_;
		const gchar* _tmp21_;
		GtkLabel* _tmp22_;
		GtkLabel* _tmp23_;
		NMIPConfig* _tmp24_;
		gchar** _tmp25_;
		gchar** _tmp26_;
		_tmp4_ = ipv4;
		_tmp5_ = nm_ip_config_get_addresses (_tmp4_);
		_tmp6_ = vala_g_ptr_array_get_length (_tmp5_);
		_tmp7_ = _tmp6_;
		if (_tmp7_ > 0) {
			NMIPAddress* address = NULL;
			NMIPConfig* _tmp8_;
			GPtrArray* _tmp9_;
			gconstpointer _tmp10_;
			GtkLabel* _tmp11_;
			NMIPAddress* _tmp12_;
			const gchar* _tmp13_;
			guint32 mask_addr = 0U;
			NMIPAddress* _tmp14_;
			struct in_addr source_addr = {0};
			struct in_addr _tmp15_ = {0};
			const gchar* _tmp16_ = NULL;
			const gchar* _tmp17_;
			GtkLabel* _tmp18_;
			_tmp8_ = ipv4;
			_tmp9_ = nm_ip_config_get_addresses (_tmp8_);
			_tmp10_ = g_ptr_array_index (_tmp9_, (guint) 0);
			address = (NMIPAddress*) _tmp10_;
			_tmp11_ = self->priv->ip4address;
			_tmp12_ = address;
			_tmp13_ = nm_ip_address_get_address (_tmp12_);
			gtk_label_set_label (_tmp11_, _tmp13_);
			_tmp14_ = address;
			mask_addr = htonl (((guint32) 0xffffffffLL) << (32 - nm_ip_address_get_prefix (_tmp14_)));
			memset (&_tmp15_, 0, sizeof (struct in_addr));
			_tmp15_.s_addr = mask_addr;
			source_addr = _tmp15_;
			_tmp17_ = inet_ntoa (source_addr);
			_tmp16_ = _tmp17_;
			if (_tmp16_ == NULL) {
				_tmp16_ = NETWORK_UNKNOWN_STR;
			}
			_tmp18_ = self->priv->mask;
			gtk_label_set_label (_tmp18_, _tmp16_);
			 (source_addr);
		}
		_tmp20_ = ipv4;
		_tmp21_ = nm_ip_config_get_gateway (_tmp20_);
		_tmp19_ = _tmp21_;
		if (_tmp19_ == NULL) {
			_tmp19_ = NETWORK_UNKNOWN_STR;
		}
		_tmp22_ = self->priv->router;
		gtk_label_set_label (_tmp22_, _tmp19_);
		_tmp23_ = self->priv->dns;
		gtk_label_set_label (_tmp23_, "");
		_tmp24_ = ipv4;
		_tmp26_ = _tmp25_ = nm_ip_config_get_nameservers (_tmp24_);
		if (_vala_array_length (_tmp25_) > 0) {
			gchar** dns_addr = NULL;
			NMIPConfig* _tmp27_;
			gchar** _tmp28_;
			gchar** _tmp29_;
			gchar** _tmp30_;
			gint _tmp30__length1;
			gint dns_addr_length1;
			gint _dns_addr_size_;
			GtkLabel* _tmp31_;
			gchar** _tmp32_;
			gint _tmp32__length1;
			const gchar* _tmp33_;
			_tmp27_ = ipv4;
			_tmp29_ = _tmp28_ = nm_ip_config_get_nameservers (_tmp27_);
			_tmp30_ = (_tmp29_ != NULL) ? _vala_array_dup1 (_tmp29_, _vala_array_length (_tmp28_)) : _tmp29_;
			_tmp30__length1 = _vala_array_length (_tmp28_);
			dns_addr = _tmp30_;
			dns_addr_length1 = _tmp30__length1;
			_dns_addr_size_ = dns_addr_length1;
			_tmp31_ = self->priv->dns;
			_tmp32_ = dns_addr;
			_tmp32__length1 = dns_addr_length1;
			_tmp33_ = _tmp32_[0];
			gtk_label_set_label (_tmp31_, _tmp33_);
			{
				gint i = 0;
				i = 1;
				{
					gboolean _tmp34_ = FALSE;
					_tmp34_ = TRUE;
					while (TRUE) {
						gchar** _tmp36_;
						gint _tmp36__length1;
						GtkLabel* _tmp37_;
						GtkLabel* _tmp38_;
						const gchar* _tmp39_;
						const gchar* _tmp40_;
						gchar* _tmp41_;
						gchar* _tmp42_;
						gchar** _tmp43_;
						gint _tmp43__length1;
						const gchar* _tmp44_;
						gchar* _tmp45_;
						gchar* _tmp46_;
						if (!_tmp34_) {
							gint _tmp35_;
							_tmp35_ = i;
							i = _tmp35_ + 1;
						}
						_tmp34_ = FALSE;
						_tmp36_ = dns_addr;
						_tmp36__length1 = dns_addr_length1;
						if (!(i < _tmp36__length1)) {
							break;
						}
						_tmp37_ = self->priv->dns;
						_tmp38_ = self->priv->dns;
						_tmp39_ = gtk_label_get_label (_tmp38_);
						_tmp40_ = _tmp39_;
						_tmp41_ = g_strconcat (_tmp40_, ", ", NULL);
						_tmp42_ = _tmp41_;
						_tmp43_ = dns_addr;
						_tmp43__length1 = dns_addr_length1;
						_tmp44_ = _tmp43_[i];
						_tmp45_ = g_strconcat (_tmp42_, _tmp44_, NULL);
						_tmp46_ = _tmp45_;
						gtk_label_set_label (_tmp37_, _tmp46_);
						_g_free0 (_tmp46_);
						_g_free0 (_tmp42_);
					}
				}
			}
			dns_addr = (_vala_array_free (dns_addr, dns_addr_length1, (GDestroyNotify) g_free), NULL);
		}
	} else {
		GtkLabel* _tmp47_;
		GtkLabel* _tmp48_;
		GtkLabel* _tmp49_;
		GtkLabel* _tmp50_;
		_tmp47_ = self->priv->ip4address;
		gtk_label_set_label (_tmp47_, NETWORK_UNKNOWN_STR);
		_tmp48_ = self->priv->mask;
		gtk_label_set_label (_tmp48_, NETWORK_UNKNOWN_STR);
		_tmp49_ = self->priv->router;
		gtk_label_set_label (_tmp49_, NETWORK_UNKNOWN_STR);
		_tmp50_ = self->priv->dns;
		gtk_label_set_label (_tmp50_, NETWORK_UNKNOWN_STR);
	}
	_tmp51_ = self->priv->_device;
	_tmp52_ = nm_device_get_ip6_config (_tmp51_);
	_tmp53_ = _g_object_ref0 (_tmp52_);
	ip6 = _tmp53_;
	_tmp54_ = self->priv->ip6address;
	_tmp55_ = self->priv->ip6address_head;
	_tmp56_ = ip6;
	gtk_widget_set_visible ((GtkWidget*) _tmp55_, _tmp56_ != NULL);
	gtk_widget_set_visible ((GtkWidget*) _tmp54_, _tmp56_ != NULL);
	_tmp57_ = self->priv->ip6address;
	gtk_label_set_label (_tmp57_, "");
	_tmp58_ = ip6;
	if (_tmp58_ != NULL) {
		Block10Data* _data10_;
		NMIPConfig* _tmp59_;
		GPtrArray* _tmp60_;
		GPtrArray* _tmp61_;
		GPtrArray* _tmp62_;
		_data10_ = g_slice_new0 (Block10Data);
		_data10_->_ref_count_ = 1;
		_data10_->self = g_object_ref (self);
		_data10_->i = 1;
		_tmp59_ = ip6;
		_tmp60_ = nm_ip_config_get_addresses (_tmp59_);
		_tmp61_ = _g_ptr_array_ref0 (_tmp60_);
		_data10_->addresses = _tmp61_;
		_tmp62_ = _data10_->addresses;
		g_ptr_array_foreach (_tmp62_, ____lambda7__gfunc, _data10_);
		block10_data_unref (_data10_);
		_data10_ = NULL;
	}
	_tmp63_ = self->priv->_owner;
	if (_tmp63_ != NULL) {
		NetworkWidgetsDeviceItem* _tmp64_;
		_tmp64_ = self->priv->_owner;
		g_signal_emit (self, network_widgets_info_box_signals[NETWORK_WIDGETS_INFO_BOX_UPDATE_SIDEBAR_SIGNAL], 0, _tmp64_);
	}
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (ip6);
	_g_object_unref0 (ipv4);
}

NetworkWidgetsInfoBox*
network_widgets_info_box_construct (GType object_type)
{
	NetworkWidgetsInfoBox * self = NULL;
	self = (NetworkWidgetsInfoBox*) g_object_new (object_type, NULL);
	return self;
}

NetworkWidgetsInfoBox*
network_widgets_info_box_new (void)
{
	return network_widgets_info_box_construct (NETWORK_WIDGETS_TYPE_INFO_BOX);
}

NMDevice*
network_widgets_info_box_get_device (NetworkWidgetsInfoBox* self)
{
	NMDevice* result;
	NMDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_device;
	result = _tmp0_;
	return result;
}

static void
network_widgets_info_box_set_device (NetworkWidgetsInfoBox* self,
                                     NMDevice* value)
{
	NMDevice* old_value;
	g_return_if_fail (self != NULL);
	old_value = network_widgets_info_box_get_device (self);
	if (old_value != value) {
		NMDevice* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_device);
		self->priv->_device = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, network_widgets_info_box_properties[NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY]);
	}
}

NetworkWidgetsDeviceItem*
network_widgets_info_box_get_owner (NetworkWidgetsInfoBox* self)
{
	NetworkWidgetsDeviceItem* result;
	NetworkWidgetsDeviceItem* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_owner;
	result = _tmp0_;
	return result;
}

static void
network_widgets_info_box_set_owner (NetworkWidgetsInfoBox* self,
                                    NetworkWidgetsDeviceItem* value)
{
	NetworkWidgetsDeviceItem* old_value;
	g_return_if_fail (self != NULL);
	old_value = network_widgets_info_box_get_owner (self);
	if (old_value != value) {
		NetworkWidgetsDeviceItem* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_owner);
		self->priv->_owner = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, network_widgets_info_box_properties[NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY]);
	}
}

static void
_network_widgets_info_box___lambda8_ (NetworkWidgetsInfoBox* self)
{
	network_widgets_info_box_update_status (self);
	g_signal_emit (self, network_widgets_info_box_signals[NETWORK_WIDGETS_INFO_BOX_INFO_CHANGED_SIGNAL], 0);
}

static void
__network_widgets_info_box___lambda8__nm_device_state_changed (NMDevice* _sender,
                                                               guint new_state,
                                                               guint old_state,
                                                               guint reason,
                                                               gpointer self)
{
	_network_widgets_info_box___lambda8_ ((NetworkWidgetsInfoBox*) self);
}

static GObject *
network_widgets_info_box_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkWidgetsInfoBox * self;
	GtkImage* sent_head = NULL;
	GtkImage* _tmp0_;
	GtkLabel* _tmp1_;
	GtkGrid* sent_grid = NULL;
	gchar* _tmp2_;
	GtkGrid* _tmp3_ = NULL;
	GtkGrid* _tmp4_;
	GtkImage* _tmp5_;
	GtkGrid* _tmp6_;
	GtkLabel* _tmp7_;
	GtkImage* received_head = NULL;
	GtkImage* _tmp8_;
	GtkLabel* _tmp9_;
	GtkGrid* received_grid = NULL;
	gchar* _tmp10_;
	GtkGrid* _tmp11_ = NULL;
	GtkGrid* _tmp12_;
	GtkImage* _tmp13_;
	GtkGrid* _tmp14_;
	GtkLabel* _tmp15_;
	GtkGrid* send_receive_grid = NULL;
	GtkGrid* _tmp16_ = NULL;
	GtkGrid* _tmp17_;
	GtkGrid* _tmp18_;
	GtkGrid* _tmp19_;
	GtkGrid* _tmp20_;
	GtkLabel* ip4address_head = NULL;
	GtkLabel* _tmp21_ = NULL;
	GtkLabel* _tmp22_ = NULL;
	GtkLabel* _tmp23_ = NULL;
	GtkLabel* _tmp24_ = NULL;
	GtkLabel* mask_head = NULL;
	GtkLabel* _tmp25_ = NULL;
	GtkLabel* _tmp26_ = NULL;
	GtkLabel* router_head = NULL;
	GtkLabel* _tmp27_ = NULL;
	GtkLabel* _tmp28_ = NULL;
	GtkLabel* dns_head = NULL;
	GtkLabel* _tmp29_ = NULL;
	GtkLabel* _tmp30_ = NULL;
	GtkLabel* _tmp31_;
	GtkLabel* _tmp32_;
	GtkLabel* _tmp33_;
	GtkLabel* _tmp34_;
	GtkLabel* _tmp35_;
	GtkLabel* _tmp36_;
	GtkLabel* _tmp37_;
	GtkLabel* _tmp38_;
	GtkLabel* _tmp39_;
	GtkLabel* _tmp40_;
	GtkLabel* _tmp41_;
	GtkLabel* _tmp42_;
	GtkLabel* _tmp43_;
	GtkLabel* _tmp44_;
	GtkLabel* _tmp45_;
	GtkLabel* _tmp46_;
	GtkLabel* _tmp47_;
	GtkLabel* _tmp48_;
	GtkLabel* _tmp49_;
	GtkGrid* _tmp50_;
	GtkLabel* _tmp51_;
	NMDevice* _tmp52_;
	parent_class = G_OBJECT_CLASS (network_widgets_info_box_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBox);
	gtk_grid_set_column_spacing ((GtkGrid*) self, 12);
	gtk_grid_set_row_spacing ((GtkGrid*) self, 6);
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("go-up-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp0_);
	sent_head = _tmp0_;
	_tmp1_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->sent);
	self->priv->sent = _tmp1_;
	_tmp2_ = g_strdup (_ ("Sent"));
	_tmp3_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp3_, 12);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, _tmp2_);
	_g_free0 (_tmp2_);
	g_object_ref_sink (_tmp3_);
	sent_grid = _tmp3_;
	_tmp4_ = sent_grid;
	_tmp5_ = sent_head;
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) _tmp5_);
	_tmp6_ = sent_grid;
	_tmp7_ = self->priv->sent;
	gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
	_tmp8_ = (GtkImage*) gtk_image_new_from_icon_name ("go-down-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp8_);
	received_head = _tmp8_;
	_tmp9_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->received);
	self->priv->received = _tmp9_;
	_tmp10_ = g_strdup (_ ("Received"));
	_tmp11_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp11_, 12);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp11_, _tmp10_);
	_g_free0 (_tmp10_);
	g_object_ref_sink (_tmp11_);
	received_grid = _tmp11_;
	_tmp12_ = received_grid;
	_tmp13_ = received_head;
	gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) _tmp13_);
	_tmp14_ = received_grid;
	_tmp15_ = self->priv->received;
	gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
	_tmp16_ = (GtkGrid*) gtk_grid_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp16_, GTK_ALIGN_CENTER);
	gtk_grid_set_column_spacing (_tmp16_, 12);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp16_, 12);
	g_object_ref_sink (_tmp16_);
	send_receive_grid = _tmp16_;
	_tmp17_ = send_receive_grid;
	_tmp18_ = sent_grid;
	gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
	_tmp19_ = send_receive_grid;
	_tmp20_ = received_grid;
	gtk_container_add ((GtkContainer*) _tmp19_, (GtkWidget*) _tmp20_);
	_tmp21_ = (GtkLabel*) gtk_label_new (_ ("IP Address:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp21_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp21_);
	ip4address_head = _tmp21_;
	_tmp22_ = (GtkLabel*) gtk_label_new (NULL);
	gtk_label_set_selectable (_tmp22_, TRUE);
	gtk_label_set_xalign (_tmp22_, (gfloat) 0);
	g_object_ref_sink (_tmp22_);
	_g_object_unref0 (self->priv->ip4address);
	self->priv->ip4address = _tmp22_;
	_tmp23_ = (GtkLabel*) gtk_label_new (_ ("IPv6 Address:"));
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp23_, TRUE);
	gtk_widget_set_halign ((GtkWidget*) _tmp23_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp23_);
	_g_object_unref0 (self->priv->ip6address_head);
	self->priv->ip6address_head = _tmp23_;
	_tmp24_ = (GtkLabel*) gtk_label_new (NULL);
	gtk_label_set_selectable (_tmp24_, TRUE);
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp24_, TRUE);
	gtk_label_set_xalign (_tmp24_, (gfloat) 0);
	g_object_ref_sink (_tmp24_);
	_g_object_unref0 (self->priv->ip6address);
	self->priv->ip6address = _tmp24_;
	_tmp25_ = (GtkLabel*) gtk_label_new (_ ("Subnet mask:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp25_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp25_);
	mask_head = _tmp25_;
	_tmp26_ = (GtkLabel*) gtk_label_new (NULL);
	gtk_label_set_selectable (_tmp26_, TRUE);
	gtk_label_set_xalign (_tmp26_, (gfloat) 0);
	g_object_ref_sink (_tmp26_);
	_g_object_unref0 (self->priv->mask);
	self->priv->mask = _tmp26_;
	_tmp27_ = (GtkLabel*) gtk_label_new (_ ("Router:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp27_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp27_);
	router_head = _tmp27_;
	_tmp28_ = (GtkLabel*) gtk_label_new (NULL);
	gtk_label_set_selectable (_tmp28_, TRUE);
	gtk_label_set_xalign (_tmp28_, (gfloat) 0);
	g_object_ref_sink (_tmp28_);
	_g_object_unref0 (self->priv->router);
	self->priv->router = _tmp28_;
	_tmp29_ = (GtkLabel*) gtk_label_new (_ ("DNS:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp29_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp29_);
	dns_head = _tmp29_;
	_tmp30_ = (GtkLabel*) gtk_label_new (NULL);
	gtk_label_set_selectable (_tmp30_, TRUE);
	gtk_label_set_xalign (_tmp30_, (gfloat) 0);
	g_object_ref_sink (_tmp30_);
	_g_object_unref0 (self->priv->dns);
	self->priv->dns = _tmp30_;
	_tmp31_ = ip4address_head;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp31_, 0, 0, 1, 1);
	_tmp32_ = self->priv->ip4address;
	_tmp33_ = ip4address_head;
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp32_, (GtkWidget*) _tmp33_, GTK_POS_RIGHT, 1, 1);
	_tmp34_ = self->priv->ip6address_head;
	_tmp35_ = ip4address_head;
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp34_, (GtkWidget*) _tmp35_, GTK_POS_BOTTOM, 1, 1);
	_tmp36_ = self->priv->ip6address;
	_tmp37_ = self->priv->ip6address_head;
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp36_, (GtkWidget*) _tmp37_, GTK_POS_RIGHT, 1, 1);
	_tmp38_ = mask_head;
	_tmp39_ = self->priv->ip6address_head;
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp38_, (GtkWidget*) _tmp39_, GTK_POS_BOTTOM, 1, 1);
	_tmp40_ = self->priv->mask;
	_tmp41_ = mask_head;
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp40_, (GtkWidget*) _tmp41_, GTK_POS_RIGHT, 1, 1);
	_tmp42_ = router_head;
	_tmp43_ = mask_head;
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp42_, (GtkWidget*) _tmp43_, GTK_POS_BOTTOM, 1, 1);
	_tmp44_ = self->priv->router;
	_tmp45_ = router_head;
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp44_, (GtkWidget*) _tmp45_, GTK_POS_RIGHT, 1, 1);
	_tmp46_ = dns_head;
	_tmp47_ = router_head;
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp46_, (GtkWidget*) _tmp47_, GTK_POS_BOTTOM, 1, 1);
	_tmp48_ = self->priv->dns;
	_tmp49_ = dns_head;
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp48_, (GtkWidget*) _tmp49_, GTK_POS_RIGHT, 1, 1);
	_tmp50_ = send_receive_grid;
	_tmp51_ = dns_head;
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp50_, (GtkWidget*) _tmp51_, GTK_POS_BOTTOM, 4, 1);
	_tmp52_ = self->priv->_device;
	g_signal_connect_object (_tmp52_, "state-changed", (GCallback) __network_widgets_info_box___lambda8__nm_device_state_changed, self, 0);
	network_widgets_info_box_update_status (self);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (dns_head);
	_g_object_unref0 (router_head);
	_g_object_unref0 (mask_head);
	_g_object_unref0 (ip4address_head);
	_g_object_unref0 (send_receive_grid);
	_g_object_unref0 (received_grid);
	_g_object_unref0 (received_head);
	_g_object_unref0 (sent_grid);
	_g_object_unref0 (sent_head);
	return obj;
}

static void
network_widgets_info_box_class_init (NetworkWidgetsInfoBoxClass * klass,
                                     gpointer klass_data)
{
	network_widgets_info_box_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NetworkWidgetsInfoBox_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_network_widgets_info_box_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_network_widgets_info_box_set_property;
	G_OBJECT_CLASS (klass)->constructor = network_widgets_info_box_constructor;
	G_OBJECT_CLASS (klass)->finalize = network_widgets_info_box_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY, network_widgets_info_box_properties[NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", nm_device_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY, network_widgets_info_box_properties[NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY] = g_param_spec_object ("owner", "owner", "owner", NETWORK_WIDGETS_TYPE_DEVICE_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	network_widgets_info_box_signals[NETWORK_WIDGETS_INFO_BOX_UPDATE_SIDEBAR_SIGNAL] = g_signal_new ("update-sidebar", NETWORK_WIDGETS_TYPE_INFO_BOX, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NETWORK_WIDGETS_TYPE_DEVICE_ITEM);
	network_widgets_info_box_signals[NETWORK_WIDGETS_INFO_BOX_INFO_CHANGED_SIGNAL] = g_signal_new ("info-changed", NETWORK_WIDGETS_TYPE_INFO_BOX, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
network_widgets_info_box_instance_init (NetworkWidgetsInfoBox * self,
                                        gpointer klass)
{
	self->priv = network_widgets_info_box_get_instance_private (self);
}

static void
network_widgets_info_box_finalize (GObject * obj)
{
	NetworkWidgetsInfoBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBox);
	_g_object_unref0 (self->priv->_device);
	_g_object_unref0 (self->priv->_owner);
	_g_object_unref0 (self->priv->ip4address);
	_g_object_unref0 (self->priv->ip6address);
	_g_object_unref0 (self->priv->mask);
	_g_object_unref0 (self->priv->router);
	_g_object_unref0 (self->priv->dns);
	_g_object_unref0 (self->priv->sent);
	_g_object_unref0 (self->priv->received);
	_g_object_unref0 (self->priv->ip6address_head);
	G_OBJECT_CLASS (network_widgets_info_box_parent_class)->finalize (obj);
}

static GType
network_widgets_info_box_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkWidgetsInfoBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_widgets_info_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWidgetsInfoBox), 0, (GInstanceInitFunc) network_widgets_info_box_instance_init, NULL };
	GType network_widgets_info_box_type_id;
	network_widgets_info_box_type_id = g_type_register_static (gtk_grid_get_type (), "NetworkWidgetsInfoBox", &g_define_type_info, 0);
	NetworkWidgetsInfoBox_private_offset = g_type_add_instance_private (network_widgets_info_box_type_id, sizeof (NetworkWidgetsInfoBoxPrivate));
	return network_widgets_info_box_type_id;
}

GType
network_widgets_info_box_get_type (void)
{
	static volatile gsize network_widgets_info_box_type_id__once = 0;
	if (g_once_init_enter (&network_widgets_info_box_type_id__once)) {
		GType network_widgets_info_box_type_id;
		network_widgets_info_box_type_id = network_widgets_info_box_get_type_once ();
		g_once_init_leave (&network_widgets_info_box_type_id__once, network_widgets_info_box_type_id);
	}
	return network_widgets_info_box_type_id__once;
}

static void
_vala_network_widgets_info_box_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	NetworkWidgetsInfoBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBox);
	switch (property_id) {
		case NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY:
		g_value_set_object (value, network_widgets_info_box_get_device (self));
		break;
		case NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY:
		g_value_set_object (value, network_widgets_info_box_get_owner (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_network_widgets_info_box_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	NetworkWidgetsInfoBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBox);
	switch (property_id) {
		case NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY:
		network_widgets_info_box_set_device (self, g_value_get_object (value));
		break;
		case NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY:
		network_widgets_info_box_set_owner (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

